﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getDefinitionByName;	
	import flash.utils.getQualifiedClassName;
	import flash.media.Sound;
	import flash.media.SoundTransform;	
	
	public class Animation extends MovieClip{
		private var aniStorageArray:Array;//Parameter'ed array from outside of class so garbage collector won't collect
		
		private var mC:MovieClip;
		private var startFrameLabel:String;
		private var endFrameLabel:String;
//		private var timeBtwFrames:uint;
		private var duration:uint;
		private var currentTimeFunc:Function;		
		private var loopNum:int;
		private var currentLoopNum:int;
		private var completionRemovalOn:Boolean = false;
		
		private var startFrameNum:int;
		private var endFrameNum:int;
		private var numFrames:int;
		
		private var aniComplete:Boolean;
		private var endFunc:Function = null;//Used at end of aniComplete (i.e. setGameRunSpeed for chain)
		
		private var aniOn:Boolean = true;
		private var aniEventOn:Boolean = false;//Shows if the main event is runnning
		
		private var aniSeqOn:Boolean = false;
		private var aniSeqInnerOn:Boolean = false;//true=changeAni func was called from a seq, not from outside
		private var aniSeqNum:uint = 0;
		private var aniSeqArray:Array;
		
		private var aniLockOn:Boolean = false;//true=prevents any change to ani
		
		private var aniSoundArray:Array = null;
		private var soundEffect:SoundEffect;
		private var echoOn:Boolean = false;
		private var echoInterval:uint = 400;//Amount of time b/t each echo
		private var echoAmount:uint = 3;//Number of echos
		private var echoReduction:Number = .6;//Each subsequent echo is ~ of previous echo volume
		private var singleSoundOn:Boolean = false;
		private var sound:Sound;
		
		private var resetOn:Boolean = false;//Allow changeAni to begin even if it's the same animation (one time)

		//Replacing a child MC
		private var classNameToReplace:String = null;
		private var replacementMC:DisplayObject = null;
		private var replaceGraphicOn:Boolean = false;
		
		private var percComplete:Number = 0;
		private var lastTimeAnim:uint;
		private var lastTimeStart:uint;
		
		private var _tier:uint=0;
		
		public function Animation(pAniStorageArray:Array){
			aniStorageArray = pAniStorageArray;
			aniStorageArray.push(this);
		}
		
//		public function Animation(pMC:MovieClip, pStartFrameLabel:String, pEndFrameLabel:String, pDuration:uint, pCurrentTimeFunc:Function, pLoopNum:uint, pAniSoundArray:Array){
//			mC = pMC;
//			startFrameLabel = pStartFrameLabel;
//			endFrameLabel = pEndFrameLabel;
//			duration = pDuration;
//			currentTimeFunc = pCurrentTimeFunc;
//			loopNum = pLoopNum;
//			currentLoopNum = loopNum;
//			setAniSound(pAniSoundArray);
//			
//			aniComplete = false;
//			
//			var fCrntLbls:Array = pMC.currentLabels;//An array of all the frame labels (in the form of FrameLabel objects) in the currentGraphic MovieClip
//			for(var i:uint=0; i<fCrntLbls.length; i++){//Get the number of frames for the animation
//				if(fCrntLbls[i].name == pStartFrameLabel){//If the FrameLabel matches the start frame label from the skill
//					startFrameNum = fCrntLbls[i].frame;//get the start frame number
//				}
//				if(fCrntLbls[i].name == pEndFrameLabel){//If the FrameLabel matches the end frame label from the skill
//					endFrameNum = fCrntLbls[i].frame;//get the end frame number
//				}
//			}
//			numFrames = endFrameNum-startFrameNum;//Amount of time between frames so that the animation ends when the casting ends
//			
//			pMC.gotoAndStop(startFrameNum);
//			
//			lastTimeAnim = pCurrentTimeFunc.call();
//			lastTimeStart = pCurrentTimeFunc.call();
//			addEventListener(Event.ENTER_FRAME, startAnimation);
//			aniEventOn = true;
//		}
		private function startAnimationEvent(event:Event){
			startAnimation();
		}
		private function playAllChildren(pMC:MovieClip, pFramesMoved:int){//Also in BarPanel Class
			for(var i:uint=0;i<pMC.numChildren;i++){
				if(pMC.getChildAt(i) is MovieClip){
					if(MovieClip(pMC.getChildAt(i)).totalFrames>1){
						var fNextFrameNum:uint;
						if(pFramesMoved>0){
							if(MovieClip(pMC.getChildAt(i)).currentFrame+pFramesMoved <= MovieClip(pMC.getChildAt(i)).totalFrames){
								fNextFrameNum = MovieClip(pMC.getChildAt(i)).currentFrame + pFramesMoved;
							}
							else{
								
								fNextFrameNum = MovieClip(pMC.getChildAt(i)).currentFrame+pFramesMoved-MovieClip(pMC.getChildAt(i)).totalFrames;
							}
							MovieClip(pMC.getChildAt(i)).gotoAndStop(fNextFrameNum);
						}
						else if(pFramesMoved<0){
							if(MovieClip(pMC.getChildAt(i)).currentFrame+pFramesMoved >= 1){
								fNextFrameNum = MovieClip(pMC.getChildAt(i)).currentFrame + pFramesMoved;
							}
							else{
								fNextFrameNum = MovieClip(pMC.getChildAt(i)).totalFrames+MovieClip(pMC.getChildAt(i)).currentFrame+pFramesMoved;
							}
							MovieClip(pMC.getChildAt(i)).gotoAndStop(fNextFrameNum);
						}						
					}
				}
			}
		}
		//private var framesMoved:int = 0;//Used for playAllChildren only so that it know how many frames to move
		private function startAnimation(){
			if(aniOn){				
				if(mC!=null && duration>0){
					var fFramesMoved:int;
					var fTimePassed:uint = currentTimeFunc()-lastTimeAnim;
					lastTimeAnim+=fTimePassed;
					var fPercComplete:Number;
					var fProjectedFrame:int=0;
					//******************INFINITE ANIMATION************
					if(loopNum==0){
						fPercComplete = fTimePassed/duration;
						percComplete+=fPercComplete;
						if(numFrames>=0){//If animating forwards
							fProjectedFrame = startFrameNum+Math.floor(percComplete*(numFrames+1));
						}
						else{//If animating backwards
							fProjectedFrame = startFrameNum+Math.ceil(percComplete*(numFrames-1));
						}
						fFramesMoved = fProjectedFrame - mC.currentFrame;
						playAllChildren(mC, fFramesMoved);
//						if(mC.parent is Player){
//							if(Player(mC.parent).getPlayerName()=="Cat"){
//								trace(fPercComplete);
//							}
//						}
						if(percComplete<1){
							mC.gotoAndStop(fProjectedFrame);
							if(aniSoundArray!=null){
								playAniSound(aniSoundArray);
							}
							//changeFrame(fProjectedFrame,startFrameNum,endFrameNum,numFrames>=0);
						}
						else{//Animation completed, so repeat
							percComplete -= Math.floor(percComplete);//Find the projected frame with excess time
							if(numFrames>=0){//If animating fowards
								fProjectedFrame = startFrameNum+Math.floor(percComplete*(numFrames+1));
							}
							else{//If animating backwards
								fProjectedFrame = startFrameNum+Math.ceil(percComplete*(numFrames-1));
							}
							mC.gotoAndStop(fProjectedFrame);
							if(aniSoundArray!=null){
								resetAniSound(aniSoundArray);
							}
						}
					}
					//*******************FINITE ANIMATION*************
					else{
						fPercComplete = fTimePassed/(duration/loopNum);
						percComplete+=fPercComplete;
						if(numFrames>=0){//If animating fowards
							fProjectedFrame = startFrameNum+Math.floor(percComplete*(numFrames+1));
						}
						else{//If animating backwards
							fProjectedFrame = startFrameNum+Math.ceil(percComplete*(numFrames-1));
						}
						fFramesMoved = fProjectedFrame - mC.currentFrame;
						playAllChildren(mC, fFramesMoved);
						if(percComplete<1){//Ani has not completed
							mC.gotoAndStop(fProjectedFrame);
							//mC.gotoAndStop(fProjectedFrame);
							if(aniSoundArray!=null){
								playAniSound(aniSoundArray);
							}
						}
						else{//Ani has completed
							mC.gotoAndStop(endFrameNum);
							currentLoopNum -= Math.floor(percComplete);
							if(currentLoopNum>0){//Loops go backwards in counting								
								percComplete -= Math.floor(percComplete);
								if(numFrames>=0){//If animating fowards
									fProjectedFrame = startFrameNum+Math.floor(percComplete*(numFrames+1));
								}
								else{//If animating backwards
									fProjectedFrame = startFrameNum+Math.ceil(percComplete*(numFrames-1));
								}
								mC.gotoAndStop(fProjectedFrame);
								if(aniSoundArray!=null){
									resetAniSound(aniSoundArray);
								}
							}
							else{//If no more loops, end (static animation) or play next seq
								if(aniSeqOn){//Seq only exists in finite animation
									//*NOT USED ANYMORE* Used to save old perc value to sync transition from previous animation for overflow
									//var fOldPercComplete:Number = percComplete.valueOf();
									//% converted to time past the goal duration
									var fOldTimeOver:Number = (percComplete-(-currentLoopNum+1))*(duration/loopNum);
									if(playSeq()){
										if(loopNum==0){//Infinite Loop
											percComplete = fOldTimeOver/duration;
										}
										else{//Finite Loop											
											percComplete = fOldTimeOver/(duration/loopNum);
										}
										if(numFrames>=0){//If animating fowards
											fProjectedFrame = startFrameNum+Math.floor(percComplete*(numFrames+1));
										}
										else{//If animating backwards
											fProjectedFrame = startFrameNum+Math.ceil(percComplete*(numFrames-1));
										}										
										mC.gotoAndStop(fProjectedFrame);
										//if(aniSoundArray!=null){
											//resetAniSound(aniSoundArray);
										//}
									}
								}
								aniComplete = true;
							}
						}
					}
					//******************REPLACE GRAPHIC**************************
					if(replaceGraphicOn && classNameToReplace!=null && replacementMC!=null){
						replaceGraphic();
					}
					//******************ANI DURATION REMOVE**********************
					if(completionRemovalOn){
						if(lastTimeAnim-lastTimeStart > duration){
							ArrayHelper.findAndRemove(aniStorageArray, this, 1);
							if(mC.parent != null){
//								if(mC.parent is Player){
//									Player(mC.parent).removeFromFXArray(mC);
//								}
								mC.parent.removeChild(mC);
							}
							if(endFunc!=null){
								endFunc();
							}
							aniComplete = true;
							removeEventListener(Event.ENTER_FRAME, startAnimationEvent);
							aniEventOn = false;
						}
					}
				}
				else{
					removeEventListener(Event.ENTER_FRAME, startAnimationEvent);
					aniEventOn = false;
				}
			}
		}
		public function changeFrame(pFrame:Object,pStartFrame:Number,pEndFrame:Number,pForwardOn:Boolean){
			var i:uint=0;
			if(pFrame is String){
				var fCrntLbls:Array = mC.currentLabels;//An array of all the frame labels (in the form of FrameLabel objects) in the currentGraphic MovieClip
				for(i=0; i<fCrntLbls.length; i++){//Get the number of frames for the animation
					if(fCrntLbls[i].name == pFrame){//If the FrameLabel matches the start frame label from the skill
						pFrame = fCrntLbls[i].frame;//get the start frame number
					}
				}
				if(!(pFrame is Number)){
					return;
				}
			}
			if(pFrame is Number){
				var fFrameDif:Number = Number(pFrame)-mC.currentFrame;
				var fFrameArray:Array = new Array(0);
				var fFrameNumOf:Number = 0;
				if(pForwardOn){
					if(mC.currentFrame>Number(pFrame)){//Wrap Around
						fFrameNumOf = pEndFrame-mC.currentFrame + Number(pFrame)-pStartFrame + 1;
					}
					else{//Normal
						fFrameNumOf = Number(pFrame)-mC.currentFrame;
					}
					for(i=0; i<fFrameNumOf; i++){
						if(mC.currentFrame==pEndFrame){//Wrap Around
							mC.gotoAndStop(pStartFrame);
						}
						else{
							mC.gotoAndStop(mC.currentFrame+1);
						}
					}
				}
				else{//Play Backwards
					if(mC.currentFrame<Number(pFrame)){//Wrap Around
						fFrameNumOf = mC.currentFrame-pEndFrame + pStartFrame-Number(pFrame) + 1;
					}
					else{//Normal
						fFrameNumOf = mC.currentFrame-Number(pFrame);
					}
					for(i=0; i<fFrameNumOf; i++){
						if(mC.currentFrame==pEndFrame){//Wrap Around
							mC.gotoAndStop(pStartFrame);
						}
						else{
							mC.gotoAndStop(mC.currentFrame-1);
						}
					}
				}
			}
		}
		public function changeAni(pMC:MovieClip, pStartFrameLabel:String, pEndFrameLabel:String, pDuration:uint, pCurrentTimeFunc:Function, pLoopNum:uint, pAniSoundArray:Array):Boolean{
//			if(pMC.parent is Player){//This will also cause other attached MC's to trace (dustclouds, etc.)
//				if(Player(pMC.parent).getPlayerName()=="Cat"){
//					trace(pStartFrameLabel);
//				}
//			}
			if(!aniLockOn){
				if((!(mC==pMC && startFrameLabel==pStartFrameLabel && endFrameLabel == pEndFrameLabel && pDuration==duration && currentTimeFunc == pCurrentTimeFunc && loopNum == pLoopNum && aniSoundArray==pAniSoundArray))
					|| resetOn){//Don't let the same animation be activated twice
					resetOn = false;
					var allLabels:Array = pMC.currentLabels;
					for(var i:uint=0; i<allLabels.length; i++){//Check if label name exists
						if(allLabels[i].name == pStartFrameLabel){
//							if(pMC.parent is Player){//This will also cause other attached MC's to trace (dustclouds, etc.)
//								if(Player(pMC.parent).getPlayerName()=="Mama Cat"){
//									trace(pStartFrameLabel);
//								}
//							}
							aniOn = true;
							if(!aniSeqInnerOn){
								aniSeqOn = false;
								aniSeqNum = 0;
							}
							aniSeqInnerOn = false;
							if(aniSoundArray!=null){
								//resetAniSound(aniSoundArray);
							}
							if(aniEventOn){
								removeEventListener(Event.ENTER_FRAME, startAnimationEvent);
							}
							mC = pMC;
							startFrameLabel = pStartFrameLabel;
							endFrameLabel = pEndFrameLabel;
							duration = pDuration;
							currentTimeFunc = pCurrentTimeFunc;
							loopNum = pLoopNum;
							currentLoopNum = loopNum;
							setAniSound(pAniSoundArray);
							
							percComplete = 0;
							aniComplete = false;
							
							var fCrntLbls:Array = pMC.currentLabels;//An array of all the frame labels (in the form of FrameLabel objects) in the currentGraphic MovieClip
							for(i=0; i<fCrntLbls.length; i++){//Get the number of frames for the animation
								if(fCrntLbls[i].name == pStartFrameLabel){//If the FrameLabel matches the start frame label from the skill
									startFrameNum = fCrntLbls[i].frame;//get the start frame number
								}
								if(fCrntLbls[i].name == pEndFrameLabel){//If the FrameLabel matches the end frame label from the skill
									endFrameNum = fCrntLbls[i].frame;//get the end frame number
								}
							}
							numFrames = endFrameNum-startFrameNum;//Amount of time between frames so that the animation ends when the casting ends
							
							pMC.gotoAndStop(startFrameNum);
							
							//******************REPLACE GRAPHIC**************************
							if(replaceGraphicOn && classNameToReplace!=null && replacementMC!=null){
								replaceGraphic();
							}
							
							lastTimeAnim = pCurrentTimeFunc.call();
							lastTimeStart = pCurrentTimeFunc.call();
							
							addEventListener(Event.ENTER_FRAME, startAnimationEvent);
							aniEventOn = true;
							startAnimation();
							return true;//Animation exists
						}
					}				
				}
			}
			return false;//Animation doesn't exist			
		}
//		public function addSound(pSound:Sound){
//			pSound.play();
//		}
//		public function getTimeBtwFrames(){
//			return timeBtwFrames;
//		}
		public function setSeq(pArray:Array){
			if(pArray.length%7==0 && pArray.length>=7){
				stopAni();
				aniSeqInnerOn = false;
				aniSeqNum = 0;
				aniSeqOn = true;
				aniSeqArray = pArray;
			}
		}
		//change the durations of the animations so that they run smoothly within the 1st ([3]) duration's time
		public function setSeqProportionOn(){
			if(aniSeqArray!=null){
				if(aniSeqArray.length%7==0 && aniSeqArray.length>=7){
					//ProportionalTimeOn = change the durations of the animations so that they run smoothly within the 1st ([3]) duration's time
					var fTotalDuration:uint = aniSeqArray[3];
					var fTotalSeqNum:uint = aniSeqArray.length/7;
					var fEachDuration:uint = Math.round(fTotalDuration/fTotalSeqNum);
					for(var i:uint=0;i<aniSeqArray.length;i+=7){
						aniSeqArray[i+3]=fEachDuration;
					}
				}
			}
		}
		private var _repeatSeqOn:Boolean = false;
		public function get repeatSeqOn():Boolean{
			return _repeatSeqOn;
		}
		public function set repeatSeqOn(b:Boolean){
			_repeatSeqOn = b;
		}
		public function playSeq():Boolean{
			var i:uint = 7*aniSeqNum;
			if(!aniSeqInnerOn){
				if(aniSeqArray.length>i){
					//If animation exists
					if(aniSeqArray[i+3]==0){
						aniSeqNum++;
						return playSeq();
					}
					else{
						aniSeqInnerOn = true;
						setResetOn(true);//Allow the animation to play even if it is the same animation that is already playing
						if(changeAni(aniSeqArray[i],aniSeqArray[i+1],aniSeqArray[i+2],aniSeqArray[i+3],aniSeqArray[i+4],aniSeqArray[i+5],aniSeqArray[i+6])){
							aniSeqNum++;
							return true;
						}
					}
				}
				aniSeqNum = 0;
				if(_repeatSeqOn){
					aniSeqOn = true;
					aniSeqInnerOn = true;
					i=0;
					setResetOn(true);//Allow the animation to play even if it is the same animation that is already playing
					if(changeAni(aniSeqArray[i],aniSeqArray[i+1],aniSeqArray[i+2],aniSeqArray[i+3],aniSeqArray[i+4],aniSeqArray[i+5],aniSeqArray[i+6])){
						aniSeqNum++;
						return true;
					}
				}
				else{
					aniSeqInnerOn = false;
					aniSeqOn = false;
				}
			}
			return false;
		}
		public function setAniSound(pArray:Array){//ClassName,Frame# or Label,Vol,False(used for Animation Class to see if it played already)
			if(pArray!=null){//CONVERT FRAME LABEL TO FRAME NUMBER OF SOUND
				for(var j:uint=0; j<pArray.length;j+=4){
					pArray[j+3] = false;
					if(pArray[j+1] is String){
						var fFoundSndLabel:Boolean = false;
						for(var k:uint=0;k<mC.currentLabels.length;k++){
							if(pArray[j+1]==mC.currentLabels[k].name){
								pArray[j+1] = mC.currentLabels[k].frame;
								fFoundSndLabel = true;
								break;
							}
						}
						if(!fFoundSndLabel){//If SndLabel doesn't exist
							pArray[j+1] = null;//Don't play it
						}
					}
				}
				//resetAniSound(pArray);
			}
			aniSoundArray = pArray;			
		}
		private function playAniSound(pArray:Array){//[0]=SndName,[1]=Frame Lbl to play Snd,[2]=Vol,[3]=Snd Played(for Player internal use only, start with false)
//			if(Main.getMain().getSoundOn()){
//				if(pArray!=null){
//					for(var i:uint=0; i<pArray.length; i+=4){
//						if(pArray[i+1]!=null && pArray[i]!=null){
//							if(mC.currentFrame>=pArray[i+1] && !pArray[i+3]){//[i+1]==0 = play right from start
//								var pSoundEffect:SoundEffect = new SoundEffect(pArray[i],pArray[i+2],currentTimeFunc,Main.getMain().getGameSoundEffectArray());
//								pSoundEffect.startSoundEffect();
//								pArray[i+3] = true;
//							}
//						}
//					}
//				}
//			}
		}
		public function stopSoundEffect(){//Also used in Player's removeVariables to stop the sound when changing areas
			if(soundEffect!=null){
				soundEffect.stopSoundEffect();
				soundEffect.removeSoundEffect();
			}
		}
		public function setEchoOn(pEchoOn:Boolean, pEchoInterval:uint, pEchoAmount:uint, pEchoReduction:Number){
			echoOn = pEchoOn;
			echoInterval = pEchoInterval;
			echoAmount = pEchoAmount;
			echoReduction = pEchoReduction;
		}
		private function resetAniSound(pArray:Array){//Allows sound to be played again
			for(var i:uint=0; i<pArray.length; i+=4){
				pArray[i+3]=false;
			}
		}
		public function setReplaceGraphic(pClassNameToReplace:String, pReplacementMC:DisplayObject){
			classNameToReplace = pClassNameToReplace;
			replacementMC = pReplacementMC;
			replaceGraphicOn = true;
			replaceGraphic();
		}
		private function replaceGraphic(){
			var i:uint=0;
			var j:uint=0;
			for(i=0;i<mC.numChildren;i++){
				if(getQualifiedClassName(mC.getChildAt(i)) == classNameToReplace){
					var fReplacementAlreadyExists:Boolean = false;
					for(j=0;j<MovieClip(mC.getChildAt(i)).numChildren;j++){
						if(getQualifiedClassName(MovieClip(mC.getChildAt(i)).getChildAt(j))!=getQualifiedClassName(replacementMC)){
							MovieClip(mC.getChildAt(i)).removeChildAt(j);
						}
						else{
							fReplacementAlreadyExists = true;
						}
					}
					if(!fReplacementAlreadyExists){
						MovieClip(mC.getChildAt(i)).addChild(replacementMC);
					}
				}
			}
		} 
		public function testFrameLabel(pMC:MovieClip,pLabelName:String):Boolean{
			if(pMC!=null){
				var fArray:Array = pMC.currentLabels;
				for(var i:uint=0;i<fArray.length;i++){
					if(pLabelName==fArray[i].name){
						return true;
					}
				}
			}
			return false;
		}
		public function getMC():MovieClip{
			return mC;
		}
		public function setDuration(pDuration:uint){
			duration = pDuration;
		}
		public function getDuration():uint{
			return duration;
		}
		public function getAniName():String{
			return startFrameLabel;
		}
		public function getAniComplete():Boolean{
			return aniComplete;
		}
		public function setCompletionRemovalOn(b:Boolean){
			completionRemovalOn = b;
		}
		public function getAniOn():Boolean{
			return aniOn;
		}
		public function setAniOn(b:Boolean){
			aniOn = b;
		}
		public function setResetOn(b:Boolean){
			resetOn = b;
		}
		public function setSingleSoundOn(b:Boolean){
			singleSoundOn = b;
		}
		public function setEndFunc(f:Function){
			endFunc = f;
		}
		public function removeAni(){
			ArrayHelper.findAndRemove(aniStorageArray, this, 1);
			if(aniEventOn){
				removeEventListener(Event.ENTER_FRAME, startAnimationEvent);
				aniEventOn = false;
			}
		}
		public function stopAni(){
			if(aniEventOn){
				removeEventListener(Event.ENTER_FRAME, startAnimationEvent);
				aniEventOn = false;
			}
		}
		public function getAniLockOn():Boolean{
			return aniLockOn;
		}
		public function setAniLockOn(b:Boolean){
			aniLockOn = b;
		}
//		public static function getNumFrames(pStartFrameLabel:String, pEndFrameLabel:String):int{
//			
//		}
	}
}