﻿package {
	public class ArrayHelper{
		public static function arrayEquality(pArray1:Array, pArray2:Array, pStartFrom1:uint=0,pStartFrom2:uint=0):Boolean{
			if(pArray1!=null && pArray2!=null){
				if(pArray1.length == pArray2.length || pStartFrom1!=0 || pStartFrom2!=0){
					for(var i:uint=pStartFrom1; i<pArray1.length; i++){
						if(pArray1[i]!=pArray2[i-pStartFrom1+pStartFrom2]){
							return false;
						}
					}
					return true;
				}
			}
			return false;
		}
		public static function contains(pArray:Array, pObject:Object):Object{
			if(pArray!=null){
				for(var i:uint=0; i<pArray.length; i++){
					if(pArray[i]==pObject){
						return i;
					}
				}
			}
			return null;
		}
		public static function containsAny(pArray0:Array, pArray1:Array):Object{//If two arrays have any element in common
			if(pArray0!=null && pArray1!=null){
				for(var i:uint=0; i<pArray0.length; i++){
					for(var j:uint=0; j<pArray1.length; j++){
						if(pArray0[i]==pArray1[j]){
							return [i,j];
						}
					}
				}
			}
			return null;
		}
		public static function functionEquality(pArray:Array, pObject:Object, pFunction:Function):Object{
			if(pArray!=null){
				for(var i:uint=0; i<pArray.length; i++){
					if(pFunction(pArray[i])==pObject){
						return pArray[i];
					}
				}
			}
			return null;
		}
		public static function addIfAbsent(pArray:Array,pObject:Object){
			if(contains(pArray,pObject)==null){
				pArray.push(pObject);
			}
		}
//		public static function removeIfContains(pArray:Array,pObject:Object){
//			var fElem:Object = contains(pArray,pObject);
//			if(fElem is Number){
//				pArray.splice(fElem,1);
//			}
//		}
		public static function cloneArray(pArray:Array):Array{
			if(pArray!=null){
				var fArray:Array = new Array(0);
				for(var i:uint=0; i<pArray.length; i++){
					fArray.push(pArray[i]);
				}
				return fArray;
			}
			return null;
		}
		public static function cloneAndAlterArray(pArray:Array, fFunction:Function):Array{
			if(pArray!=null){
				var fArray:Array = new Array(0);
				for(var i:uint=0; i<pArray.length; i++){
					fArray.push(fFunction(pArray[i]));
				}
				return fArray;
			}
			return null;
		}
		public static function findAndReplace(pArray:Array, pFind:Object, pReplacement:Object):Array{
			for(var i:uint=0; i<pArray.length; i++){
				if(pArray[i]==pFind){
					pArray.splice(i,1,pReplacement);
					break;
				}
			}
			return pArray;
		}
		public static function findAndReplaceAll(pArray:Array, pFind:Object, pReplacement:Object):Array{
			for(var i:uint=0; i<pArray.length; i++){
				if(pArray[i]==pFind){
					pArray.splice(i,1,pReplacement);
				}
			}
			return pArray;
		}
		public static function findAndRemove(pArray:Array, pFind:Object, pRemoveCount:int=1):Array{
			for(var i:uint=0; i<pArray.length; i++){
				if(pArray[i]==pFind){
					if(pArray.length-(i+pRemoveCount)>0){//So you can't remove more than the length of the array
						pArray.splice(i,pRemoveCount);
					}
					else{
						pArray.splice(i);//Remove everything from i onwards
					}
					return pArray;
				}
			}
			return pArray;
		}
		public static function findAndRemoveAll(pArray:Array, pFind:Object, pRemoveCount:int=1):Array{
			for(var i:uint=0; i<pArray.length; i++){
				if(pArray[i]==pFind){
					if(pArray.length-(i+pRemoveCount)>0){
						pArray.splice(i,pRemoveCount);
						i--;
					}
					else{
						pArray.splice(i);//Remove everything from i onwards
						return pArray;
					}
				}
			}
			return pArray;
		}
		public static function findAndRemoveClass(pArray:Array, pFind:Class, pRemoveCount):Array{
			for(var i:uint=0; i<pArray.length; i++){
				if(pArray[i] is pFind){
					if(pArray.length-(i+pRemoveCount)>0){
						pArray.splice(i,pRemoveCount);
						i--;
					}
					else{
						pArray.splice(i);//Remove everything from i onwards
						return pArray;
					}
				}
			}
			return pArray;
		}
		public static function findLowest(pArray:Array, pElementOn:Boolean = true, pFunc:Function=null):Object{//pFunc returns a Number and takes a parameter that is one element of the array
			//If pElementOn, then return the lowest element number, otherwise return the lowest value
			if(pFunc==null){
				pFunc = function(o:Object){
					return o;
				}
			}
			var fCurrentLow:Number = pFunc(pArray[0]);
			var fLowElement:uint = 0;
			var fLowElementArray:Array = [0];
			if(pArray.length>1){
				for(var i:uint=1; i<pArray.length; i++){
					var fTestLow:Number = pFunc(pArray[i]);
					if(fTestLow<fCurrentLow){
						fCurrentLow = fTestLow;
						fLowElement = i;
						fLowElementArray = [i];
					}
					else if(fTestLow==fCurrentLow){
						fLowElementArray.push(i);
					}
				}
			}
			if(pElementOn){
				return fLowElementArray;
			}
			else{
				return fCurrentLow;
			}
		}
		public static function findHighest(pArray:Array, pElementOn:Boolean = true, pFunc:Function=null):Object{//pFunc returns a Number and takes a parameter that is one element of the array
			if(pFunc==null){
				pFunc = function(o:Object){
					return o;
				}
			}
			var fCurrentHigh:Number = pFunc(pArray[0]);
			var fHighElement:uint = 0;
			var fHighElementArray:Array = [0];
			if(pArray.length>1){
				for(var i:uint=1; i<pArray.length; i++){
					var fTestHigh:Number = pFunc(pArray[i]);
					if(fTestHigh>fCurrentHigh){
						fCurrentHigh = fTestHigh;
						fHighElement = i;
						fHighElementArray = [i];
					}
					else if(fTestHigh==fCurrentHigh){
						fHighElementArray.push(i);
					}
				}
			}
			if(pElementOn){//Returns an array with element #'s of the highest value
				return fHighElementArray;
			}
			else{//Returns the highest value
				return fCurrentHigh;
			}
		}
		public static function randomize(pArray:Array):Array{
			var fNewArray:Array = pArray.slice();
			
			for(var i:uint=0; i<pArray.length; i++){
				var fTempObj:Object = fNewArray[i];
				var fRndElem:uint = Math.floor(Math.random()*pArray.length);
				fNewArray[i] = fNewArray[fRndElem];
				fNewArray[fRndElem] = fTempObj;
			}
			return fNewArray;
		}
		public static function getSum(pArray:Array):Number{
			var fCurrentSum:Number = 0;
			for(var i:uint=0; i<pArray.length; i++){
				if(pArray[i] is Number){
					fCurrentSum+=pArray[i];
				}
			}
			return fCurrentSum;
		}
	}
}