﻿package {
	import flash.utils.Timer;
	import flash.utils.getTimer;
	import flash.events.*;
	import flash.display.*;
	import flash.media.Sound;
	
	public class AttackFreqTimer extends MovieClip{
		private var physObj:PhysObj;
		private var effectDuration:int;
		private var attackFreq:int;
		private var lastTimeEffect:uint;
		private var lastTimeHit:uint;
		private var _skill:Skill;
//		private var player:Player;
		private var aFTOn:Boolean = true;//False at end of duration
		private var numHits:int = 1;//Number of hits per single frame
		private var contactOn:Boolean = true;//Set in player if the AO and player are in contact (Game's testAllCollisions->Player's addAFT->AFT's setContactOn)
		private var gameTimeFunc:Function;
		private var firstHit:Boolean = true;
		public function AttackFreqTimer(pSkill:Skill,pPO:PhysObj, pGameTimeFunc:Function){
			physObj = pPO;
			_skill = pSkill;
			effectDuration = pSkill.getDuration();
			attackFreq = pSkill.getAttackFreq();
			//player = pPlayer;
			gameTimeFunc = pGameTimeFunc;
			lastTimeEffect = pGameTimeFunc();
			lastTimeHit = pGameTimeFunc();
			//attackFreqTimer();
			numHits = 1;
			//addEventListener(Event.ENTER_FRAME, attackFreqTimerEvent);
		}
		public function removeAttackFreqTimer():void {
			physObj = null;
			_skill = null;
			gameTimeFunc = null;
		}
		private function attackFreqTimerEvent(e:Event){
			attackFreqTimer();
		}
		public function attackFreqTimer(){
			if(physObj.deathOn || gameTimeFunc()-lastTimeEffect >= effectDuration){
//			if(gameTimeFunc()-lastTimeEffect >= effectDuration){
//				Skill(this.parent).setPlayerA(player);
//				Skill(this.parent).getEndEffectFunc()();
				numHits = 0;
				aFTOn = false;
//				removeEventListener(Event.ENTER_FRAME, attackFreqTimerEvent);
			}
			else{
				var fTimePassed:uint = gameTimeFunc()-lastTimeHit;
				if(fTimePassed >= attackFreq){
					var fNumHits:uint = Math.floor(fTimePassed/attackFreq);//How many hits based on how many times the delay goes into fTimePassed
					var fRemainderTime:uint = fTimePassed%attackFreq;//Remaining excess time after taking into account the fNumHits
					numHits = fNumHits;
					lastTimeHit += fTimePassed-fRemainderTime;
					
				}
				else{
					numHits = 0;
				}
				if(firstHit){
					numHits = 1;
					firstHit = false;
				}
			}
		}
		public function removeEvent(){
			//removeEventListener(Event.ENTER_FRAME, attackFreqTimerEvent);
		}
		public function getNumHits():int{
			return numHits;
		}
		public function setNumHits(b:int){//Used to turn off numHits after the first initial hit in Player's addAFT (so it doesn't activate twice in one frame)
			numHits = b;
		}
		public function getAFTOn():Boolean{
			return aFTOn;
		}
		public function getContactOn():Boolean{
			return contactOn;
		}
		public function setContactOn(b:Boolean){
			contactOn = b;
		}
		public function get skill():Skill{
			return _skill;
		}
		public function set skill(s:Skill){
			_skill = s;
		}
	}	
}