﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	public class Background extends MovieClip{//Can also be used as foreground
		private var mainBG:DisplayObject = null;
		private var bGArray:Array = new Array(0);//[n]=bGGraphic,[n+1]=scroll speed (0=doesn't move, 1=moves at same speed as avatar)
		private var bGArrayAlt:Array = new Array(0);//For infinite scrolling
		private var bGWidth:Number = 0;//The width of the bG starting from the reference point that can be scrolled and walked on
		private var bGHeight:Number = 400;
		private var scrollX:Number = 0;//Position of the bG
		private var leftEnd:Boolean = true;
		private var rightEnd:Boolean = false;
		private var attachedBG:Background = null;//Another BG which will follow the scroll of this BG (Foreground)
		private var multipleAvatarOn:Boolean = false;
		private var crntStage:Stage;
		private var gameTimeFunc:Function;
		private var autoScrollOn:Boolean = false;
		public function Background(){			
		}
		public function removeBackground() {
			mainBG = null;
			bGArray = null;
			bGArrayAlt = null;
			attachedBG = null;
			crntStage = null;
			gameTimeFunc = null;
		}
		public function createBackground(pBGClassArray:Array,pAlign:Number,pBGWidth:Number,pBGHeight:Number,pStage:Stage){
			bGArray = new Array(0);
			bGWidth = pBGWidth;
			bGHeight = pBGHeight;
			crntStage = pStage;
//			scrollX = pAlign*(stage.stageWidth-pBGWidth);
			for(var i:uint=0; i<pBGClassArray.length; i+=2){//Create all the BG's and add them to bG
				var FBackgroundGraphicClass:Class = getDefinitionByName(pBGClassArray[i]) as Class;
				var fBGGraphic:DisplayObject = new FBackgroundGraphicClass;
				fBGGraphic.cacheAsBitmap = true;//CHANGE TO BITMAP (Performance MUCH BETTER!!!)
				addChildAt(fBGGraphic,0).name = i.toString();//Name the BG child by its order to be used with .getChildByName
				if(i==0){
					mainBG = fBGGraphic;
				}
				fBGGraphic.x = pAlign*(crntStage.stageWidth-pBGWidth)*pBGClassArray[i+1];
				//trace(fBGGraphic.x);
				fBGGraphic.y = crntStage.stageHeight;
				bGArray.push(fBGGraphic,pBGClassArray[i+1]);
				if(pAlign == 1){
					leftEnd = false;
					rightEnd = true;
				}
				else if(pAlign == 0){
					leftEnd = true;
					rightEnd = false;
				}
				else{
					leftEnd = false;
					rightEnd = false;
				}
				
//				if(i!=0){
//					bGGraphic.y-=stage.stageHeight-bGGraphic.height;//keep the non-road BG's on top of stage
//				}
			}
			scrollX = bGArray[0].x;
//			bG.x = pAlign*(-(pBGWidth-stage.stageWidth));//Align the background based on specifications in function createArea()
//			bG.y = stage.stageHeight;
/*
			var fPlayerCamArray:Array = MovieClip(Game.getGame()).getPlayerCamArray();
			if(fPlayerCamArray.length>1){
				multipleAvatarOn = true;
				//addEventListener(Event.ENTER_FRAME, multipleAvatarFunc);
			}
*/
		}
		private var lastTimeAutoScroll:Number;
		public function startAutoScroll(pGameTimeFunc:Function){
			gameTimeFunc = pGameTimeFunc;
			if(bGArrayAlt.length == 0){
				var i:int;
				for(i=0; i<bGArray.length; i+=2){
					var FBackgroundGraphicClass:Class = getDefinitionByName(getQualifiedClassName(bGArray[i])) as Class;
					var fBGGraphicAlt:DisplayObject = new FBackgroundGraphicClass;
					fBGGraphicAlt.cacheAsBitmap = true;//CHANGE TO BITMAP (Performance MUCH BETTER!!!)
					addChildAt(fBGGraphicAlt,bGArray[i].parent.getChildIndex(bGArray[i])).name = i.toString();//Name the BG child by its order to be used with .getChildByName
					fBGGraphicAlt.x = bGArray[i].x + bGArray[i].width-1;
					fBGGraphicAlt.y = crntStage.stageHeight;
					bGArrayAlt.push(fBGGraphicAlt,bGArray[i+1]);
				}
			}
			lastTimeAutoScroll = gameTimeFunc();
			autoScrollOn = true;
		}
		public function stopAutoScroll(){
			autoScrollOn = false;
		}
		public function autoInfiniteScroll(pMoveSpeed:Number){
			if(autoScrollOn){
				var i:int;
				var fTimePassed:int = gameTimeFunc()-lastTimeAutoScroll;
				lastTimeAutoScroll += fTimePassed;
				for(i=0; i<bGArray.length; i+=2){
					var fDist:Number = pMoveSpeed*(fTimePassed/1000)*bGArray[i+1];
					if(bGArray[i].x+fDist<-bGArray[i].width){
						bGArrayAlt[i].x+=fDist;
						bGArray[i].x = bGArrayAlt[i].x + bGArrayAlt[i].width-1;
					}
					else if(bGArrayAlt[i].x+fDist<-bGArray[i].width){
						bGArray[i].x+=fDist;
						bGArrayAlt[i].x = bGArray[i].x + bGArray[i].width-1;
					}
					else{
						bGArrayAlt[i].x+=fDist;
						bGArray[i].x+=fDist;
					}
				}
			}
		}
/*
		public function multiplePlayerFunc(fPlayerArray:Array){
//			var fPlayerArray:Array = MovieClip(Game.getGame()).getAvatarArray();
			//if(fPlayerArray
			var i:uint=0;
			var fPlayerNoCorpseArray:Array = new Array(0);
			for(;i<fPlayerArray.length;i++){
				if(!fPlayerArray[i].getCorpseOn() && !fPlayerArray[i].getDeathGroundChkOn()){
					fPlayerNoCorpseArray.push(fPlayerArray[i]);
				}
			}
			if(fPlayerNoCorpseArray.length>0){
				var fDmgObjArray:Array = MovieClip(Game.getGame()).getDmgObjArray();
				var fOriginalPosition:Number = bGArray[0].x;
				var fHighestEle:uint = ArrayHelper.findHighest(fPlayerNoCorpseArray,true,function(pPlayer:Player){return pPlayer.x})[0];
				var fLowestEle:uint = ArrayHelper.findLowest(fPlayerNoCorpseArray,true,function(pPlayer:Player){return pPlayer.x})[0];
				var fLeftMostAvatar:Player = fPlayerNoCorpseArray[fLowestEle];
				var fRightMostAvatar:Player = fPlayerNoCorpseArray[fHighestEle];
				var fDistBtwAvatars:Number = Math.abs(fLeftMostAvatar.x-fRightMostAvatar.x);
				var fDistFromEnd:Number = (stage.stageWidth-fDistBtwAvatars)/2;
				var fAvatarDistFromBG:Number = fLeftMostAvatar.x-fDistFromEnd-bGArray[0].x;
				var fMoveAmountX = -fAvatarDistFromBG-bGArray[0].x;
				scrollX = bGArray[0].x+fMoveAmountX;
				if(scrollX>0){//If past left side
					scrollX = 0;
					fMoveAmountX = -fOriginalPosition;
					leftEnd = true;
					rightEnd = false;
				}
				else if(scrollX+bGWidth<stage.stageWidth){//If past right side
					scrollX = stage.stageWidth-bGWidth;
					fMoveAmountX = stage.stageWidth-(fOriginalPosition+bGWidth);
					leftEnd = false;
					rightEnd = true;
				}
				else{//If normal
					leftEnd = false;
					rightEnd = false;
				}
				//trace("Scroll",scrollX);
				bGArray[0].x = scrollX;
				if(attachedBG!=null){//Scroll the attached BG
					for(i=0; i<attachedBG.getBGArray().length; i+=2){
						attachedBG.getBGArray()[i].x+=fMoveAmountX*attachedBG.getBGArray()[i+1];
					}
				}
				for(i=2; i<bGArray.length; i+=2){
					bGArray[i].x+=fMoveAmountX*bGArray[i+1];
				}
				for (i=0; i < fDmgObjArray.length; i++) {
					if(fDmgObjArray[i].parent is AttackObject){
						if(!fDmgObjArray[i].parent.getAOPlayerStick()){
							fDmgObjArray[i].parent.x += fMoveAmountX;
						}
					}
					else{
						fDmgObjArray[i].parent.x += fMoveAmountX;
					}
				}
			}
		}
		public function moveBackground(pMoveAmountX:Number):Number{//Only for primary background, all other backgrounds should be attached instead of using this function
			//If it's not a single room (give or take 10)
			if(bGWidth+10<stage.stageWidth || bGWidth-10>stage.stageWidth){
				if(!((leftEnd && pMoveAmountX>=0) || (rightEnd && pMoveAmountX<=0))){
					var i:uint=0;
					var fDmgObjArray:Array = MovieClip(Game.getGame()).getDmgObjArray();
					var fOriginalPosition:Number = bGArray[0].x;
					scrollX = bGArray[0].x;
					scrollX += pMoveAmountX;
					if(scrollX>0){//If past left side
						scrollX = 0;
						pMoveAmountX = -fOriginalPosition;
						leftEnd = true;
						rightEnd = false;
					}
					else if(scrollX+bGWidth<stage.stageWidth){//If past right side
						scrollX = stage.stageWidth-bGWidth;
						pMoveAmountX = stage.stageWidth-(fOriginalPosition+bGWidth);
						leftEnd = false;
						rightEnd = true;
					}
					else{//If normal
						leftEnd = false;
						rightEnd = false;
					}
					//trace("Scroll",scrollX);
					bGArray[0].x = scrollX;
					if(attachedBG!=null){//Scroll the attached BG
						for(i=0; i<attachedBG.getBGArray().length; i+=2){
							attachedBG.getBGArray()[i].x+=pMoveAmountX*attachedBG.getBGArray()[i+1];
						}
					}
					for(i=2; i<bGArray.length; i+=2){
						bGArray[i].x+=pMoveAmountX*bGArray[i+1];
					}
					for (i=0; i < fDmgObjArray.length; i++) {
						if(fDmgObjArray[i].parent is AttackObject){
							if(!fDmgObjArray[i].parent.getAOPlayerStick()){
								fDmgObjArray[i].parent.x += pMoveAmountX;
							}
						}
						else{
							fDmgObjArray[i].parent.x += pMoveAmountX;
						}
					}
					return pMoveAmountX;
				}
			}
			return 0;
		}
*/
		public function getMainBG():DisplayObject{
			return mainBG;
		}
		public function getBGArray():Array{
			return bGArray;
		}
		public function setAttachedBG(pB:Background){
			attachedBG = pB;
		}
		public function getScrollX():Number{
			return scrollX;
		}
		public function getBGWidth():Number{
			return bGWidth;
		}
		public function getBGHeight():Number{
			return bGHeight;
		}
		public function setLeftEnd(b:Boolean){
			leftEnd = b;
		}
		public function setRightEnd(b:Boolean){
			rightEnd = b;
		}		
	}
}