﻿package {
	import flash.display.*;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	
	public class ControlObj extends MovieClip{
		private var mChangeDirectionOn:Boolean = true;
		
		private var gameTimeFunc:Function;
		private var baseVelX:Number = 150;
		private var baseVelY:Number = -400;
		private var baseVelYDown:Number = 300;
		private var dropOn:Boolean = false;
		private var floatOn:Boolean = false;
		private var gravity:Number = 0;
		
		private var _crntGraphic:MovieClip;
		private var _crntGraphicInner:MovieClip;//If the actual current graphic is nested within the _crntGraphic (e.g. Farmer bob's StickBoyWhole)
		private var _crntGraphicInner_Array:Array;//Contains every possible instance of _crntGraphicInner
		private var _crntGraphicStandWidth:Number;
		private var _crntGraphicStandHeight:Number;
		private var _crntAni:Animation = new Animation([]);
		private var _crntAniName:String = "stand";
		
		private var _aniMvHash:Object;
		
		private var moveOn:Boolean = true;//If moveX and moveY are on
//		private var _controlStatus:Object = {hOn:true,hType:null};//If runActions is on, if not, what type of disable
		private var _controlOffArray:Array = new Array(0);//Array of Strings (type of pause e.g. "cast").  If .length>0, no actions
		public function get controlOffArray():Array{
			return _controlOffArray;
		}
		private var _crntVelX:Number = 0;
		private var _crntMomentumVelX:Number = 0;
		
		private var _airOn:Boolean = false;
		
		private var mvSpeedArray:Array = new Array(0);
		private var _mvSpeed:MvSpeed = new MvSpeed();
		
		private var lastTimeAutoMove:int;

		
		private var borderCoord:Object = {hLeft:15,hTop:0,hRight:1080-15,hBottom:675-35};
		private var _borders:Object = {hLeft:false,hTop:false,hRight:false,hBottom:true};
		public function set borders(o:Object){
			_borders = o;
		}
		private var groundSide:String = "bottom";
		
		private var _directionFacing:String = "right";
		private var _faceXForwardOn:Boolean = false;
		public function set faceXForwardOn(b:Boolean){
			_faceXForwardOn = b;
		}
		private var _faceForwardOn:Boolean = false;
		public function set faceForwardOn(b:Boolean){
			_faceForwardOn = b;
		}
		private var _faceMouseOn:Boolean = false;
		public function set faceMouseOn(b:Boolean){
			_faceMouseOn = b;
		}
		private var _faceMouseAlwaysOn:Boolean = false;
		public function set faceMouseAlwaysOn(b:Boolean){
			_faceMouseAlwaysOn = b;
		}
		private var crntJumpHeld:uint = 0;
		static const JUMP_HELD_DUR:uint = 300;
		
		private var lastTimeAction:Number = 0;
		
		private var _mouseAimName:String = null;
		
		private var _controlArray:Array = new Array(0);//Array of Objects:{hName:name,hType:keyboard/pattern/linear,hDef:{misc0,misc1,...miscN},hStatus:"on"/"off"/"removed"}
		private var _mCAlignXY:Object;
		public function get mCAlignXY():Object{
			return _mCAlignXY;
		}
		public function set mCAlignXY(o:Object){
			_mCAlignXY = o;
		}
		public function removeControlObj():void {
			gameTimeFunc = null;
			_crntGraphic = null;
			_crntGraphicInner = null;
			_crntGraphicInner_Array = null;
			_crntAni.removeAni();
			_crntAni = null;
			_aniMvHash = null;
			_controlOffArray = null;
			mvSpeedArray = null;
			_mvSpeed = null;
			_controlArray = null;
			_mCAlignXY = null;
			maxTierR = null;
			_potentialAniArray = null;
		}
		public function ControlObj(pMCName:String,pMCInner_Array:Array, pMCAlignXY:Object,pAniMvHash:Object,pGravity:Number,pGameTimeFunc:Function,pScale:Object=null){
			gameTimeFunc = pGameTimeFunc;
			_mCAlignXY = pMCAlignXY;
			_aniMvHash = pAniMvHash;
//			this.team = "avatar";
//			this.dmgType = "none";
			//this.mvSpeed.addMvSpeed({hName:"vertical",hVelX:0,hAccX:0,hVelY:0,hAccY:gravity,hTier:0},"add");
			gravity = pGravity;
			lastTimeAction = gameTimeFunc();
			var FClass:Class = getDefinitionByName(pMCName) as Class;
			_crntGraphic = new FClass();
			_crntGraphicInner_Array = pMCInner_Array;
			addChild(_crntGraphic);
			if(pScale==null){
				pScale = {hX:1,hY:1};
			}
			_crntGraphic.scaleX = pScale["hX"];
			_crntGraphic.scaleY = pScale["hY"];
//			_crntGraphic.cacheAsBitmap = true;
			_crntGraphicStandWidth = _crntGraphic.width;
			_crntGraphicStandHeight = _crntGraphic.height;
//			switch(pMCName){
//				case "Dog":
//					this.bulletOrigin = [9,-24.65];
//					break;
//				default:
//					break;
//			}
		}
		//{hName: ,hType:"keyboard",hStatus:"on",hDef:{hMvType ,hKeyboardTester: ,hWalkSpeed: ,hRunSpeed: }}
		//hDef:{hMvType ,hKeyboardTester: ,hWalkSpeed: ,hRunSpeed: 
		public function addControl(pName:String,pType:String,pDefinition:Object,pTier:Object,pDuration:Number=-1):Boolean{//If a control is overwritten = true
			var fControl:Object = getControlByName(pName,true);//Removes the object if it exists
			var fNewControl:Object = {hName:pName,hType:pType,hStatus:"on",hDef:pDefinition,hMvSpeed:new MvSpeed(),hElapsed:0,hTier:pTier,hDuration:pDuration};
			switch(pType){
				case "pattern":
					fNewControl = {hName:pName,hType:pType,hStatus:"on",hDef:pDefinition,hMvSpeed:new MvSpeed(),hElapsed:0,hTier:pTier,hDuration:pDuration,hCrntMvNumX:0,hCrntMvNumY:0,hMvElapsedX:0,hMvElapsedY:0};
					if(pDefinition["hXInverseOn"] is Boolean && pDefinition["hXInverseOn"]==true){
						fNewControl["hMvSpeed"].velX = -pDefinition["hXMvArray"][0];
						fNewControl["hMvSpeed"].accX = -pDefinition["hXMvArray"][2];
					}
					else{
						fNewControl["hMvSpeed"].velX = pDefinition["hXMvArray"][0];
						fNewControl["hMvSpeed"].accX = pDefinition["hXMvArray"][2];
					}
					fNewControl["hMvSpeed"].velY = pDefinition["hYMvArray"][0];
					fNewControl["hMvSpeed"].accY = pDefinition["hYMvArray"][2];
					break;
				case "keyboard":
					if(pDefinition["hGravity"] is Number){
						switch(pDefinition["hJumpPlane"]){
							case "x":
								if(pDefinition["hGravity"]>=0){
									groundSide = "right";
								}
								else{
									groundSide = "left";
								}
								break;
							case "y":
								if(pDefinition["hGravity"]>=0){
									groundSide = "bottom";
								}
								else{
									groundSide = "top";
								}
								break;
						}
					}
					break;
				case "linear":
					startLinear(fNewControl);
					break;
				case "freeFall":
					startFreeFall(fNewControl);
					break;
				default:
					trace("No such control type");
			}			
			_controlArray.push(fNewControl);
			calcMaxReplace();
			if(_faceMouseOn){
				startMouseAim(_crntGraphic);
			}
			if(fControl!=null){
				return true;
			}
			return false;
		}
		private var maxTierR:Object = {hTier:{hTierNum:-1,hType:"replace"}};//The highest tiered replacement control object

		private function calcMaxReplace(){
			var i:uint;
			maxTierR = {hTier:{hTierNum:-1,hType:"replace"}};
			for(i=0; i<_controlArray.length; i++){
				if(_controlArray[i]["hTier"]["hType"]=="replace" && _controlArray[i]["hStatus"]=="on"){
					if(_controlArray[i]["hTier"]["hTierNum"]>=maxTierR["hTier"]["hTierNum"]){
						maxTierR = _controlArray[i];
					}
				}
			}
			for(i=0; i<_controlArray.length; i++){
				if(_controlArray[i]["hTier"]["hTierNum"]<=maxTierR["hTier"]["hTierNum"] && _controlArray[i]!=maxTierR){
					resetControl(_controlArray[i]);
				}
			}
		}		
		public function pauseControl(pName:String):Boolean{
			var fControl:Object = getControlByName(pName);
			if(fControl!=null){
				fControl["hStatus"] = "off";
				calcMaxReplace();
				resetControl(fControl);
				return true;
			}
			return false;
		}
		public function getControlByName(pName:String,pRemoveOn:Boolean=false):Object{
			var i:int;
			for(i=0;i<_controlArray.length;i++){
				if(_controlArray[i]["hName"] == pName){
					var fControl:Object = _controlArray[i];
					if(pRemoveOn){
						fControl["hStatus"] = "removed";
						_controlArray.splice(i,1);
						calcMaxReplace();
					}
					return _controlArray[i];
				}
			}
			return null;
		}
		public function resetControl(pControl:Object){
			if(pControl != null){
				pControl["hMvSpeed"].velX = 0;
				pControl["hMvSpeed"].velY = 0;
				
				switch(pControl["hType"]){
					case "keyboard":
						crntJumpHeld = JUMP_HELD_DUR;
						break;
					case "pattern":
						pControl["hCrntMvNumX"]=0;
						pControl["hCrntMvNumY"]=0;
						pControl["hMvElapsedX"]=0;
						pControl["hMvElapsedY"]=0;
						break;
				}
			}
		}
		public function changeDirectionFacing() {
			_crntGraphic.scaleX = -_crntGraphic.scaleX;
			if (_directionFacing == "right") {
				_directionFacing = "left";
			}
			else if(_directionFacing == "left") {
				_directionFacing = "right";
			}
		}
		public function setDirectionFacing(pDirection:String) {
			if (pDirection!=_directionFacing) {
				changeDirectionFacing();
			}
		}
		private function moveX(pTimePassed:uint, pSpeed:Number, pAcc:Number, pPositiveOn:Boolean=true,pNegativeOn:Boolean=true){
			if(moveOn){
				_crntVelX += pSpeed;
				var fDistance:Number = pSpeed*pTimePassed/1000 + .5*pAcc*Math.pow(pTimePassed/1000,2);
				if(!pPositiveOn && fDistance>0){
					fDistance = 0;
				}
				if(!pNegativeOn && fDistance<0){
					fDistance = 0;
				}
				trueMoveX(fDistance);
			}
		}
		private function moveY(pTimePassed:uint, pSpeed:Number, pAcc:Number, pPositiveOn:Boolean=true,pNegativeOn:Boolean=true){
			if(moveOn){
				var fDistance:Number = pSpeed*pTimePassed/1000 + .5*pAcc*Math.pow(pTimePassed/1000,2);
				if(!pPositiveOn && fDistance>0){
					fDistance = 0;
				}
				if(!pNegativeOn && fDistance<0){
					fDistance = 0;
				}
				trueMoveY(fDistance);
			}
		}
		public function trueMoveX(pDistance:Number){//Only used outside in PhysObj's physObjLoop for AOPlayerStick
			this.x += pDistance;
		}
		public function trueMoveY(pDistance:Number){//Only used outside in PhysObj's physObjLoop for AOPlayerStick
			this.y += pDistance;
		}
		public function checkBounds():Object{//Used only in PhysObj for death borders
			var fBoundHash:Object = {hLeft:false,hTop:false,hRight:false,hBottom:false};
			if(_borders["hBottom"]){
				if(this.y >= borderCoord["hBottom"]&&_mCAlignXY["hY"]=="bottom"){
					fBoundHash["hBottom"] = true;
				}
				else if(this.y+_crntGraphicStandHeight/2 >= borderCoord["hBottom"]-1&&_mCAlignXY["hY"]=="mid"){
					fBoundHash["hBottom"] = true;
				}
			}
			if(_borders["hTop"]){
				if((this.y-_crntGraphicStandHeight/2<=borderCoord["hTop"]&&_mCAlignXY["hY"]=="mid")){
					fBoundHash["hTop"] = true;
				}
				else if(this.y-_crntGraphicStandHeight<=borderCoord["hTop"]&&_mCAlignXY["hY"]=="bottom"){
					fBoundHash["hTop"] = true;
				}
			}
			if(_borders["hLeft"]){
				if(this.x-_crntGraphicStandWidth/2 <= borderCoord["hLeft"]){
					fBoundHash["hLeft"] = true;
				}
			}
			if(_borders["hRight"]){
				if(this.x+_crntGraphicStandWidth/2 >= borderCoord["hRight"]){
					fBoundHash["hRight"] = true;
				}
			}
			return fBoundHash;
		}
		private function checkAndChangeBounds():Object{
			var fBoundHash:Object = {hLeft:false,hTop:false,hRight:false,hBottom:false};
			if(_borders["hBottom"]){
				if(this.y >= borderCoord["hBottom"]&&_mCAlignXY["hY"]=="bottom"){
					this.y = borderCoord["hBottom"];
					if(groundSide=="bottom")_airOn = false;
					fBoundHash["hBottom"] = true;
				}
				else if(this.y+_crntGraphicStandHeight/2 >= borderCoord["hBottom"]-1&&_mCAlignXY["hY"]=="mid"){
					this.y = borderCoord["hBottom"]-_crntGraphicStandHeight/2;
					if(groundSide=="bottom")_airOn = false;
					fBoundHash["hBottom"] = true;
				}
				else{
					if(groundSide=="bottom")_airOn = true;
				}
			}
			if(_borders["hTop"]){
				if((this.y-_crntGraphicStandHeight/2<=borderCoord["hTop"]&&_mCAlignXY["hY"]=="mid")){
					this.y = borderCoord["hTop"]+_crntGraphicStandHeight/2;
					if(groundSide=="top")_airOn = false;
					fBoundHash["hTop"] = true;
				}
				else if(this.y-_crntGraphicStandHeight<=borderCoord["hTop"]&&_mCAlignXY["hY"]=="bottom"){
					this.y = borderCoord["hTop"]+_crntGraphicStandHeight;
					if(groundSide=="top")_airOn = false;
					fBoundHash["hTop"] = true;
				}
				else{
					if(groundSide=="top")_airOn = true;
				}
			}
			if(_borders["hLeft"]){
				if(this.x-_crntGraphicStandWidth/2 <= borderCoord["hLeft"]){
					this.x = borderCoord["hLeft"]+_crntGraphicStandWidth/2;
					if(groundSide=="left")_airOn = false;
					fBoundHash["hLeft"] = true;
				}
				else{
					if(groundSide=="left")_airOn = true;
				}
			}
			if(_borders["hRight"]){
				if(this.x+_crntGraphicStandWidth/2 >= borderCoord["hRight"]){
					this.x = borderCoord["hRight"]-_crntGraphicStandWidth/2;
					if(groundSide=="right")_airOn = false;
					fBoundHash["hRight"] = true;
				}
				else{
					if(groundSide=="right")_airOn = true;
				}
			}
			return fBoundHash;
		}
		public function faceForward(pVelX:Number,pVelY:Number){
			if(pVelX<0){//If moving left
			   if(_crntGraphic.scaleX > 0){//If graphic is facing right
					_crntGraphic.scaleX = -_crntGraphic.scaleX;
			   }
			}
			else if(pVelX>0){//if moving right
			   if(_crntGraphic.scaleX < 0){//If graphic is facing left
					_crntGraphic.scaleX = -_crntGraphic.scaleX;
			   }
			}
			_crntGraphic.rotation = Math.atan(pVelY/pVelX)*(360/(2*Math.PI));
		}
		private var _potentialAniArray:Array = new Array(0);
		public function runActions() {
			var fTimePassed:Number = gameTimeFunc()-lastTimeAction;
			lastTimeAction += fTimePassed;
			var i:int;
			var fSumVelX:Number = 0;
			var fSumVelY:Number = 0;
			var fTotalXVel:Number = 0;
			var fTotalYVel:Number = 0;
			_potentialAniArray = new Array(0);
			_crntVelX = 0;
			for(i=0;i<_controlArray.length;i++){
				if(_controlOffArray.length==0 || _controlArray[i]["hName"]!="primary"){//Disable Array (disables the primary control)
					var fNewTimePassed:Number = fTimePassed;
					var fDurationReachedOn:Boolean = false;
					//If duration of control is up or not
					if(_controlArray[i]["hDuration"]!=-1){
						if(_controlArray[i]["hElapsed"]+fNewTimePassed > _controlArray[i]["hDuration"]){
							fNewTimePassed = _controlArray[i]["hDuration"]-_controlArray[i]["hElapsed"];
							fDurationReachedOn = true;
						}
						_controlArray[i]["hElapsed"]+=fTimePassed;
					}
					if(_controlArray[i]["hStatus"]=="on"){
						if(_controlArray[i]["hTier"]["hTierNum"]>maxTierR["hTier"]["hTierNum"] || _controlArray[i]==maxTierR){
							switch(_controlArray[i]["hType"]){
								case "keyboard":
									runKeyboard(_controlArray[i],fNewTimePassed);
									break;
								case "linear":
									runLinear(_controlArray[i],fNewTimePassed);
									break;
								case "pattern":
									runPattern(_controlArray[i],fNewTimePassed);
									break;
								case "freeFall":
									if(runFreeFall(_controlArray[i],fNewTimePassed)){//If on ground
										_controlArray.splice(i,1);
										i--;
										calcMaxReplace();
									}
									break;
							}
							fSumVelX += _controlArray[i]["hMvSpeed"].velX;
							fSumVelY += _controlArray[i]["hMvSpeed"].velY;
						}
					}
					if(fDurationReachedOn){
						_controlArray.splice(i,1);
						i--;
						calcMaxReplace();
					}
				}
			}
			if(_controlOffArray.length>0){
				if(_airOn){
					moveX(fTimePassed,_crntMomentumVelX,0);
				}
				//runMomentumX
			}
			_crntMomentumVelX = _crntVelX;
			runGravity(moveY,gravity,fTimePassed);
			var fBoundHash:Object = checkAndChangeBounds();
			if(fBoundHash["hLeft"]||fBoundHash["hRight"]){
				fSumVelX = 0;
			}
			if(fBoundHash["hTop"]||fBoundHash["hBottom"]){
				fSumVelY = 0;
			}
			if (_faceXForwardOn) {
				faceForward(fSumVelX,0);
			}
			else if(_faceForwardOn){
				faceForward(fSumVelX,fSumVelY);
			}
			if(_faceMouseAlwaysOn){
				startMouseAim(_crntGraphic);
			}
			checkAni();
		}
		private function checkAni(){
			var i:uint;
			for(i=0;i<_potentialAniArray.length;i++){
				switch(_potentialAniArray[i]){
					case "stand":
						_crntAni.changeAni(_crntGraphic,"startStand","endStand",_aniMvHash["hStand"]["hFreq"],gameTimeFunc,0,null);
						break;
					case "duck":
						_crntAni.changeAni(_crntGraphic,"startDuck","endDuck",_aniMvHash["hDuck"]["hFreq"],gameTimeFunc,0,null);
						break;
					case "walk":
						_crntAni.changeAni(_crntGraphic,"startWalk","endWalk",_aniMvHash["hWalk"]["hFreq"],gameTimeFunc,0,null);
						break;
					case "run":
						_crntAni.changeAni(_crntGraphic,"startRun","endRun",_aniMvHash["hRun"]["hFreq"],gameTimeFunc,0,null);		
						break;
					case "crawl":
						_crntAni.changeAni(_crntGraphic,"startCrawl","endCrawl",_aniMvHash["hCrawl"]["hFreq"],gameTimeFunc,0,null);
						break;
					case"jump":
						_crntAni.changeAni(_crntGraphic,"startJump","endJump",_aniMvHash["hJump"]["hFreq"],gameTimeFunc,0,null);
						break;
					case "float":
						_crntAni.changeAni(_crntGraphic,"startFloat","endFloat",_aniMvHash["hFloat"]["hFreq"],gameTimeFunc,0,null);
						break;
					case "drop":
						_crntAni.changeAni(_crntGraphic,"startDrop","endDrop",_aniMvHash["hDrop"]["hFreq"],gameTimeFunc,0,null);
						break;
					case "airDash":
						_crntAni.changeAni(_crntGraphic,"startAirDash","endAirDash",_aniMvHash["hAirDash"]["hFreq"],gameTimeFunc,0,null);
						break;
					case "stunned":
						_crntAni.changeAni(_crntGraphic, "startStunned", "endStunned", _aniMvHash["hStunned"]["hFreq"], gameTimeFunc, 0, null);
						break;
				}
			}
		}
		public function startAniPattern(pPatternArray:Array){
			if(pPatternArray.length>0){
				_crntAni.repeatSeqOn = true;
				_crntAni.setResetOn(true);
				var fSeqArray:Array = new Array(0);
				for(var i:uint=0;i<pPatternArray.length;i+=4){
					fSeqArray.push(_crntGraphic,pPatternArray[i],pPatternArray[i+1],pPatternArray[i+3],gameTimeFunc,pPatternArray[i+2],null);
				}
				_crntAni.setSeq(fSeqArray);
				_crntAni.playSeq();
			}
		}
		//{hName: ,hType:"keyboard",hStatus:"on",hDef:{hMvType: ,hJumpPlane:"y", hKeyboardTester: ,hWalkSpeed: ,hRunSpeed: ,hJumpSpeed:,hDropSpeed:,hFloatSpeed:,hGravity:}}
		public function runKeyboard(pControl:Object,pTimePassed:uint){
			var fKeyboardTester:KeyboardTester = pControl["hDef"]["hKeyboardTester"];
			var fWalkSpeed:Number = pControl["hDef"]["hWalkSpeed"];
			var fRunSpeed:Number = pControl["hDef"]["hRunSpeed"];
			var fCrawlSpeed:Number = pControl["hDef"]["hCrawlSpeed"];
			var fJumpPlane:String = pControl["hDef"]["hJumpPlane"];
			var fJumpSpeed:Number = pControl["hDef"]["hJumpSpeed"];
			var fDropSpeed:Number = pControl["hDef"]["hDropSpeed"];
			var fFloatSpeed:Number = pControl["hDef"]["hFloatSpeed"];
			var fGravity:Number = pControl["hDef"]["hGravity"];
			
			var fMvType:String = pControl["hDef"]["hMvType"];//jump or freeMv
			var fResult0:Object;
			var fResult1:Object;
			switch(fMvType){
				case "jump":
					var fMvFunc:Function;
					var fJumpFunc:Function;
					if(fJumpPlane == "y"){
						fMvFunc = moveX;
						fJumpFunc = moveY;
						fResult1 = runJumpMv(fJumpFunc,pControl["hMvSpeed"].velY,fJumpSpeed,fGravity,fDropSpeed,fFloatSpeed,fKeyboardTester.getKeyOnHash().hUp,fKeyboardTester.getKeyOnHash().hDown,fKeyboardTester.getDoubleTapHash().hLeft,fKeyboardTester.getDoubleTapHash().hRight,pTimePassed);
						pControl["hMvSpeed"].velY = fResult1["hVel"];
						fResult0 = runFreeMv(fMvFunc,pControl["hMvSpeed"].velX,fWalkSpeed,fRunSpeed,fCrawlSpeed,fKeyboardTester.getKeyOnHash().hLeft,fKeyboardTester.getKeyOnHash().hRight,fKeyboardTester.getDoubleTapHash().hLeft,fKeyboardTester.getDoubleTapHash().hRight,fKeyboardTester.getKeyOnHash().hDown,pTimePassed);
						pControl["hMvSpeed"].velX = fResult0["hVel"];
						//runGravity(fJumpFunc,fGravity,pTimePassed);
					}
					else if(fJumpPlane == "x"){
						fMvFunc = moveY;
						fJumpFunc = moveX;
						fResult1 = runJumpMv(fJumpFunc,pControl["hMvSpeed"].velX,fJumpSpeed,fGravity,fDropSpeed,fFloatSpeed,fKeyboardTester.getKeyOnHash().hUp,fKeyboardTester.getKeyOnHash().hDown,fKeyboardTester.getDoubleTapHash().hLeft,fKeyboardTester.getDoubleTapHash().hRight,pTimePassed);
						pControl["hMvSpeed"].velX = fResult1["hVel"];
						fResult0 = runFreeMv(fMvFunc,pControl["hMvSpeed"].velY,fWalkSpeed,fRunSpeed,fCrawlSpeed,fKeyboardTester.getKeyOnHash().hLeft,fKeyboardTester.getKeyOnHash().hRight,fKeyboardTester.getDoubleTapHash().hLeft,fKeyboardTester.getDoubleTapHash().hRight,fKeyboardTester.getKeyOnHash().hDown,pTimePassed);
						pControl["hMvSpeed"].velY = fResult0["hVel"];
						
					}
					if(fResult1["hAniName"]!=null){
						_potentialAniArray.push(fResult1["hAniName"]);
					}
					else{
						_potentialAniArray.push(fResult0["hAniName"]);
					}
					break;
				case "freeMv":
					fResult0 = runFreeMv(moveX,pControl["hMvSpeed"].velX,fWalkSpeed,fWalkSpeed,fWalkSpeed,fKeyboardTester.getKeyOnHash().hLeft,fKeyboardTester.getKeyOnHash().hRight,fKeyboardTester.getDoubleTapHash().hLeft,fKeyboardTester.getDoubleTapHash().hRight,fKeyboardTester.getKeyOnHash().hDown,pTimePassed);
					fResult1 = runFreeMv(moveY,pControl["hMvSpeed"].velY,fWalkSpeed,fWalkSpeed,fWalkSpeed,fKeyboardTester.getKeyOnHash().hUp,fKeyboardTester.getKeyOnHash().hDown,fKeyboardTester.getDoubleTapHash().hUp,fKeyboardTester.getDoubleTapHash().hDown,fKeyboardTester.getKeyOnHash().hRight,pTimePassed);
					if(fResult0["hAniName"]=="stand" && fResult1["hAniName"]=="stand"){
						_potentialAniArray.push("stand");
					}
					else{
						_potentialAniArray.push("walk");
					}
					//runFreeMv(moveX,0,fWalkSpeed,fRunSpeed,fKeyboardTester.getKeyOnHash().hLeft,fKeyboardTester.getKeyOnHash().hRight,fKeyboardTester.getDoubleTapHash().hLeft,fKeyboardTester.getDoubleTapHash().hRight,pTimePassed);
					//runFreeMv(moveY,0,fWalkSpeed,fRunSpeed,fKeyboardTester.getKeyOnHash().hUp,fKeyboardTester.getKeyOnHash().hDown,fKeyboardTester.getDoubleTapHash().hUp,fKeyboardTester.getDoubleTapHash().hDown,pTimePassed);
					break;
			}
		}
		private function runFreeMv(pMvFunc:Function,pVelCrnt:Number,pWalkSpeed:Number,pRunSpeed:Number,pCrawlSpeed:Number,pNegKeyOn:Boolean,pPosKeyOn:Boolean,pNegDblKeyOn:Boolean,pPosDblKeyOn:Boolean,pCrawlKeyOn:Boolean,pTimePassed:int):Object{
			
			var fMoveAction = null;
			var fMoveActionDirection:String = null;
			var fVelNew:Number = 0;
			var fChangeDirectionFacingOn:Boolean = false;
			
			if (_airDashOn) {
				fMoveAction = "airDash";//Doesn't matter since runJumpMv will take precidence in animation assignment
				switch(_airDashDir){
					case "left":
						fVelNew = -_airDashSpeed;
						pMvFunc(pTimePassed, fVelNew,0);
						if(_directionFacing == "right" && mChangeDirectionOn){
							changeDirectionFacing();
							fChangeDirectionFacingOn = true;
						}
						break;
					case "right":
						fVelNew = _airDashSpeed;
						pMvFunc(pTimePassed, fVelNew,0);
						if(_directionFacing == "left" && mChangeDirectionOn){
							changeDirectionFacing();
							fChangeDirectionFacingOn = true;
						}
						break;
				}
			}
			else{
				//****************LEFT AND RIGHT ARROW OR !LEFT AND !RIGHT ARROW***********************
				if ((pPosKeyOn && pNegKeyOn)||
					(!pPosKeyOn && !pNegKeyOn)) {//If both or neither left and right arrows are pressed at same time, dont do anything
					if(pCrawlKeyOn){
						fMoveAction = "duck";
					}
					else{
						fMoveAction = "stand"
					}
					fMoveActionDirection = null;
				}
				else {
					//****************LEFT ARROW***********************
					if (pNegKeyOn) {//Move left
						fMoveActionDirection = "left";
						//If double tapped and run not already activated
						if(pCrawlKeyOn)fMoveAction = "crawl";
						else if (pNegDblKeyOn)fMoveAction = "run";
						else fMoveAction = "walk";
					}
					//****************RIGHT ARROW***********************
					if (pPosKeyOn) {//Move right
						fMoveActionDirection = "right";
						//If double tapped and run not already activated
						if(pCrawlKeyOn)fMoveAction = "crawl";
						else if(pPosDblKeyOn)fMoveAction = "run";
						else fMoveAction = "walk";
					}
				}
				//*************************WALK/RUN*************************************
				switch(fMoveAction){
					case "walk":
						switch(fMoveActionDirection){
							case "left":
								fVelNew = -pWalkSpeed;
								pMvFunc(pTimePassed, fVelNew,0);//Can't use moveXWithDirectionChange because the direction change is based on the direction of the speed
								if(_directionFacing == "right" && mChangeDirectionOn){
									changeDirectionFacing();
									fChangeDirectionFacingOn = true;
								}
								break;
							case "right":
								fVelNew = pWalkSpeed;
								pMvFunc(pTimePassed, fVelNew,0);
								if(_directionFacing == "left" && mChangeDirectionOn){
									changeDirectionFacing();
									fChangeDirectionFacingOn = true;
								}
								break;
						}
						break;
					case "run":
						switch(fMoveActionDirection){
							case "left":
								fVelNew = -pRunSpeed;
								pMvFunc(pTimePassed, fVelNew,0);
								if(_directionFacing == "right" && mChangeDirectionOn){
									changeDirectionFacing();
									fChangeDirectionFacingOn = true;
								}
								break;
							case "right":
								fVelNew = pRunSpeed;
								pMvFunc(pTimePassed, fVelNew,0);
								if(_directionFacing == "left" && mChangeDirectionOn){
									changeDirectionFacing();
									fChangeDirectionFacingOn = true;
								}
								break;
						}
						break;
					case "crawl":
						switch(fMoveActionDirection){
							case "left":
								fVelNew = -pCrawlSpeed;
								pMvFunc(pTimePassed, fVelNew,0);
								if(_directionFacing == "right" && mChangeDirectionOn){
									changeDirectionFacing();
									fChangeDirectionFacingOn = true;
								}
								break;
							case "right":
								fVelNew = pCrawlSpeed;
								pMvFunc(pTimePassed, fVelNew,0);
								if(_directionFacing == "left" && mChangeDirectionOn){
									changeDirectionFacing();
									fChangeDirectionFacingOn = true;
								}
								break;
						}
						break;
					case "stand":
					case "duck":
						fVelNew = 0;
						break;
					default:
						fVelNew = 0;
						break;
				}
			}
			_crntAniName = fMoveAction;
			return {hVel:fVelNew,hAniName:fMoveAction,hChangeDirOn:fChangeDirectionFacingOn};
		}
		private var crntGravityVel:Number = 0;
		private function runGravity(pMvFunc:Function, pGravity:Number, pTimePassed:uint) {
			if(!_airDashOn){
				pMvFunc(pTimePassed, crntGravityVel, pGravity);			
				if(_airOn){
					crntGravityVel += pGravity*(pTimePassed/1000);
				}
				else{
					crntGravityVel = 0;
				}
			}
		}
		private var _crntAirDashHeld:Number = 0;
		private var _jumpNumMax:int = 2;
		private var _jumpNumCrnt:int = 0;
		private var _jumpLock:Boolean = false;
		private var _airDashOn:Boolean = false;
		private var _airDashMax:Number = 1;
		private var _airDashDir:String = "";
		private var _airDashCounter:Number = 0;
		private var _airDashHeldMax:Number = 700;
		private var _airDashSpeed:Number = 200;
		private var _airDashRunLock:Boolean = false;//When running and then jumping, prevent it from going straight into air dash
		private function runJumpMv(pMvFunc:Function,pVelCrnt:Number,pJumpSpeed:Number,pGravity:Number,pDropSpeed:Number,pFloatSpeed:Number,pJumpKeyOn:Boolean,pDropKeyOn:Boolean,pAirDashKeyOnL:Boolean,pAirDashKeyOnR:Boolean,pTimePassed:uint):Object{
			var fAniName:String = null;
			if(!_airOn){
				floatOn = false;
				crntJumpHeld = 0;
				_jumpNumCrnt = 0;
				
			}
			else{
				crntJumpHeld += pTimePassed;
			}
			if (pJumpKeyOn) {
				if (!_airOn || !_jumpLock) {
					_jumpNumCrnt++;
					_jumpLock = true;
					crntJumpHeld = 0;
				}
				if((crntJumpHeld < JUMP_HELD_DUR || !_airOn) && _jumpNumCrnt <= _jumpNumMax){//Jump Hold
					pVelCrnt = pJumpSpeed;
//					pMvFunc(pTimePassed,pJumpSpeed,0);
					crntGravityVel = pVelCrnt;
					fAniName = "jump";
					//this.velY = baseVelY;
				}
				else if(pVelCrnt+crntGravityVel > 0){//Float down
					floatOn = true;
					pVelCrnt = pFloatSpeed;
//					pMvFunc(pTimePassed,pFloatSpeed,0);
					crntGravityVel = pVelCrnt;
					//this.crntAni.changeAni(_crntGraphic,"startFloat","endFloat",250,gameTimeFunc,0,null);
					fAniName = "float";
				}
				else{//Normal Jump
					floatOn = false;
					pVelCrnt = 0;
//					pMvFunc(pTimePassed,pVelCrnt,pGravity);
//					pVelCrnt += pGravity*(pTimePassed/1000);
					crntJumpHeld = JUMP_HELD_DUR;
					fAniName = "jump";
				}
			}
			else {
				_jumpLock = false;
				if (_airOn) {//Normal Fall
					floatOn = false;
					pVelCrnt = 0;
	//				pMvFunc(pTimePassed,pVelCrnt,pGravity);
	//				pVelCrnt += pGravity*(pTimePassed/1000);
					crntJumpHeld = JUMP_HELD_DUR;
					fAniName = "jump";
				}
			}
			if(pDropKeyOn && _airOn){//Drop
				if(!dropOn){
					pVelCrnt = 0;
				}
				dropOn = true;				
				crntJumpHeld = JUMP_HELD_DUR;
				pMvFunc(pTimePassed,pDropSpeed,0);
				fAniName = "drop";
				//this.crntAni.changeAni(_crntGraphic,"startDrop","endDrop",250,gameTimeFunc,0,null);
			}
			var fAirDashKeyOn:Boolean = false;
			if (_airDashOn) {
				fAirDashKeyOn = true;
			}
			else {
				if(pAirDashKeyOnL || pAirDashKeyOnR){
					if (_airDashDir == "left" && pAirDashKeyOnR || _airDashDir == "right" && pAirDashKeyOnL || pAirDashKeyOnL && pAirDashKeyOnR) {
					}
					else {
						fAirDashKeyOn = true;
					}
				}
			}
			if (!pAirDashKeyOnL && !pAirDashKeyOnR) {
				_airDashRunLock = false;
				//fAirDashKeyOn = false;
			}
			if (fAirDashKeyOn && !_airDashRunLock && _airOn && !pDropKeyOn && !pJumpKeyOn && (_airDashCounter < _airDashMax) && (_crntAirDashHeld < _airDashHeldMax)) {
				_crntAirDashHeld += pTimePassed;
				_airDashOn = true;
				pVelCrnt = 0;
				crntGravityVel = 0;
				fAniName = "airDash";
				if (pAirDashKeyOnR) _airDashDir = "right";
				else if (pAirDashKeyOnL) _airDashDir = "left";
				fAniName = "airDash";
			}
			else {
				_airDashDir = "";
				_crntAirDashHeld = 0;
				if (_airDashOn) {
					_airDashCounter++;
				}
				_airDashOn = false;
			}
			if (!_airOn) {
				if (pJumpKeyOn && (pAirDashKeyOnL || pAirDashKeyOnR)) {//If jumping while running
					_airDashRunLock = true;
				}
				else{_airDashRunLock = false;}
				_airDashDir = "";
				_crntAirDashHeld = 0;
				_airDashCounter = 0;
				dropOn = false;
//				if(crntAni.getAniName()=="startDrop"){
//					this.crntAni.changeAni(_crntGraphic,"startStand","endStand",400,gameTimeFunc,0,null);
//				}
			}
			return {hVel:pVelCrnt,hAniName:fAniName};
		}
		private function startLinear(pControl:Object){
			var fMvSpeed:MvSpeed = pControl["hMvSpeed"];
			var fVel:Number;
			var fAcc:Number;
			var fAngle:Number;
			var fXDist:Number = pControl["hDef"]["hXDist"];
			var fYDist:Number = pControl["hDef"]["hYDist"];
			var fSpread:Number = pControl["hDef"]["hSpread"];
			var fFixedSpread:Number = pControl["hDef"]["hFixedSpread"];
			if(_mCAlignXY["hY"]=="bottom"){//Fix for graphic Align
				//pControl["hDef"]["hYDist"] += _crntGraphicStandHeight/2;
				//fYDist = pControl["hDef"]["hYDist"];
			}
			if(!(pControl["hDef"]["hFixedSpread"] is Number)){
				fFixedSpread = 0;
			}
			if(pControl["hDef"]["hVel"]!=null && pControl["hDef"]["hAcc"]!=null){
				fVel = pControl["hDef"]["hVel"];
				fAcc = pControl["hDef"]["hAcc"];
			}
			else if(pControl["hDef"]["hTravelTime"]!=null){
				var fTravelTime:Number = pControl["hDef"]["hTravelTime"]/1000;
				var fTravelDist:Number = Math.sqrt(Math.pow(fXDist,2)+Math.pow(fYDist,2));
				if(pControl["hDef"]["hMinDist"] is Number){
					if(fTravelDist < pControl["hDef"]["hMinDist"]){fTravelDist=pControl["hDef"]["hMinDist"]}
				}
				if(pControl["hDef"]["hMaxDist"] is Number){
					if(fTravelDist > pControl["hDef"]["hMaxDist"]){fTravelDist=pControl["hDef"]["hMaxDist"]}
				}
				if(pControl["hDef"]["hFinalVel"] is Number){
					var fInitVel:Number = (2*fTravelDist/fTravelTime)-pControl["hDef"]["hFinalVel"];
					fVel = fInitVel;
					fAcc = (pControl["hDef"]["hFinalVel"]-fInitVel)/fTravelTime;
				}
				else{
					fVel = fTravelDist/fTravelTime;
					fAcc = 0;
				}
			}
			var fInverseOn:Boolean = false;
			if(pControl["hDef"]["hAngle"] is Number){//A hardcoded angle\
				fInverseOn = pControl["hDef"]["hDirectionFacingOn"] && _directionFacing == "left";
				fAngle = pControl["hDef"]["hAngle"]*(2*Math.PI/360);
			}
			else{
				fInverseOn = fXDist<0;
				fAngle = Math.atan(fYDist/fXDist);
			}
			fAngle = fAngle + (fFixedSpread+(-fSpread + 2*fSpread*Math.random()))*(2*Math.PI/360);
			var fVelX:Number = Math.cos(fAngle)*fVel;
			var fVelY:Number = Math.sin(fAngle)*fVel;
			var fAccX:Number = Math.cos(fAngle)*fAcc;
			var fAccY:Number = Math.sin(fAngle)*fAcc;
			if(fInverseOn){
				fMvSpeed.velX = -fVelX;
				fMvSpeed.velY = -fVelY;
				fMvSpeed.accX = -fAccX;
				fMvSpeed.accY = -fAccY;
				//this.accX = pAcc*fXYRatio;
			}
			else{
				fMvSpeed.velX = fVelX;
				fMvSpeed.velY = fVelY;
				fMvSpeed.accX = fAccX;
				fMvSpeed.accY = fAccY;

				//this.accX = -pAcc*fXYRatio;
			}
		}
		public function runLinear(pControl:Object,pTimePassed:uint){
			moveX(pTimePassed,pControl["hMvSpeed"].velX,pControl["hMvSpeed"].accX);
			moveY(pTimePassed,pControl["hMvSpeed"].velY,pControl["hMvSpeed"].accY);
			pControl["hMvSpeed"].velX += pControl["hMvSpeed"].accX*(pTimePassed/1000);
			pControl["hMvSpeed"].velY += pControl["hMvSpeed"].accY*(pTimePassed/1000);
		}
		public function runPattern(pControl:Object,pTimePassed:uint){
			var fXMvArray:Array = pControl["hDef"]["hXMvArray"];
			var fYMvArray:Array = pControl["hDef"]["hYMvArray"];
			var fXInverseOn:Boolean;
			if(pControl["hDef"]["hXInverseOn"] is Boolean){
				fXInverseOn = pControl["hDef"]["hXInverseOn"];
			}
			else{
				fXInverseOn = false;
			}

//			if (totalTimeElapsed >= duration && duration != -1) {
//				kill();
//			}
//			else{
				if (fXMvArray is Array) {
					pControl["hMvElapsedX"] += pTimePassed;
					var fDurationX:Number = fXMvArray[pControl["hCrntMvNumX"] * 4 + 3];
					if (fDurationX > 0) {
						if (pControl["hMvElapsedX"] >= fDurationX) {
							pControl["hCrntMvNumX"]++;
							pControl["hMvElapsedX"] -= fDurationX;
							var fTimeProperX:Number = (pTimePassed - pControl["hMvElapsedX"])/1000;//Time without the overflow
							if (!fXInverseOn) {//Overflow
								//this.velX += fTimeProperX * this.accX;
								trueMoveX(fTimeProperX * pControl["hMvSpeed"].velX + .5 * pControl["hMvSpeed"].accX * Math.pow(fTimeProperX, 2));
							}
							else {
								//this.velX += -fTimeProperX * this.accX;
								trueMoveX(-(fTimeProperX * pControl["hMvSpeed"].velX + .5 * pControl["hMvSpeed"].accX * Math.pow(fTimeProperX, 2)));
							}
							if (pControl["hCrntMvNumX"] * 4 >= fXMvArray.length) {
								pControl["hCrntMvNumX"] = 0;
							}
							var fVelAtOverflowX:Number;
							if(!fXInverseOn){
								
								//this.mvSpeed.addMvSpeed({hName:"horizontal",hVelX:fXMvArray[pControl["hCrntMvNumX"] * 4],hAccX:fXMvArray[pControl["hCrntMvNumX"] * 4 + 2],hVelY:0,hAccY:0,hTier:0},"add");
								pControl["hMvSpeed"].velX = fXMvArray[pControl["hCrntMvNumX"] * 4];
								pControl["hMvSpeed"].accX = fXMvArray[pControl["hCrntMvNumX"] * 4 + 2];
								fVelAtOverflowX = pControl["hMvSpeed"].velX + pControl["hMvElapsedX"]/1000 * pControl["hMvSpeed"].accX;
								trueMoveX(-(fTimeProperX * fVelAtOverflowX + .5*pControl["hMvSpeed"].accX*Math.pow(fTimeProperX,2)));
							}
							else {
//								this.mvSpeed.addMvSpeed({hName:"horizontal",hVelX:-fXMvArray[pControl["hCrntMvNumX"] * 4],hAccX:-fXMvArray[pControl["hCrntMvNumX"] * 4 + 2],hVelY:0,hAccY:0,hTier:0},"add");
								pControl["hMvSpeed"].velX = -fXMvArray[pControl["hCrntMvNumX"] * 4];
								pControl["hMvSpeed"].accX = -fXMvArray[pControl["hCrntMvNumX"] * 4 + 2];
								fVelAtOverflowX = pControl["hMvSpeed"].velX + pControl["hMvElapsedX"]/1000 * pControl["hMvSpeed"].accX;
								trueMoveX(fTimeProperX * fVelAtOverflowX + .5*pControl["hMvSpeed"].accX*Math.pow(fTimeProperX,2));
							}
						}
					}
					moveX(pTimePassed,pControl["hMvSpeed"].velX,pControl["hMvSpeed"].accX);
					pControl["hMvSpeed"].velX +=  pControl["hMvSpeed"].accX * (pTimePassed/1000);					
				}
				if (fYMvArray is Array) {
					pControl["hMvElapsedY"] += pTimePassed;
					var fDurationY:Number = fYMvArray[pControl["hCrntMvNumY"] * 4 + 3];
					if (fDurationY > 0) {
						if (pControl["hMvElapsedY"] >= fDurationY) {
							pControl["hCrntMvNumY"]++;
							pControl["hMvElapsedY"] -= fDurationY;
							var fTimeProperY:Number = (pTimePassed - pControl["hMvElapsedY"])/1000;
							//this.velY += fTimeProperY * this.accY;
							trueMoveY(fTimeProperY * pControl["hMvSpeed"].velY + .5*pControl["hMvSpeed"].accY*Math.pow(fTimeProperY,2));
							if (pControl["hCrntMvNumY"] * 4 >= fYMvArray.length) {
								pControl["hCrntMvNumY"] = 0;
							}
//							this.mvSpeed.addMvSpeed({hName:"vertical",hVelX:0,hAccX:0,hVelY:fYMvArray[pControl["hCrntMvNumY"] * 4],hAccY:fYMvArray[pControl["hCrntMvNumY"] * 4 + 2],hTier:0},"add");
							pControl["hMvSpeed"].velY = fYMvArray[pControl["hCrntMvNumY"] * 4];
							pControl["hMvSpeed"].accY = fYMvArray[pControl["hCrntMvNumY"] * 4 + 2];
							var fVelAtOverflowY:Number = pControl["hMvSpeed"].velY + pControl["hMvElapsedY"]/1000 * pControl["hMvSpeed"].accY;
							//trace("CHANGE",this.y, this.velY, fVelAtOverflowY);
							trueMoveY(-(fTimeProperY * fVelAtOverflowY + .5*pControl["hMvSpeed"].accY*Math.pow(fTimeProperY,2)));
						}
					}
					moveY(pTimePassed,pControl["hMvSpeed"].velY,pControl["hMvSpeed"].accY);
					pControl["hMvSpeed"].velY +=  pControl["hMvSpeed"].accY * (pTimePassed/1000);
				}
//			}
		}
		public function startFreeFall(pControl:Object){
			if(pControl["hDef"]["hInverseOn"] == true){
				pControl["hMvSpeed"].velX = -pControl["hDef"]["hXVel"];
			}
			else{
				pControl["hMvSpeed"].velX = pControl["hDef"]["hXVel"];
			}
			pControl["hMvSpeed"].velY = pControl["hDef"]["hYVel"];
			pControl["hMvSpeed"].accY = pControl["hDef"]["hGravity"];
			_airDashOn = false;
		} 

		public function runFreeFall(pControl:Object,pTimePassed:uint):Boolean{
			moveX(pTimePassed,pControl["hMvSpeed"].velX,pControl["hMvSpeed"].accX);
			moveY(pTimePassed,pControl["hMvSpeed"].velY,pControl["hMvSpeed"].accY);
			pControl["hMvSpeed"].velY +=  pControl["hMvSpeed"].accY * (pTimePassed / 1000);
			_potentialAniArray.push("stunned");
			if(!_airOn && crntGravityVel>0){
				return true;
			}
			return false;
		}
		public function startMouseAim(pMC:MovieClip,pDispX:Number=0,pDispY:Number=0){
			if(pMC){
				//var fAimPoint:Point = new Point(_crntGraphic.getChildAt(i).x,_crntGraphic.getChildAt(i).y);
				//fAimPoint = _crntGraphic.getChildAt(i).localToGlobal(fAimPoint);
				var fMouseX:Number = this.x + pDispX - Main.getMain().mouseX;
				var fMouseY:Number = this.y + pDispY - Main.getMain().mouseY;
				if(_directionFacing == "right"){
					if(fMouseX < 0){
						pMC.rotation = Math.atan(fMouseY/fMouseX)*(360/(2*Math.PI));
					}
					else{
						pMC.rotation = 180 + Math.atan(fMouseY/fMouseX)*(360/(2*Math.PI));
					}
				}
				else{
					fMouseX = this.x - pDispX - Main.getMain().mouseX;
					if(pMC.scaleX < 0){//(Since Rotation is not affected by scaling)The current MC has been directly scaled
						if(fMouseX < 0){
							pMC.rotation = 180 + Math.atan(fMouseY/fMouseX)*(360/(2*Math.PI));
						}
						else{
							pMC.rotation = Math.atan(fMouseY/fMouseX)*(360/(2*Math.PI));
						}
					}
					else{
						if(fMouseX >= 0){//(Since Rotation is not affected by scaling)The current MC has been indirectly scaled by a parent MC
							pMC.rotation = -Math.atan(fMouseY/fMouseX)*(360/(2*Math.PI));
						}
						else{
							pMC.rotation = -180 - Math.atan(fMouseY/fMouseX)*(360/(2*Math.PI));
						}
					}
				}
			}
		}
		public function get mouseAimName():String{
			return _mouseAimName;
		}
		public function set mouseAimName(s:String){
			_mouseAimName = s;
		}
		public function get mvSpeed():MvSpeed{
			return _mvSpeed;
		}
		public function get airOn():Boolean{
			return _airOn;
		}
		public function set airOn(pB:Boolean){
			_airOn = pB;
		}
		public function get crntGraphic():MovieClip{
			return _crntGraphic;
		}		
		public function get crntGraphicInner():MovieClip {
			_crntGraphicInner = null;
			if (_crntGraphicInner_Array != null) {
				for (var i:uint = 0; i < _crntGraphic.numChildren; i++) {
					for(var j:uint = 0; j < _crntGraphicInner_Array.length; j++) {
						if (getQualifiedClassName(_crntGraphic.getChildAt(i)) == _crntGraphicInner_Array[j]) {
							_crntGraphicInner = MovieClip( _crntGraphic.getChildAt(i));
							return _crntGraphicInner;
						}
					}
				}
			}
			return _crntGraphicInner;
		}

		public function get crntAni():MovieClip{
			return _crntAni;
		}
		public function get crntGraphicStandWidth():Number{
			return _crntGraphicStandWidth;
		}
		public function get crntGraphicStandHeight():Number{
			return _crntGraphicStandHeight;
		}
		public function get directionFacing():String{
			return _directionFacing;
		}
	}
}