﻿package{
	public class FadeTransition extends MovieClip{
		private var transitionBG:TransitionBG;
		//TRANSITION++++++++++++++++++++++++++++++++++++++++++++++++++++
		public function createTransition(pTransitionMidFunc:Function,pTransitionPostGameMode:String="battleArea"){
			if(transitionOn){
				removeTransition();
			}
			if(!transitionOn){
				transitionOn = true;
				gameMode = "transition";
				transitionPostGameMode = pTransitionPostGameMode;
				transitionMidFunc=pTransitionMidFunc;
				if(!Boolean(transitionBG)){
					transitionBG = new TransitionBG();
				}
				if(transitionBG.parent==null){
					this.addChild(transitionBG);
					transitionBG.width = stage.stageWidth;
					transitionBG.height = stage.stageHeight;
					transitionBG.x=0;
					transitionBG.y=stage.stageHeight;
				}
				transitionBG.alpha = 0;
				transitionBG.visible=true;
				setChildIndex(transitionBG,numChildren-1);
				addEventListener(Event.ENTER_FRAME, transitionTime);
				if(bGSoundEffect!=null){
					bGSoundEffect.startFadeOutSoundEffect(transDuration/2);
				}
				lastTimeTrans = getTimer();
				keyDownOn = false;//Turn off keys
			}
		}
		private function transitionTime(e:Event){
			//start by turn light -> dark 
			if(getTimer()-lastTimeTrans<transDuration/2){
				transitionBG.alpha = (getTimer()-lastTimeTrans)/(transDuration/2);
			}
			//end by turn dark -> light
			else if(getTimer()-lastTimeTrans>=transDuration/2 && getTimer()-lastTimeTrans<=transDuration){
				//Call the function
				if(!transitionMidFuncOn){
					transitionMidFunc();
					transitionMidFuncOn = true;
					
					if(transitionBG.parent==null){//In case it is removed by transitionMidFunc() (e.g. unloadAll, reset, etc.)
						this.addChild(transitionBG);
						transitionBG.width = stage.stageWidth;
						transitionBG.height = stage.stageHeight;
						transitionBG.x=0;
						transitionBG.y=stage.stageHeight;
						transitionBG.visible = true;
					}
					//Make sure transitionBG is on top
					var topPosition:int = this.numChildren - 1;
					if(topPosition>=0){
						this.setChildIndex(transitionBG, topPosition);
					}
				}
				transitionBG.alpha = 1-(getTimer()-lastTimeTrans-transDuration/2)/(transDuration/2);
			}
			else if(getTimer()-lastTimeTrans>transDuration){
				removeTransition();
			}
		}
		private function removeTransition(){
			transitionOn = false;
			if(gameMode == "transition"){
				gameMode = transitionPostGameMode;
			}
			transitionMidFuncOn = false;
			transitionBG.visible=false;
			removeEventListener(Event.ENTER_FRAME, transitionTime);
			keyDownOn = true;//Turn keys back on
		}
	}		
}