﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	public class KeyboardTester extends MovieClip{
		private var keyCodeArray:Array = null;
		private var keyOnArray:Array = new Array(0);
		private var keyPressOnArray:Array = new Array(0);
		private var firstPressOnArray:Array = new Array(0);
		private var doubleTapArray:Array = new Array(0);
		private var lastTimeDoubleTapArray:Array = new Array(0);
		
		private var keyCodeHash:Object = null;
		private var keyOnHash:Object = null;
		private var keyPressOnHash:Object = null;
		private var firstPressOnHash:Object = null;
		private var doubleTapHash:Object = null;
		private var lastTimeDoubleTapHash:Object = null;
		
		private var doubleTapDelay:Number = 100;
		public function KeyboardTester(pKeyCodeSomething:Object, pStage:Stage){
			if(pKeyCodeSomething is Array){
				keyCodeArray = pKeyCodeSomething as Array;
				for(var i:uint=0;i<keyCodeArray.length;i++){
					keyOnArray.push(false);
					keyPressOnArray.push(false);
					firstPressOnArray.push(true);
					doubleTapArray.push(false);
					lastTimeDoubleTapArray.push(getTimer());
				}
				addEventListener(Event.ENTER_FRAME,checkPress);
				pStage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownFunc);
				pStage.addEventListener(KeyboardEvent.KEY_UP,keyUpFunc);
			}
			else if(pKeyCodeSomething is Object){
				keyCodeHash = pKeyCodeSomething;
				keyOnHash = convertHash(keyCodeHash,false);
				keyPressOnHash = convertHash(keyCodeHash,false);
				firstPressOnHash = convertHash(keyCodeHash,true);
				doubleTapHash = convertHash(keyCodeHash,false);
				lastTimeDoubleTapHash = convertHash(keyCodeHash,getTimer());
				pStage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownHashFunc);
				pStage.addEventListener(KeyboardEvent.KEY_UP,keyUpHashFunc);
				addEventListener(Event.ENTER_FRAME,checkPressHash);
			}			
		}
		private function convertHash(pHash:Object, pNewValue:*):Object{
			var fNewHash:Object = Clone.doClone(pHash);
			for(var i in fNewHash){
				fNewHash[i] = pNewValue;
			}
			return fNewHash;
		}
		private function checkPressHash(e:Event){
			for(var i in keyCodeHash){
				keyPressOnHash[i] = false;
				if(keyOnHash[i] && firstPressOnHash[i]){
					keyPressOnHash[i] = true;
					firstPressOnHash[i] = false;
				}
				else{
					keyPressOnHash[i] = false;
				}
			}
		}
		private function keyDownHashFunc(e:KeyboardEvent){
			for(var i in keyCodeHash){
				if(e.keyCode == keyCodeHash[i]){
					keyOnHash[i] = true;
					if(getTimer()-lastTimeDoubleTapHash[i]<doubleTapDelay){
						doubleTapHash[i] = true;
					}
				}
			}
		}
		private function keyUpHashFunc(e:KeyboardEvent){
			for(var i in keyCodeHash){
				if(e.keyCode == keyCodeHash[i]){
					keyPressOnHash[i] = false;
					keyOnHash[i] = false;
					doubleTapHash[i] = false;
					firstPressOnHash[i] = true;
					lastTimeDoubleTapHash[i] = getTimer();
				}
			}
		}
		private function checkPress(e:Event){
			for(var i:uint=0;i<keyCodeArray.length;i++){
				keyPressOnArray[i] = false;
				if(keyOnArray[i] && firstPressOnArray[i]){
					keyPressOnArray[i] = true;
					firstPressOnArray[i] = false;
				}
				else{
					keyPressOnArray[i] = false;
				}
			}
		}
		private function keyDownFunc(e:KeyboardEvent){
			for(var i:uint=0;i<keyCodeArray.length;i++){
				if(e.keyCode == keyCodeArray[i]){
					keyOnArray[i] = true;
					if(getTimer()-lastTimeDoubleTapArray[i]<doubleTapDelay){
						doubleTapArray[i] = true;
					}
				}
			}
		}
		private function keyUpFunc(e:KeyboardEvent){
			for(var i:uint=0;i<keyCodeArray.length;i++){
				if(e.keyCode == keyCodeArray[i]){
					keyPressOnArray[i] = false;
					keyOnArray[i] = false;
					firstPressOnArray[i] = true;
					doubleTapArray[i] = false;
					lastTimeDoubleTapArray[i] = getTimer();
				}
			}
		}
		public function getKeyOnHash():Object{
			return keyOnHash;
		}
		public function getKeyPressOnHash():Object{
			return keyPressOnHash;
		}
		public function getDoubleTapHash():Object{
			return doubleTapHash;
		}
		
		public function getKeyOnArray(pEle:uint):Boolean{
			return keyOnArray[pEle];
		}
		public function getKeyPressOnArray(pEle:uint):Boolean{
			return keyPressOnArray[pEle];
		}
		public function getDoubleTapArray(pEle:uint):Boolean{
			return doubleTapArray[pEle];
		}
	}
}