﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	import flash.geom.Point;
	import flash.media.Sound;
	import flash.media.SoundTransform;
	import flash.geom.ColorTransform;
	import flash.filters.*;
	import fl.motion.Color;

	public class PhysObj extends ControlObj{
		private var _physObjDef:PhysObjDef = new PhysObjDef();
		private var _physObjName:String;
		private var _physObjCreator:PhysObj;
		private var _physObjCreatorOrigin:Object = {hX:0,hY:0};
		
		private var _crntGraphic:MovieClip;
		private var _crntGraphicStandWidth:Number;
		private var _crntGraphicStandHeight:Number;
		private var _crntAni:Animation = new Animation([]);
		private var _curseSymbol:CurseSymbol = new CurseSymbol();
		
		private var gameTimeFunc:Function;
		
		private var moveOn:Boolean = true;
		private var _airOn:Boolean = false;
		private var _velX:Number = 0;
		private var _velMaxX:Number = 99999;
		private var _accX:Number = 0;
		
		private var _velY:Number = 0;
		private var _velMaxY:Number = 99999;
		private var _accY:Number = 0;
		
		private var crntVelX:Number = 0;
		private var maxVelX:Number = 0;
		
		private var crntVelY:Number = 0;
		private var maxVelY:Number = 0;
		
		private var velAddArrayX:Array = new Array(0);
		private var velAddArrayY:Array = new Array(0);
		
		private var borderCoord:Object = {hLeft:0,hTop:0,hRight:720,hBottom:405};
		
		private var _directionFacing:String = "right";
		
		private var edgeDistance:Number = 360;
		private var stageFocusOn:Boolean = false;
		
		private var _skillEquipArray:Array = new Array(0);;//[n]=[[n]=PhysObjName, [n+1]=Counter]...
		public function get skillEquipArray():Array{
			return _skillEquipArray;
		}
		private var _skillEquipCrnt:uint = 0;
		public function get skillEquipCrnt():uint{
			return _skillEquipCrnt;
		}
		private var _skillCommandHash:Object = new Object();
		public function get skillCommandHash():Object{
			return _skillCommandHash;
		}
		private var _selectedSkillObj:Object;
		public function get selectedSkillObj():Object{
			return _selectedSkillObj;
		}
		public function set selectedSkillObj(p:Object){
			_selectedSkillObj = p;
		}
		private var _talents:Object = {MysteryBox:{hHatPerc:3}};
		public function get talents():Object{
			return _talents;
		}
		//For causing dmg
		private var _team:String = null;
		private var _dmgType:String = "opponent";//"none" (Avatar shoud use this),"same","all"
		private var _dmgBase:Number = 1;
		private var _hitMult:Number = 1;//Dmg taken, increased and decreased by * or / in Damage
		private var _hitMultArray:Array = new Array(0);
		private var hitMultColor:ColorTransform = new ColorTransform(1,1,1,1,255,0,255);
		private var defaultColor:ColorTransform = new ColorTransform(1,1,1,1,0,0,0);
		private var _skill:Skill = new Skill();
		private var _damage:Damage;
		private var _timedEffectArray:Array = new Array(0);//Stores TimedEffects (e.g. hitMult effect)
		private var _timedEffectCastArray:Array = new Array(0);//Stores cast timedEffects
		
		//For taking dmg
		private var _hitRules:Array = new Array(0);//[n]=Hittable?, [n+1]=Dmg Ratio, [[n]=Exception Child MC Name, [n+1]=Hittable?, [n+2]=Dmg Ratio],...
		private var _hPCrnt:Number = 1;
		private var _hPMax:Number = 20;
		private var _deathOn:Boolean = false;
		
		private var lastTimeAutoMove:Number = 0;
		
		public function PhysObj(pPOName:String,pGameTimeFunc:Function,pCreator:PhysObj=null){
			var i:uint=0;
			_physObjDef.setPhysObjDef(pPOName);
			if(pCreator!=null){
				_physObjCreator = pCreator;
				if(_physObjDef.startFunc!=null)_physObjDef.startFunc(_physObjCreator);
				if(physObjDef.aOPlayerStickOn){
					_physObjCreatorOrigin["hX"] = _physObjCreator.x;
					_physObjCreatorOrigin["hY"] = _physObjCreator.y;
				}
			}
			else{
				_physObjCreator = this;
			}
			if(_physObjDef.mCName is String){
				super(_physObjDef.mCName,_physObjDef.mCNameInner_Array,_physObjDef.mCAlignXY,_physObjDef.aniMvHash,_physObjDef.gravity,pGameTimeFunc,_physObjDef.mCScaleXY);
			}
			_curseSymbol.x = this.x;
			switch(_physObjDef.mCAlignXY["hY"]){
				case "bottom":
					_curseSymbol.y = -this.crntGraphicStandHeight;
					break;
				case "mid":
					_curseSymbol.y = -this.crntGraphicStandHeight/2;
					break;
			}
			addChild(_curseSymbol);
			_curseSymbol.visible = false;
			_hPCrnt = _physObjDef.hPMax;
			_hPMax = _physObjDef.hPMax;
			_physObjName = pPOName;
			_dmgBase = _physObjDef.dmgBase;
			_damage = new Damage(this,Main.getMain().ptBStorageArray);
			this.borders = _physObjDef.borders;
			_skillEquipArray = Clone.doClone(_physObjDef.skillEquipArray);
			var fPhysObjDef:PhysObjDef = new PhysObjDef();
			var fCounter:Counter;
			for(i=0; i<_skillEquipArray.length; i++){
				fPhysObjDef = new PhysObjDef();
				fPhysObjDef.setPhysObjDef(_skillEquipArray[i]["hName"]);
				fCounter = new Counter(-1,fPhysObjDef.cooldown,fPhysObjDef.multiple,pGameTimeFunc,_physObjDef.initalShotDelay);
				_skillEquipArray[i]["hCounter"] = fCounter;
				_skillEquipArray[i]["hPhysObjDef"] = fPhysObjDef;
				_skillEquipArray[i]["hTotalShots"] = 0;
			}
			for(i=1;i<=4;i++){
				_skillCommandHash["hSkill"+String(i)] = new Object();
				switch(i){
					case 1:
						_skillCommandHash["hSkill"+String(i)]["hName"] = "Movin' On Up";
						break;
					case 2:
						_skillCommandHash["hSkill2"]["hName"] = "GhostRing";
						break;
					default:
						_skillCommandHash["hSkill2"]["hName"] = "GhostRing";
						break;
				}
				fPhysObjDef = new PhysObjDef();
				fPhysObjDef.setPhysObjDef(_skillCommandHash["hSkill"+String(i)]["hName"]);
				fCounter = new Counter(-1,fPhysObjDef.cooldown,fPhysObjDef.multiple,pGameTimeFunc,_physObjDef.initalShotDelay);
				_skillCommandHash["hSkill"+String(i)]["hCounter"] = fCounter;
				_skillCommandHash["hSkill"+String(i)]["hPhysObjDef"] = fPhysObjDef;
			}
			
			var fPhysObjDefSpecial:PhysObjDef = new PhysObjDef();
			fPhysObjDefSpecial.setPhysObjDef(_physObjDef.specialSkillName);
			if(_physObjDef.specialSkillName!=null){
				var fSpecialCounter:Counter = new Counter(-1,fPhysObjDefSpecial.cooldown,fPhysObjDefSpecial.multiple,pGameTimeFunc);
				//fSpecialCounter.counterOn = true;
				_specialSkill = {hName:_physObjDef.specialSkillName, hOn:false, hCounter:fSpecialCounter};
			}
			//_skill.setSkill(_physObjDef.skillName);
			gameTimeFunc = pGameTimeFunc;
			lastTimeAutoMove = pGameTimeFunc();
			lastTimeExist = pGameTimeFunc();
			this.faceXForwardOn = _physObjDef.faceXForwardOn;
			this.faceForwardOn = _physObjDef.faceForwardOn;
			this.faceMouseAlwaysOn = _physObjDef.faceMouseAlwaysOn;
			this.faceMouseOn = _physObjDef.faceMouseOn;
			if(_physObjDef.aniPattern.length>0){
				this.startAniPattern(_physObjDef.aniPattern);
			}
		}
		private var lastTimeExist:uint;

		public function physObjLoop(){
			this.runActions();
			this.runSkills();
			if(_physObjCreator != null && physObjDef.aOPlayerStickOn){
				var fXDif:Number = _physObjCreator.x-_physObjCreatorOrigin["hX"];
				var fYDif:Number = _physObjCreator.y-_physObjCreatorOrigin["hY"];
				trueMoveX(fXDif);
				trueMoveY(fYDif);
				_physObjCreatorOrigin["hX"] = _physObjCreator.x;
				_physObjCreatorOrigin["hY"] = _physObjCreator.y;
			}
			for(var i:int=0; i<_skillEquipArray.length; i++){
				_skillEquipArray[i]["hCounter"].counting();
			}
			if(_specialSkill!=null){
				_specialSkill["hCounter"].counting();
			}
			if(_physObjDef.facePlayerDirectionAlwaysOn){
				if(this.directionFacing!=_physObjCreator.directionFacing){
					this.changeDirectionFacing();
				}
			}
			var fTotalHitMult:Number = calcTotalHitMult();

			if(fTotalHitMult != 1){
				_curseSymbol.txtRatio.text = String(Math.round(fTotalHitMult*10)/10) + "x";
				_curseSymbol.visible = true;
				if(this.crntGraphic.transform.colorTransform.color != hitMultColor.color){
					this.crntGraphic.transform.colorTransform = hitMultColor;
				}
			}
			else if(this.crntGraphic.transform.colorTransform != defaultColor){
				this.crntGraphic.transform.colorTransform = defaultColor;
				_curseSymbol.visible = false;
			}
			//autoMoveFunc();
			if(_physObjDef.duration > -1){
				if(gameTimeFunc()-lastTimeExist >= _physObjDef.duration){
					_deathOn = true;
				}
			}
			var fBoundsHit:Object = this.checkBounds();
			if ((_physObjDef.deathBorders["hLeft"] && fBoundsHit["hLeft"]) ||
				(_physObjDef.deathBorders["hRight"] && fBoundsHit["hRight"]) ||
				(_physObjDef.deathBorders["hTop"] && fBoundsHit["hTop"]) ||
				(_physObjDef.deathBorders["hBottom"] && fBoundsHit["hBottom"]) ) {
					_deathOn = true;
				}
		}
		private function startDeath(){
			_skillEquipArray = new Array(0);
		}
		private var _keyboard:KeyboardTester;
		public function set keyboard(k:KeyboardTester){
			_keyboard = k;
		}
		private var _specialSkill:Object = null;
		public function get specialSkill():Object{
			return _specialSkill;
		}
		public function set specialSkill(s:Object){
			_specialSkill = s;
		}
		private var _weapSwitchDelayOn:Boolean = false;
		public function get weapSwitchDelayOn():Boolean{
			return _weapSwitchDelayOn;
		}
		private var timedEffectWeapSwitchDelay:TimedEffect;
		private function runSkills(){
			if(_keyboard!=null){
				var i:uint=0;
				var fPO:PhysObj = this;
				if(_keyboard.getKeyPressOnHash()["hSkillChangeF"]){
					if(_skillEquipArray.length>0){
						_skillEquipCrnt = (_skillEquipCrnt+1)%_skillEquipArray.length;
						if(timedEffectWeapSwitchDelay!=null){
							if(timedEffectWeapSwitchDelay.effectOn){
								timedEffectWeapSwitchDelay.forceEnd();
							}
						}
						timedEffectWeapSwitchDelay = new TimedEffect(function(){_weapSwitchDelayOn = true},function(){_weapSwitchDelayOn = false},_physObjDef.weapSwitchDelay,gameTimeFunc);
						timedEffectWeapSwitchDelay.start();
					}
				}
				if(_keyboard.getKeyPressOnHash()["hSkillChangeB"]){
					if(_skillEquipArray.length>0){
						if(_skillEquipCrnt == 0){
							_skillEquipCrnt = _skillEquipArray.length-1;
						}
						else{
							_skillEquipCrnt--;
						}
						if(timedEffectWeapSwitchDelay!=null){
							if(timedEffectWeapSwitchDelay.effectOn){
								timedEffectWeapSwitchDelay.forceEnd();
							}
						}
						timedEffectWeapSwitchDelay = new TimedEffect(function(){_weapSwitchDelayOn = true},function(){_weapSwitchDelayOn = false},_physObjDef.weapSwitchDelay,gameTimeFunc);
						timedEffectWeapSwitchDelay.start();
					}
				}
				for(var j in _skillCommandHash){
					if(_keyboard.getKeyPressOnHash()[j]){
						_selectedSkillObj = _skillCommandHash[j];
					}
				}
				if(_keyboard.getKeyOnHash().hSpecial){
					_specialSkill["hCounter"].counterOn = true;
					_specialSkill["hOn"] = true;
				}
				else{
					_specialSkill["hCounter"].counterOn = false;
				}
//				var fNameArray:Array = ["hSkill1","hSkill2","hSkill3","hSkill4"];
//				for(i=0;i<fNameArray.length;i++){
//					if(_keyboard.getKeyOnHash()[fNameArray[i]]){
//						skillCommandHash[fNameArray[i]]["hOn"] = true;
//					}
//				}
			}
		}
		private var _invOn:Boolean = false;
		public function get invOn():Boolean{
			return _invOn;
		}
		public function set invOn(b:Boolean){
			_invOn = b;
		}
		private var timedEffectInv:TimedEffect;
		public function startInv(pDuration:Number):void{
			if(timedEffectInv!=null){
				if(timedEffectInv.effectOn){
					timedEffectInv.forceEnd();
				}
			}
			var fPO:PhysObj = this;
			timedEffectInv = new TimedEffect(function(){_invOn = true;fPO.alpha=.5},function(){_invOn = false;fPO.alpha=1},pDuration,gameTimeFunc);
			timedEffectInv.start();
		}
		public function calcTotalHitMult():Number{
			var fTotal:Number = 1;
			for(var i:uint=0;i<_hitMultArray.length;i++){
				fTotal*=_hitMultArray[i];
			}
			return fTotal;
		}
		public function removePhysObj():void {
			var i:uint;
			_crntGraphic = null;
			_hitMultArray = null;
			_skillEquipArray = null;
			_skillCommandHash = null;
			_selectedSkillObj = null;
			_talents = null;
			_crntAni.removeAni();
			_crntAni = null;
			velAddArrayX = null;
			velAddArrayY = null;
			for (i = 0; i < _timedEffectArray.length; i++) {
				_timedEffectArray[i].end();
			}
			_timedEffectArray = new Array(0);
			for (i = 0; i < _timedEffectCastArray.length; i++) {
				_timedEffectCastArray[i].end();
			}
			_timedEffectCastArray = new Array(0);
			_hitRules = null;
			_keyboard = null;
			_specialSkill = null;
			timedEffectInv = null;
			_damage.removeDamage();		
			_damage = null;
			this.removeControlObj();
		}
		/*********************************************************
							MOVEMENT
		**********************************************************/
//		private function setAreaEnds(event:Event){
//			if (this.x > stage.stageWidth-edgeDistance) {//If avatar is more than the right edge distance, 
//				rightEnd = true;//it is at the right end
//			}			
//			if (this.x < edgeDistance) {//If avatar is more than the right edge distance, 
//				leftEnd = true;//it is at the right end
//			}		
//			removeEventListener(Event.ENTER_FRAME, setAreaEnds);
//		}
		public function addVelX(pVel:Number){
			velAddArrayX.push(pVel);
		}
		public function removeVelX(pVel:Number){
			ArrayHelper.findAndRemove(velAddArrayX,pVel);
		}
		public function addVelY(pVel:Number){
			velAddArrayY.push(pVel);
		}
		public function removeVelY(pVel:Number){
			ArrayHelper.findAndRemove(velAddArrayY,pVel);
		}
		public static function compareTeams(pAttacker:PhysObj,pVictim:PhysObj):Boolean{
			if(pAttacker.dmgType=="all" || (pAttacker.dmgType=="opponent"&&pAttacker.team!=pVictim.team) || (pAttacker.dmgType=="same"&&pAttacker.team==pVictim.team)){
				return true;
			}
			return false;
		}
		public function get physObjDef():PhysObjDef{
			return _physObjDef;
		}
		public function get physObjName():String{
			return _physObjName;
		}
		public function get physObjCreator():PhysObj{
			return _physObjCreator;
		}
		public function set physObjCreator(p:PhysObj){
			_physObjCreator = p;
		}
		public function get hitRules():Array{
			return _hitRules;
		}
		public function set hitRules(a:Array){
			_hitRules = a;
		}
		public function get dmgType():String{
			return _dmgType;
		}
		public function set dmgType(a:String){
			_dmgType = a;
		}
		public function get dmgBase():Number{
			return _dmgBase;
		}
		public function get hPMax():Number {
			return _hPMax;
		}
		public function get hitMult():Number{
			return _hitMult;
		}
		public function set hitMult(n:Number){
			_hitMult = n;
		}
		public function get hitMultArray():Array{
			return _hitMultArray;
		}
		public function get timedEffectArray():Array{
			return _timedEffectArray;
		}
		public function get timedEffectCastArray():Array{
			return _timedEffectCastArray;
		}
		public function get team():String{
			return _team;
		}
		public function set team(a:String){
			_team = a;
		}
		public function get deathOn():Boolean{
			return _deathOn;
		}
		public function set deathOn(pB:Boolean){
//			if(!_deathOn && pB){
//				removeEventListener(Event.ENTER_FRAME, physObjLoop);
//				//if(this.parent!=null){
//					this.parent.removeChild(this);
//				//}
//				delete this;
//			}
			_deathOn = pB;
		}
		public function get skill():Skill{
			return _skill;
		}
		public function set skill(pB:Skill){
			_skill = pB;
		}
		public function get damage():Damage{
			return _damage;
		}
		public function set damage(pB:Damage){
			_damage = pB;
		}
		public function get hPCrnt():Number{
			return _hPCrnt;
		}
		public function set hPCrnt(pB:Number){
			_hPCrnt = pB;
		}
	}
}