﻿package{
	import flash.display.*;
	
	//Definition of the MC, movement, coordinates, and skill of PhysObj
	public class PhysObjDef extends MovieClip{
		private var _physObjName:String;
		private var _startFunc:Function;
		private var _mCName:String;
		private var _mCNameInner_Array:Array;
		private var _mCAlignXY:Object = {hX:"mid",hY:"bottom"};//How the MC is aligned (relative to the origin point)
		private var _mCScaleXY:Object = {hX:1,hY:1};
		private var _physObjType:String = "player";
		private var _autofireOn:Boolean = false;
		private var _castTime:Number = 0;
		private var _activateTime:Number = 0;
		private var _hPMax:Number = 1;
		private var _pointBurstOn:Boolean = true;//If PointBurst is displayed
		private var _dmgBase:Number = 1;//Always positive unless want everything to have an opposite effect
		private var _selfDmg:Number = 0;//Amount of dmg dealt to self when hitting another PO
		private var _dmgRules:Array = new Array(0);// Cause dmg: [n]={hHitOn:Hittable?, hDmgRatio:Dmg Ratio, hSkillName:}, [n+1]={hName:Exception Child MC Name, hHitOn:Hittable?, hDmgRatio:Dmg Ratio, hSkillName:},...
		private var _hitRules:Array = new Array(0);// Take dmg:  [n]={hHitOn:Hittable?, hDmgRatio:Dmg Ratio}, [n+1]={hName:Exception Child MC Name, hHitOn:Hittable?, hDmgRatio:Dmg Ratio},...
		private var _dispPlayerReferenceOn:Object = {hXOn:true,hYOn:true};//true = initialDisp hX or hY value references the player instead of stage
		private var _bulletOrigin:Object = {hX:0,hY:0};
		private var _initialDisp:Object = {hX:0,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};//hMouseXOn = x follows mouseX within the minLimX to maxLimX distance from the creator
		private var _weapSwitchDelay:int = 400;
		
		//Creator effects
		private var _recoil:Object;
		private var _inv:int = 0;//Invincibility duration
		
		//private var _moveDef:Array = new Array(0);//"linear":[0]=Velocity,[1]=Acc. "pattern":[0]=xMvArray,[1]=yMvArray
		private var _moveDef:Object = { hType:"pattern", hDef: { hXMvArray:[0, null, 0, 1000], hYMvArray:[0, null, 0, 1000] }};//"linear":hVel:#,hAcc:#,hSpread=0-180,hFixedSpread=0-180 "pattern":[0]=xMvArray,[1]=yMvArray
		private var _mouseAimOn:Boolean = false;//If moveDef is linear and the owner is avatar, it's forced automatic mouseAim (in Main), else it can be forced on here. Otherwise, linear follows a player.
		private var _faceXForwardOn:Boolean = false;//Face horizontal direction only
		private var _faceForwardOn:Boolean = false;//Face direction of velocity
		private var _faceMouseOn:Boolean = false;//Face mouse when created
		private var _faceMouseAlwaysOn:Boolean = false;//Constantly face mouse
		private var _faceMouseDirectionOn:Boolean = false;//DirectionFacing upon creation is relative to the mouse position vs. creator PO position
		private var _facePlayerDirectionAlwaysOn:Boolean = false;//Changes direction with its creator
		private var _aOPlayerStickOn:Boolean = false;//AO sticks to player
		private var _gravity:Number = 0;//0 = no gravity;
		private var _skillEquipArray:Array = new Array(0);//[n]=[[n]=PhysObjName, [n+1]=Counter=null(set in PhysObj]...
		private var _skillCommmandHash:Object;
		private var _specialSkillName:String = null;//E skill
		private var _duration:Number = -1;//-1 = infinite duration
		private var _cooldown:Number;//Amount of time b4 can create physObj again
		private var _initalShotDelay:Number = 0;//Amount of time before able to shoot initially (ex: for Surpise Box)
		private var _multiple:uint = 1;//Number of PhysObj fired at once
		private var _multipleSpread:Array = new Array(0);//[n]=fixed angle 0, [n+1]=fixed angle 1...
		private var _shotsMax:int = -1;//Number of shots a PO can take, -1 = infinite
		private var _borders:Object = {hLeft:false,hTop:false,hRight:false,hBottom:true};//Physical blocking
		private var _deathBorders:Object = {hLeft:false,hTop:false,hRight:false,hBottom:false};//Death past borders
		private var _aniPattern:Array = new Array(0);//
		private var _aniMvHash:Object = {hStand:{hFreq:1000},hDuck:{hFreq:1000},hWalk:{hFreq:1000},hRun:{hFreq:1000},hCrawl:{hFreq:1000},hJump:{hFreq:1000},hDrop:{hFreq:1000},hFloat:{hFreq:1000},hAirDash:{hFreq:1000},hStunned:{hFreq:500},hDeath:{hFreq:1000}}
		private var _control:Object;
		private var _linearMv:Object = {};//{hTravelTime:0,hMinDist:0,hMaxDist:0}
		
		private var _vertCondSkill:Object = null;//{hUpName:SkillName,hDownName:SkillName} different skills dependent on whether click was above or below avatar
		
		private var _chainSkillArray:Array = new Array(0);
		private var _transformArray:Array = new Array(0);
		
		private var numHolder0:Number = 0;//Simply to hold numbers
		private var numHolder1:Number = 0;
		
		public function PhysObjDef(){
		}
		public function setPhysObjDef(pName:String){
			_physObjName = pName;
			switch(pName){
				case "BulletDefault":
					_pointBurstOn = false;
					_selfDmg = -1;
					_hitRules = [{hHitOn:false,hDmgRatio:0}];
					_mCAlignXY = {hX:"mid",hY:"mid"};
					break;
				case "Dog":
					_mCName = "Ghost";
					_mCAlignXY = {hX:"mid",hY:"mid"};
					_mCScaleXY = {hX:.4,hY:.4};
					_hPMax = 100;
					_bulletOrigin = {hX:9,hY:0}
					_weapSwitchDelay = 250;
					_gravity = 800;
					_skillEquipArray = [{hName:"MysteryBox"},{hName:"Fire"},{hName:"DualChop"}];
					_specialSkillName = "Movin' On Up";
					_hitRules = [{hHitOn:true,hDmgRatio:1},{hName:"Heart",hHitOn:true,hDmgRatio:1}];
					//_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:"Bark"},{hName:"Heart",hHitOn:false,hDmgRatio:1,hSkillName:"Bark0"}];
					_borders = {hLeft:true,hTop:true,hRight:true,hBottom:true};
					_control = {hMvType:"jump",hJumpPlane:"y",hWalkSpeed:75,hRunSpeed:125,hCrawlSpeed:40,hJumpSpeed:-400,hDropSpeed:300,hFloatSpeed:50,hGravity:800};
					break;
				case "Ghost0":
					_mCName = "Ghost";
					_mCAlignXY = {hX:"mid",hY:"mid"};
					_mCScaleXY = {hX:.25,hY:.25};
					_hPMax = 1;
					_bulletOrigin = {hX:0,hY:0};
					_weapSwitchDelay = 250;
					_gravity = 0;
					_skillEquipArray = [{hName:"DualChop"},{hName:"LineCurse"},{hName:"MultiGhost"}];
					_skillCommmandHash = {hKey1:"Fire",hKey2:"Curse",hKey3:"DualChop"};
					_specialSkillName = "Movin' On Up";
					_hitRules = [{hHitOn:true,hDmgRatio:1},{hName:"Heart",hHitOn:true,hDmgRatio:1}];
					//_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:"Bark"},{hName:"Heart",hHitOn:false,hDmgRatio:1,hSkillName:"Bark0"}];
					_borders = {hLeft:true,hTop:true,hRight:true,hBottom:true};
					_control = {hMvType:"freeMv",hWalkSpeed:75,hRunSpeed:125,hCrawlSpeed:40,hGravity:0};
					break;
				case "Onion":
					_mCName = "OnionWhole";
					_mCAlignXY = {hX:"mid",hY:"bottom"};
					_mCScaleXY = {hX:1,hY:1};
					_hPMax = 3;
					_bulletOrigin = {hX:0,hY:-26};
					_weapSwitchDelay = 250;
					_gravity = 1600;
					_skillEquipArray = [{hName:"Onion Toss"},{hName:"Onion Launcher"},{hName:"Onion Crusher"}];
					_skillCommmandHash = {hKey1:"Fire",hKey2:"Curse",hKey3:"DualChop"};
					_specialSkillName = "Movin' On Up";
					_pointBurstOn = false;
					_hitRules = [{hHitOn:true,hDmgRatio:1},{hName:"Heart",hHitOn:true,hDmgRatio:1}];
					//_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:"Bark"},{hName:"Heart",hHitOn:false,hDmgRatio:1,hSkillName:"Bark0"}];
					_borders = { hLeft:true, hTop:true, hRight:true, hBottom:true };
					_faceXForwardOn = false;
					_aniMvHash = {hStand:{hFreq:1000},hDuck:{hFreq:1000},hWalk:{hFreq:780},hRun:{hFreq:500},hCrawl:{hFreq:500},hJump:{hFreq:1000},hDrop:{hFreq:400},hFloat:{hFreq:500},hAirDash:{hFreq:300},hStunned:{hFreq:500},hDeath:{hFreq:1000}}
					_control = {hMvType:"jump",hJumpPlane:"y",hWalkSpeed:125,hRunSpeed:200,hCrawlSpeed:40,hJumpSpeed:-600,hDropSpeed:400,hFloatSpeed:0,hGravity:800};
					break;
				case "FarmerBob1":
					_mCName = "FarmerBobAni";
					_mCNameInner_Array = ["FarmerBobWalkAni","FarmerBobFlipAni","StickBoyBody"];
					_hPMax = 10;
					_hitRules = [{hHitOn:false,hDmgRatio:0},{hName:"FarmerBobWalkAni",hHitOn:true,hDmgRatio:1},{hName:"FarmerBobFlipAni",hHitOn:true,hDmgRatio:1},{hName:"StickBoyBody",hHitOn:true,hDmgRatio:1},{hName:"StickBoyTorso",hHitOn:true,hDmgRatio:1},{hName:"StickBoyArmL",hHitOn:true,hDmgRatio:1},{hName:"StickBoyArmR",hHitOn:true,hDmgRatio:1},{hName:"StickBoyLegL",hHitOn:true,hDmgRatio:1},{hName:"StickBoyLegR",hHitOn:true,hDmgRatio:1},{hName:"StickBoyHead",hHitOn:true,hDmgRatio:1},{hName:"StickBoyRed",hHitOn:true,hDmgRatio:1},{hName:"StickBoyGiantLeap",hHitOn:true,hDmgRatio:1}];
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"}];
					//_skillEquipArray = [{hName:"Bullet"}];
					//_moveDef = {hType:"pattern",hDef:{hXMvArray:[100,null,0,1000],hYMvArray:[0,null,0,1000]}};
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
					_aniPattern = ["pattern1", "pattern1", 0, 999999999];
					_aniMvHash["hDeath"] = { hFreq:2000 };
					_transformArray = ["FarmerBob2", "death"];
					break;
				case "FarmerBob2":
					_mCName = "FarmerBobAni";
					_mCNameInner_Array = ["FarmerBobWalkAni","FarmerBobFlipAni","StickBoyBody"];
					_hPMax = 40;
					_hitRules = [{hHitOn:false,hDmgRatio:0},{hName:"FarmerBobWalkAni",hHitOn:true,hDmgRatio:1},{hName:"FarmerBobFlipAni",hHitOn:true,hDmgRatio:1},{hName:"StickBoyBody",hHitOn:true,hDmgRatio:1},{hName:"StickBoyTorso",hHitOn:true,hDmgRatio:1},{hName:"StickBoyArmL",hHitOn:true,hDmgRatio:1},{hName:"StickBoyArmR",hHitOn:true,hDmgRatio:1},{hName:"StickBoyLegL",hHitOn:true,hDmgRatio:1},{hName:"StickBoyLegR",hHitOn:true,hDmgRatio:1},{hName:"StickBoyHead",hHitOn:true,hDmgRatio:1},{hName:"StickBoyRed",hHitOn:true,hDmgRatio:1},{hName:"StickBoyGiantLeap",hHitOn:true,hDmgRatio:1}];
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"}];
					//_skillEquipArray = [{hName:"Bullet"}];
					//_moveDef = {hType:"pattern",hDef:{hXMvArray:[100,null,0,1000],hYMvArray:[0,null,0,1000]}};
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
					_aniPattern = ["pattern1", "endPattern1", 1, 7000,"pattern2", "endPattern2", 1, 5000, "pattern3", "endPattern3", 1, 15000];
					_transformArray = ["FarmerBob3", "death"];
					break;
				case "FarmerBob3":
					_mCName = "FarmerBobAni2";
					_mCNameInner_Array = ["FarmerBobWalkAni","FarmerBobFlipAni","StickBoyBody"];
					_hPMax = 100;
					_hitRules = [{hHitOn:false,hDmgRatio:0},{hName:"FarmerBobWalkAni",hHitOn:true,hDmgRatio:1},{hName:"FarmerBobFlipAni",hHitOn:true,hDmgRatio:1},{hName:"StickBoyBody",hHitOn:true,hDmgRatio:1},{hName:"StickBoyTorso",hHitOn:true,hDmgRatio:1},{hName:"StickBoyArmL",hHitOn:true,hDmgRatio:1},{hName:"StickBoyArmR",hHitOn:true,hDmgRatio:1},{hName:"StickBoyLegL",hHitOn:true,hDmgRatio:1},{hName:"StickBoyLegR",hHitOn:true,hDmgRatio:1},{hName:"StickBoyHead",hHitOn:true,hDmgRatio:1},{hName:"StickBoyRed",hHitOn:true,hDmgRatio:1},{hName:"StickBoyGiantLeap",hHitOn:true,hDmgRatio:1}];
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"}];
					//_skillEquipArray = [{hName:"Bullet"}];
					//_moveDef = {hType:"pattern",hDef:{hXMvArray:[100,null,0,1000],hYMvArray:[0,null,0,1000]}};
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
					_aniPattern = ["pattern4", "endPattern4", 1, 15000, "pattern5", "endPattern5", 1, 15000, "pattern6", "endPattern6", 1, 10000];
					_transformArray = ["FarmerBob4", "death"];
					break;
				case "Gnome":
					_mCName = "Gnome";
					_mCScaleXY = {hX:.5,hY:.5};
					_hPMax = 75;
					_hitRules = [{hHitOn:false,hDmgRatio:0},{hName:"GnomeFace",hHitOn:true,hDmgRatio:1}];
					_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:null},{hName:"GnomeHat",hHitOn:true,hDmgRatio:1,hSkillName:"Bark0"}];
					_gravity = 800;
					//_moveDef = [[50,null,0,1000, 0,null,0,1000],[-400,null,800,1000, 0,null,0,1000]];
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[45,null,0,1000, 45,null,0,1000],hYMvArray:[0,null,0,1000, 0,null,800,1000]}};
					_aniPattern = ["startStand","endStand",4,1000, "startJump","endJump",1,1000];

					break;
				case "Valeo":
					_mCName = "Valeo";
					_hPMax = 1;
					_hitRules = [{hHitOn:true,hDmgRatio:0},{hName:"ValeoHead",hHitOn:true,hDmgRatio:1}];
					_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:"Bark"},{hName:"Heart",hHitOn:false,hDmgRatio:1,hSkillName:"Bark"}];
					//_moveDef = [[50,null,0,1000, 0,null,0,1000],[-400,null,800,1000, 0,null,0,1000]];
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[0,null,0,400, 60,null,0,1000],hYMvArray:[0,null,0,400, -400,null,800,1000]}};
					_aniPattern = ["startJump0","endJump0",1,400, "startJump1","endJump1",1,200, "startJump2","endJump2",3,800];
					break;
				case "HomingBaby":
					_mCName = "Baby";
					_hPMax = 15;
					_hitRules = [{hHitOn:false,hDmgRatio:0}];
					_moveDef = [400,0];
//					_moveDef = [[0,null,0,400, 60,null,0,1000],[0,null,0,400, -400,null,800,1000]];
					_aniPattern = ["startFly","endFly",0,1000];
					break;
				case "Baby":
					_mCName = "Baby";
					_hPMax = 15;
					_hitRules = [{hHitOn:true,hDmgRatio:1}];
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Bark0"}];
					_skillEquipArray = [{hName:"Bullet"}];
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[100,null,0,1000],hYMvArray:[0,null,0,1000]}};
//					_moveDef = [[0,null,0,400, 60,null,0,1000],[0,null,0,400, -400,null,800,1000]];
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
					_aniPattern = ["startFly","endFly",0,1000];
					break;
				case "Girl":
					_mCName = "Girl";
					//_moveDef = [[50,null,0,1000, 0,null,0,1000],[-400,null,800,1000, 0,null,0,1000]];
					_moveDef = [[75,null,0,1000],[0,null,0,0]];
					//_skillEquipArray = [["Bark",null]];
					
					_cooldown = 3000;
					break;
				case "Mom":
					_mCName = "Mom";
					_hPMax = 20;
					_moveDef = [[200,null,0,3600, -200,null,0,3600],
								[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]];
					
					//_skillEquipArray = [["Girl",null]];
					
					_cooldown = 3000;
					_borders = {hLeft:true,hTop:true,hRight:true,hBottom:true};
					break;
				case "Onion Toss":
					copy("BulletDefault");
					_mCName = "RollingOnion";
					_mCScaleXY = {hX:.6,hY:.6};
					_physObjType = "bullet";
					_selfDmg = 0;
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Poke"}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					_moveDef = { hType:"linear", hDef: { hVel:170, hAcc:0, hSpread:0 }};
					//_moveDef = { hType:"pattern", hDef: { hXMvArray:[200, null, 0, 10000], hYMvArray:[ -160, null, 360, 1000] }};
					_aOPlayerStickOn = true;
					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
					//_faceMouseOn = true;
					_gravity = 200;
					_duration = 1000;
					_cooldown = 200;
					_multiple = 1;
					_borders = { hLeft:false, hTop:false, hRight:false, hBottom:true };
					_aniPattern = ["start", "end", 1, _duration];
					_aniMvHash["hDeath"]["hFreq"] = 400;
					_startFunc = function(pPO:PhysObj){}
					//_multipleSpread = [-15,0,15];
					break;
				case "Onion Crusher":
					copy("BulletDefault");
					_mCName = "OnionCrusher";
					_mCScaleXY = {hX:.7,hY:.7};
					_physObjType = "bullet";
					_selfDmg = 0;
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Poke"}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					//_moveDef = { hType:"linear", hDef: { hVel:50, hAcc:0, hSpread:0 }};
					_moveDef = { hType:"pattern", hDef: { hXMvArray:[0, null, 0, 10000], hYMvArray:[ -400, null, 0, 1750] }};
					_aOPlayerStickOn = false;
					//_faceForwardOn = true;
					_facePlayerDirectionAlwaysOn = false;
//					_faceMouseAlwaysOn = true;
					//_faceMouseOn = true;
					_gravity = 0;
					_duration = 1750;
					_cooldown = 1000;
					_multiple = 1;
					_borders = { hLeft:false, hTop:false, hRight:false, hBottom:false };
					_deathBorders = { hLeft:false, hTop:false, hRight:false, hBottom:false };
					_aniPattern = ["start", "end", 2, 2625];
					_aniMvHash["hDeath"]["hFreq"] = 0;
					_startFunc = function(pPO:PhysObj) { }
					_transformArray = ["Onion Crusher+","death"];
					//_multipleSpread = [-15,0,15];
					break;
				case "Onion Crusher+":
					copy("BulletDefault");
					_mCName = "OnionCrusher";
					_mCScaleXY = {hX:.7,hY:.7};
					_physObjType = "bullet";
					_dmgRules = [{hHitOn:true,hDmgRatio:0,hSkillName:"Bark0"}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					_moveDef = { hType:"linear", hDef: { hVel:400, hAcc:0, hSpread:0 }};
					_mouseAimOn = true;
					//_moveDef = { hType:"pattern", hDef: { hXMvArray:[0, null, 0, 10000], hYMvArray:[ 0,null,2000,100000] }};
					_aOPlayerStickOn = false;
					_faceForwardOn = true;
					_facePlayerDirectionAlwaysOn = false;
//					_faceMouseAlwaysOn = true;
					//_faceMouseOn = true;
					_gravity = 0;
					_duration = 100000;
					_cooldown = 750;
					_multiple = 1;
					_borders = { hLeft:false, hTop:false, hRight:false, hBottom:true };
					_deathBorders = { hLeft:false, hTop:false, hRight:false, hBottom:true };
					_aniPattern = ["startFall","endFall",400,100000];
					_aniMvHash["hDeath"]["hFreq"] = 400;
					_startFunc = function(pPO:PhysObj) { }
					_transformArray = ["Onion Crusher++","death"];
					//_multipleSpread = [-15,0,15];
					break;
				case "Onion Crusher++":
					copy("BulletDefault");
					_mCName = "OnionCrusher";
					_mCScaleXY = {hX:1,hY:1};
					_physObjType = "bullet";
					_selfDmg = 0;
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Bark0"}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					//_moveDef = { hType:"linear", hDef: { hVel:50, hAcc:0, hSpread:0 }};
					_moveDef = { hType:"pattern", hDef: { hXMvArray:[0, null, 0, 10000], hYMvArray:[ 100,null,-100,600] }};
					_aOPlayerStickOn = false;
					//_faceForwardOn = true;
					_facePlayerDirectionAlwaysOn = false;
//					_faceMouseAlwaysOn = true;
					//_faceMouseOn = true;
					_gravity = 0;
					_duration = 600;
					_cooldown = 750;
					_multiple = 1;
					_borders = { hLeft:false, hTop:false, hRight:false, hBottom:false };
					_deathBorders = { hLeft:false, hTop:false, hRight:false, hBottom:false };
					_aniPattern = ["startExplosion", "endExplosion", 1, 600];
					_aniMvHash["hDeath"]["hFreq"] = 400;
					_startFunc = function(pPO:PhysObj) { }
					//_multipleSpread = [-15,0,15];
					break;

				case "Onion Launcher":
					copy("BulletDefault");
					_mCName = "OnionLauncher";
					_mCScaleXY = {hX:.7,hY:.7};
					_physObjType = "bullet";
					_dmgRules = [{hHitOn:true,hDmgRatio:4,hSkillName:"Bark0"}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					_recoil = {hName:pName,hType:"linear",hDef:{hVel:-700,hAcc:1400,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					_moveDef = { hType:"linear", hDef: { hVel:1200, hAcc:0, hSpread:0 }};
//					_moveDef = { hType:"pattern", hDef: { hXMvArray:[400, null, 0, 10000], hYMvArray:[ -160, null, 360, 1000] }};
					_aOPlayerStickOn = false;
					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
					//_faceMouseOn = true;
					_gravity = 0;
					_duration = 10000;
					_cooldown = 1500;
					_multiple = 1;
					_borders = { hLeft:false, hTop:false, hRight:false, hBottom:false };
					_aniPattern = ["start", "end", 40, _duration];
					_aniMvHash["hDeath"]["hFreq"] = 400;
					_startFunc = function(pPO:PhysObj){}
					//_multipleSpread = [-15,0,15];
					break;
				case "Onion Collider":
					copy("BulletDefault");
					//_vertCondSkill = {hUpName:"FireUp",hDownName:"FireDown"};
					_mCName = "OnionCollider";
					_mCScaleXY = {hX:.4,hY:.4};
					_physObjType = "bullet";
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
//					_faceMouseOn = true;
					_initialDisp = {hX:0,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};
					_cooldown = 800;
					_faceMouseDirectionOn = true;
					_gravity = 0;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15];
					_hPMax = 1;
					_dmgRules = [{hHitOn:true,hDmgRatio:2,hSkillName:"Bark0"}];
					_aOPlayerStickOn = false;
					//_facePlayerDirectionAlwaysOn = false;
					//_moveDef = { hType:"linear", hDef: { hVel:500, hAcc: -500, hSpread:25 }};
					_moveDef = { hType:"pattern", hDef: { hXMvArray:[400, null, 0, 10000], hYMvArray:[ -700, null, 1400, 1000] }};
					_duration = 1000;
					_cooldown = 1000;
					_aniPattern = ["start","end",2,1000];
					_aniMvHash["hDeath"]["hFreq"] = 300;

					_chainSkillArray = [{hName:"Onion Collider*"}];
					_startFunc = function(pPO:PhysObj){
					}
					break;
				case "Onion Collider*":
					copy("Onion Collider");
					_chainSkillArray = new Array(0);
					_moveDef = { hType:"pattern", hDef: { hXMvArray:[400, null, 0, 1000], hYMvArray:[ 700, null, -1400, 1000] }};
					break;

				case "Onion Shotgun":
					copy("BulletDefault");
					//_vertCondSkill = {hUpName:"FireUp",hDownName:"FireDown"};
					_mCName = "RollingOnion";
					_mCScaleXY = {hX:.2,hY:.2};
					_physObjType = "bullet";
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
//					_faceMouseOn = true;
					_initialDisp = {hX:0,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};
					_cooldown = 800;
					_faceMouseDirectionOn = false;
					_gravity = 200;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15];
					_hPMax = 1;
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Bark0"}];
					_aOPlayerStickOn = false;
					//_facePlayerDirectionAlwaysOn = false;
					_moveDef = { hType:"linear", hDef: { hVel:500, hAcc:-500, hSpread:25 }};
					_duration = 500;
					_cooldown = 800;
					_aniPattern = ["start","end",1,1000];
					_aniMvHash["hDeath"]["hFreq"] = 500;

					_chainSkillArray = [{hName:"Onion Shotgun*"},{hName:"Onion Shotgun*"},{hName:"Onion Shotgun*"},{hName:"Onion Shotgun*"},{hName:"Onion Shotgun*"},{hName:"Onion Shotgun*"},{hName:"Onion Shotgun*"},{hName:"Onion Shotgun*"},{hName:"Onion Shotgun*"}];
					_startFunc = function(pPO:PhysObj){
					}
					break;
				case "Onion Shotgun*":
					copy("Onion Shotgun");
					_chainSkillArray = new Array(0);
					break;
				case "Movin' On Up":
					copy("BulletDefault");
					_mCName = null;
					_mCScaleXY = {hX:.2,hY:.2};
					_physObjType = null;
					_hPMax = 9999;
					_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:null}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[100*(1000/250),null,0,250],hYMvArray:[0,null,0,250]},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:0,hMaxDist:100,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:0,hMaxDist:300,hSpread:0,hFinalVel:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					_inv = 250;
					_moveDef = {hType:"linear",hDef:{hVel:0,hAcc:0,hSpread:0}};
					//_faceForwardOn = true;
					//_gravity = 800;
					_duration = _inv/2+500;
					_cooldown = 5000;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
					_initialDisp = {hX:50,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};
					_dispPlayerReferenceOn = {hXOn:true,hYOn:true};

//					_startFunc = function(pPO:PhysObj){
//						_mCName = null;
//						_faceMouseDirectionOn = false;
//						_aOPlayerStickOn = false;
//						_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:null}];
//						//if(pPO
//						if(true){
//							_mCName = "GhostCurseBlack";
//							_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Curse"}];
//							_faceMouseDirectionOn = false;
//							_aOPlayerStickOn = false;
//							_aniPattern = ["startNothing","endNothing",1,_inv/2,"start","end",1,500];
//						}
//					}
					//_multiple = 1;
					//_borders = {hLeft:false,hTop:false,hRight:false,hBottom:true};
					//_multipleSpread = [-15,0,15];
					break;
				case "Curse":
					copy("BulletDefault");
					//_vertCondSkill = {hUpName:"FireUp",hDownName:"FireDown"};
					_mCName = "GhostCurse";
					_physObjType = "bullet";
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
//					_faceMouseOn = true;
					_cooldown = 800;
					_faceMouseDirectionOn = true;
					_gravity = 0;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15];
					
					_startFunc = function(pPO:PhysObj){
						_mCName = "GhostCurse";
						_mCScaleXY = {hX:.1,hY:.1};
						_hPMax = 1;
						_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Curse"}];
						_aOPlayerStickOn = false;
						//_facePlayerDirectionAlwaysOn = false;
						_moveDef = {hType:"linear",hDef:{hVel:50,hAcc:0,hSpread:0}};
						_duration = 10000;
						_cooldown = 800;
						_aniPattern = ["startIni","endIni",1,500,"startCurse","endCurse",0,500];
						_aniMvHash["hDeath"]["hFreq"] = 1000;
						if(pPO.getControlByName("Movin' On Up")!=null){
							_mCName = "GhostCurseRing";
							_mCScaleXY = {hX:.2,hY:.2};
							_hPMax = 9999;
							_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"CurseRing"}];
							_aOPlayerStickOn = true;
							//_facePlayerDirectionAlwaysOn = true;
							_moveDef = {hType:"linear",hDef:{hVel:0,hAcc:0,hSpread:0}};
							_duration = 2000;
							_cooldown = 2000;
							_aniPattern = ["startIni","endIni",1,250,"start","end",0,250];
							_aniMvHash["hDeath"]["hFreq"] = 400;
						}
					}
					break;
				case "LineCurse":
					copy("BulletDefault");
					//_vertCondSkill = {hUpName:"FireUp",hDownName:"FireDown"};
					_mCName = "GhostSkull";
					_mCScaleXY = {hX:.2,hY:.2};
					_physObjType = "bullet";
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
//					_faceMouseOn = true;
					_cooldown = 800;
					_faceMouseDirectionOn = false;
					_gravity = 0;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15];
					_transformArray = ["Curse*","death"];
					
					_startFunc = function(pPO:PhysObj){
						_hPMax = 1;
						_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Curse"}];
						_aOPlayerStickOn = false;
						//_facePlayerDirectionAlwaysOn = false;
						_moveDef = {hType:"pattern",hDef:{hXMvArray:[300,null,0,10000],hYMvArray:[0,null,0,1000]}};
						_duration = 10000;
						_cooldown = 800;
						_aniPattern = ["start","end",1,500];
						_aniMvHash["hDeath"]["hFreq"] = 500;
						if(pPO.getControlByName("Movin' On Up")!=null){
							_mCName = "GhostCurseRing";
							_mCScaleXY = {hX:.2,hY:.2};
							_hPMax = 9999;
							_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"CurseRing"}];
							_aOPlayerStickOn = true;
							//_facePlayerDirectionAlwaysOn = true;
							//_moveDef = {hType:"linear",hDef:{hVel:0,hAcc:0,hSpread:0}};
							_duration = 2000;
							_cooldown = 2000;
							_aniPattern = ["startIni","endIni",1,250,"start","end",0,250];
							_aniMvHash["hDeath"]["hFreq"] = 400;
						}
					}
					break;
				case "Curse*":
					copy("BulletDefault");
					//_vertCondSkill = {hUpName:"FireUp",hDownName:"FireDown"};
					_mCName = "GhostGhost";
					_mCScaleXY = {hX:.3,hY:.3};
					_hPMax = 100;
					_physObjType = "bullet";
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
//					_faceMouseOn = true;
					_cooldown = 800;
					_faceMouseDirectionOn = false;
					_gravity = 0;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15];
					_startFunc = function(pPO:PhysObj){
						_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Curse"}];
						_aOPlayerStickOn = false;
						//_facePlayerDirectionAlwaysOn = false;
						_moveDef = {hType:"pattern",hDef:{hXMvArray:[100,null,0,10000],hYMvArray:[0,null,0,1000]}};
						_duration = 800;
						_cooldown = 800;
						_aniPattern = ["start","end",1,800];
						_aniMvHash["hDeath"]["hFreq"] = 1000;
					}
					break;
				case "MultiGhost":
					copy("BulletDefault");
					//_vertCondSkill = {hUpName:"FireUp",hDownName:"FireDown"};
					_mCName = "GhostSkull";
					_mCScaleXY = {hX:.1,hY:.1};
					_physObjType = "bullet";
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
//					_faceMouseOn = true;
					_initialDisp = {hX:0,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};
					_cooldown = 800;
					_faceMouseDirectionOn = false;
					_gravity = 0;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15];
					_hPMax = 1;
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Curse"}];
					_aOPlayerStickOn = false;
					//_facePlayerDirectionAlwaysOn = false;
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[300,null,0,10000],hYMvArray:[0,null,0,1000]}};
					_duration = 10000;
					_cooldown = 800;
					_aniPattern = ["start","end",1,500];
					_aniMvHash["hDeath"]["hFreq"] = 500;

					_chainSkillArray = [{hName:"MultiGhost*"},{hName:"MultiGhost**"},{hName:"MultiGhost***"},{hName:"MultiGhost****"}];
					_startFunc = function(pPO:PhysObj){
					}
					break;
				case "MultiGhost*":
					copy("MultiGhost");
					_initialDisp = {hX:-20,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};
					numHolder0 = 200;
					numHolder1 = .5;
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[300,null,0,10000],hYMvArray:[numHolder0/numHolder1,null,-numHolder0/Math.pow(numHolder1,2),2000*numHolder1, -numHolder0/numHolder1,null,numHolder0/Math.pow(numHolder1,2),2000*numHolder1]}};
					_chainSkillArray = new Array(0);
					break;
				case "MultiGhost**":
					copy("MultiGhost");
					_initialDisp = {hX:-20,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};
					numHolder0 = 200;
					numHolder1 = .5;
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[300,null,0,10000],hYMvArray:[-numHolder0/numHolder1,null,numHolder0/Math.pow(numHolder1,2),2000*numHolder1, numHolder0/numHolder1,null,-numHolder0/Math.pow(numHolder1,2),2000*numHolder1]}};
					_chainSkillArray = new Array(0);
					break;
				case "MultiGhost***":
					copy("MultiGhost");
					_initialDisp = {hX:-40,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};
					numHolder0 = 400;
					numHolder1 = .5;
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[300,null,0,10000],hYMvArray:[numHolder0/numHolder1,null,-numHolder0/Math.pow(numHolder1,2),2000*numHolder1, -numHolder0/numHolder1,null,numHolder0/Math.pow(numHolder1,2),2000*numHolder1]}};
					_chainSkillArray = new Array(0);
					break;
				case "MultiGhost****":
					copy("MultiGhost");
					_initialDisp = {hX:-40,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};
					numHolder0 = 400;
					numHolder1 = .5;
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[300,null,0,10000],hYMvArray:[-numHolder0/numHolder1,null,numHolder0/Math.pow(numHolder1,2),2000*numHolder1, numHolder0/numHolder1,null,-numHolder0/Math.pow(numHolder1,2),2000*numHolder1]}};
					_chainSkillArray = new Array(0);
					break;
				case "GhostRing":
					copy("BulletDefault");
					//_vertCondSkill = {hUpName:"FireUp",hDownName:"FireDown"};
					_mCName = "GhostCurse";
					_physObjType = "bullet";
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
//					_faceMouseOn = true;
					_skillEquipArray = [{hName:"Straight Bullet"}];
					_cooldown = 3000;
					_faceMouseDirectionOn = false;
					_gravity = 0;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15]
					//_transformArray = ["LineCurse","death"];
					
					_startFunc = function(pPO:PhysObj){
						_mCName = "GhostCurse";
						_mCScaleXY = {hX:.1,hY:.1};
						_hPMax = 100;
						_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Curse"}];
						_aOPlayerStickOn = false;
						//_facePlayerDirectionAlwaysOn = false;
						_moveDef = {hType:"linear",hDef:{hMinDist:0,hMaxDist:30000,hSpread:0,hVel:30,hAcc:0}};
						_duration = Math.sqrt(Math.pow(Main.getMain().getMouseX()-pPO.x,2)+Math.pow(Main.getMain().getMouseY()-pPO.y,2))/_moveDef["hDef"]["hVel"]*1000;
						_initalShotDelay = _duration;

						_aniPattern = ["startIni","endIni",1,500,"startCurse","endCurse",0,500];
						_aniMvHash["hDeath"]["hFreq"] = 1000;
						if(pPO.getControlByName("Movin' On Up")!=null){
							_mCName = "GhostCurseRing";
							_mCScaleXY = {hX:.2,hY:.2};
							_hPMax = 9999;
							_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"CurseRing"}];
							_aOPlayerStickOn = true;
							//_facePlayerDirectionAlwaysOn = true;
							//_moveDef = {hType:"linear",hDef:{hVel:0,hAcc:0,hSpread:0}};
							_duration = 2000;
							_cooldown = 2000;
							_aniPattern = ["startIni","endIni",1,250,"start","end",0,250];
							_aniMvHash["hDeath"]["hFreq"] = 400;
						}
					}
					break;
				case "Fire":
					copy("BulletDefault");
					//_vertCondSkill = {hUpName:"FireUp",hDownName:"FireDown"};
					_mCName = "BloodSword";
					_mCScaleXY = {hX:.4,hY:.4};
					_castTime = 0;
					_duration = 350;
					_hPMax = 9999;
					_physObjType = "bullet";
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[0,null,0,1000],hYMvArray:[0,null,0,1000]}};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
					_faceMouseOn = false;
					_faceMouseDirectionOn = false;
					_aOPlayerStickOn = true;
					_gravity = 800;
					_cooldown = 750;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
//					_aniPattern = ["startPoke","endPoke",1,500];
					_aniPattern = ["startPotential0","endPotential0",1,duration*.25, "startThrustUp","endThrustUp",1,duration*.75];
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15];
					
					_startFunc = function(pPO:PhysObj){
						_mCScaleXY = {hX:.4,hY:.4};
						_duration = 350;
						_cooldown = 750;
						_initialDisp = {hX:0,hY:0,hMouseXOn:false,hMinLimX:0,hMaxLimX:0,hMouseYOn:false,hMinLimY:0,hMaxLimY:0};
						_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Poke"}];
						//_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Poke"},{hName:"BloodSwordGraphic",hHitOn:false,hDmgRatio:0,hSkillName:null}];
						_dispPlayerReferenceOn = {hXOn:true,hYOn:true};
						_faceMouseOn = true;
						_aOPlayerStickOn = true;
						_chainSkillArray = new Array(0);
						if(pPO.getControlByName("Movin' On Up")!=null){
							_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"KnockBack0"},{hName:"BloodSwordGraphic",hHitOn:false,hDmgRatio:0,hSkillName:null}];
							_aniPattern = ["startPotential0","endPotential0",1,200, "startThrustUp","endThrustUp",1,300];
							_chainSkillArray = [{hName:"FireDown"}];
						}
						else if(pPO.crntAni.getAniName()=="startCrawl"||pPO.crntAni.getAniName()=="startDuck"){
							_cooldown = 250;
							_initialDisp = {hX:0,hY:0,hMouseXOn:true,hMinLimX:-1500,hMaxLimX:1500,hMouseYOn:true,hMinLimY:-1000,hMaxLimY:1000};
							_dispPlayerReferenceOn = {hXOn:false,hYOn:false};
							_aOPlayerStickOn = false;
							_faceMouseOn = false;
							//_aniPattern = ["startPotential0","endPotential0",1,200, "startThrustUp","endThrustUp",1,300];
							_aniPattern = ["startSpike","endSpike0",1,250, "endSpike0","startSpike",1,250];
						}
						else{
							_mCScaleXY = {hX:.4,hY:-.4};
							_aniPattern = ["startPotential0","endPotential0",1,duration*.25, "startThrustUp","endThrustUp",1,duration*.75];
							//_aniPattern = ["startFullSwing","endFullSwing",1,duration];
//							_aniPattern = ["startPoke","endPoke0",1,duration/2, "endPoke0","startPoke",1,duration/2];
						}
					}
					break;
				case "DualChop":
					copy("Fire");
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Poke"},{hName:"BloodSwordGraphic",hHitOn:false,hDmgRatio:0,hSkillName:null}];
					_aniPattern = ["startPotential0","endPotential0",1,duration*.25, "startThrustUp","endThrustUp",1,duration*.75];
					_chainSkillArray = [{hName:"FireDown"}];
					break;
				case "FireUp":
					copy("BulletDefault");
					_mCName = "BloodSword";
					_mCScaleXY = {hX:.4,hY:.4};
					_hPMax = 9999;
					_physObjType = "bullet";
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"KnockBack0"},{hName:"MaskCircle",hHitOn:false,hDmgRatio:0,hSkillName:null}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					_moveDef = {hType:"linear",hDef:{hVel:0,hAcc:0,hSpread:0}};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
					_faceMouseOn = true;
					_aOPlayerStickOn = true;
					_gravity = 800;
					_duration = 500;
					_cooldown = 1000;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
					_aniPattern = ["startPotential0","endPotential0",1,200, "startThrustUp","endThrustUp",1,300];
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15];
					break;
				case "FireDown":
					copy("Fire");
					_mCScaleXY = {hX:.4,hY:-.4};
					_cooldown = 750;
					_chainSkillArray = new Array(0);
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Poke"},{hName:"MaskCircle",hHitOn:false,hDmgRatio:0,hSkillName:null}];
					//_aniPattern = ["startPotential0","endPotential0",1,200, "startThrustUp","endThrustUp",1,300];
					_startFunc = null;
					break;
				case "MysteryBox":
					copy("BulletDefault");
					_mCName = "GhostBox";
					_mCScaleXY = {hX:.4,hY:.4};
					_bulletOrigin = {hX:0,hY:-50};
					_initialDisp = {hX:35,hY:0};
					_startFunc = function(pPO:PhysObj){
						if(pPO.talents[pName]["hHatPerc"] is Number){
							var fRnd:Number = Math.random();
							if(fRnd > pPO.talents[pName]["hHatPerc"]*.15){
								_skillEquipArray = new Array(0);
								_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:null},{hName:"HumanProfile",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"},{hName:"GhostBoxGraphic",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"}];
								_aniPattern = ["startAppear","endAppear",1,500, "startNormal","endNormal",1,250, "endNormal","endNormal",1,250];
							}
							else{
								fRnd = Math.random();
								if(fRnd<1/3){
									_skillEquipArray = [{hName:"Straight Bullet",hCounter:null}];
									_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:null},{hName:"HumanProfileCowboy",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"},{hName:"GhostBoxGraphic",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"}];
									_aniPattern = ["startAppear","endAppear",1,500, "startCowboy","endCowboy",1,250, "endCowboy","endCowboy",1,250];
								}
								else if(fRnd<2/3){
									_skillEquipArray = [{hName:"Straight Bullet",hCounter:null}];
									_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:null},{hName:"HumanProfileGentleman",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"},{hName:"GhostBoxGraphic",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"}];
									_aniPattern = ["startAppear","endAppear",1,500, "startGentleman","endGentleman",1,250, "endGentleman","endGentleman",1,250];
								}
								else{
									_skillEquipArray = [{hName:"Straight Bullet",hCounter:null}];
									_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:null},{hName:"HumanProfileMohawk",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"},{hName:"GhostBoxGraphic",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"}];
									_aniPattern = ["startAppear","endAppear",1,500, "startMohawk","endMohawk",1,250, "endMohawk","endMohawk",1,250];

								}
							}
						}
					}
					_skillEquipArray = [{hName:"Straight Bullet",hCounter:null}];
					_hPMax = 9999;
					_physObjType = "bullet";
					_dmgRules = [{hHitOn:false,hDmgRatio:0,hSkillName:null},{hName:"HumanProfileGentleman",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"},{hName:"GhostBoxGraphic",hHitOn:true,hDmgRatio:1,hSkillName:"KnockUp"}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					_moveDef = {hType:"linear",hDef:{hVel:0,hAcc:0,hSpread:0}};
//					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
					_faceMouseOn = false;
					_faceMouseDirectionOn = true;
					_aOPlayerStickOn = false;
					_gravity = 800;
					_duration = 1000;
					_cooldown = 1500;
					_initalShotDelay = 500;
					_multiple = 1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
					_aniPattern = ["startTopHat","startTopHat",1,2500, "startTopHat","endTopHat",1,250, "endTopHat","endTopHat",1,250];
//					_aniPattern = ["startExtend","endExtend",1,200, "startShake","endShake",1,150];
					//_multipleSpread = [-15,0,15];
					break;
				case "Straight Bullet":
					copy("BulletDefault");
					_mCName = "GhostHead";
					_mCScaleXY = {hX:.1,hY:.1};
					_physObjType = "bullet";
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Poke"}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					//_moveDef = [[500,null,0,0],[0,null,0,0]];
					_moveDef = {hType:"linear",hDef:{hVel:300,hAcc:0,hAngle:0,hDirectionFacingOn:true,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:-1};
					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
//					_faceMouseOn = true;
					_gravity = 0;
					_duration = 50000;
					_cooldown = 0;
					_multiple = 6;
					_shotsMax = 6;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
					_multipleSpread = [0,60,120,180,240,300];
					break;
				case "Bullet":
					copy("BulletDefault");
					_mCName = "Bullet";
					_mCScaleXY = {hX:1,hY:1};
					_physObjType = "bullet";
					_dmgRules = [{hHitOn:true,hDmgRatio:1,hSkillName:"Poke"}];
					//_recoil = {hName:pName,hType:"pattern",hDef:{hXMvArray:[200,null,0,3600, -200,null,0,3600],hYMvArray:[-500*(1000/1200),null,1000*Math.pow(1000/1200,2),1200]},hTier:{hTierNum:1,hType:"replace"},hDuration:7000};
					//_recoil = {hName:pName,hType:"linear",hDef:{hVel:-300,hAcc:600,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:500};
					//_recoil = {hName:pName,hType:"linear",hDef:{hTravelTime:250,hMinDist:100,hMaxDist:300,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:250};
					//_moveDef = [[500,null,0,0],[0,null,0,0]];
					//_moveDef = {hType:"linear",hDef:{hVel:200,hAcc:0,hSpread:0},hTier:{hTierNum:1,hType:"replace"},hDuration:-1};
					_moveDef = {hType:"pattern",hDef:{hXMvArray:[45,null,0,1000, 45,null,0,1000],hYMvArray:[0,null,0,1000, 0,null,800,1000]}};
					_faceForwardOn = true;
//					_faceMouseAlwaysOn = true;
//					_faceMouseOn = true;
					_gravity = 0;
					_duration = 50000;
					_cooldown = 3000;
					_multiple = 1;
					_shotsMax = -1;
					_borders = {hLeft:false,hTop:false,hRight:false,hBottom:false};
					//_multipleSpread = [0,60,120,180,240,300];
					break;
				default:
					break;
			}
		}
		public function get physObjName():String{
			return _physObjName;
		}
		public function get startFunc():Function{
			return _startFunc;
		}
		public function get mCName():String{
			return _mCName;
		}
		public function get mCNameInner_Array():Array{
			return _mCNameInner_Array;
		}
		public function get mCAlignXY():Object{
			return _mCAlignXY;
		}
		public function get mCScaleXY():Object{
			return _mCScaleXY;
		}
		public function get physObjType():String{
			return _physObjType;
		}
		public function get autofireOn():Boolean{
			return _autofireOn;
		}
		public function get castTime():Number{
			return _castTime;
		}
		public function get activateTime():Number{
			return _activateTime;
		}
		public function get hPMax():Number{
			return _hPMax;
		}
		public function get pointBurstOn():Boolean{
			return _pointBurstOn;
		}
		public function get dmgBase():Number{
			return _dmgBase;
		}
		public function get selfDmg():Number{
			return _selfDmg;
		}
		public function get dmgRules():Array{
			return _dmgRules;
		}
		public function get hitRules():Array{
			return _hitRules;
		}
		public function get dispPlayerReferenceOn():Object{
			return _dispPlayerReferenceOn;
		}
		public function get bulletOrigin():Object{
			return _bulletOrigin;
		}
		public function get initialDisp():Object{
			return _initialDisp;
		}
		public function get weapSwitchDelay():int{
			return _weapSwitchDelay;
		}
		public function get recoil():Object{
			return _recoil;
		}
		public function get inv():Number{
			return _inv;
		}
		public function get moveDef():Object{
			return _moveDef;
		}
		public function get mouseAimOn():Boolean {
			return _mouseAimOn;
		}
		public function get faceXForwardOn():Boolean{
			return _faceXForwardOn;
		}
		public function get faceForwardOn():Boolean{
			return _faceForwardOn;
		}
		public function get faceMouseOn():Boolean{
			return _faceMouseOn;
		}
		public function get faceMouseAlwaysOn():Boolean{
			return _faceMouseAlwaysOn;
		}
		public function get faceMouseDirectionOn():Boolean{
			return _faceMouseDirectionOn;
		}
		public function get facePlayerDirectionAlwaysOn():Boolean{
			return _facePlayerDirectionAlwaysOn;
		}
		public function get aOPlayerStickOn():Boolean{
			return _aOPlayerStickOn;
		}
		public function get gravity():Number{
			return _gravity;
		}
		public function get skillEquipArray():Array{
			return _skillEquipArray;
		}
		public function get specialSkillName():String{
			return _specialSkillName;
		}
		public function get duration():Number{
			return _duration;
		}
		public function get cooldown():Number{
			return _cooldown;
		}
		public function get initalShotDelay():Number{
			return _initalShotDelay;
		}
		public function get multiple():uint{
			return _multiple;
		}
		public function get multipleSpread():Array{
			return _multipleSpread;
		}
		public function get shotsMax():int{
			return _shotsMax;
		}
		public function get borders():Object{
			return _borders;
		}
		public function get deathBorders():Object{
			return _deathBorders;
		}
		public function get aniPattern():Array{
			return _aniPattern;
		}
		public function get aniMvHash():Object{
			return _aniMvHash;
		}
		public function get control():Object{
			return _control;
		}
		public function get linearMv():Object{
			return _linearMv;
		}
		public function get vertCondSkill():Object{
			return _vertCondSkill;
		}
		public function get chainSkillArray():Array{
			return _chainSkillArray;
		}
		public function get transformArray():Array{
			return _transformArray;
		}
		private function copy(pDef:String){
			var fDef:PhysObjDef = new PhysObjDef();
			fDef.setPhysObjDef(pDef);
			
			//_physObjName = fDef.physObjName;
			_startFunc = fDef.startFunc;
			_mCName = fDef.mCName;
			_mCNameInner_Array = fDef.mCNameInner_Array;
			_mCAlignXY = fDef.mCAlignXY;
			_mCScaleXY = fDef.mCScaleXY;
			_physObjType = fDef.physObjType;
			_autofireOn = fDef.autofireOn;
			_castTime = fDef.castTime;
			_activateTime = fDef.activateTime;
			_hPMax = fDef.hPMax;
			_pointBurstOn = fDef.pointBurstOn;
			_dmgBase = fDef.dmgBase;
			_selfDmg = fDef.selfDmg;
			_dmgRules = fDef.dmgRules;// Cause dmg: [n]=Hittable?, [n+1]=Dmg Ratio, [[n]=Exception Child MC Name, [n+1]=Hittable?, [n+2]=Dmg Ratio],...
			_hitRules = fDef.hitRules;// Take dmg:  [n]=Hittable?, [n+1]=Dmg Ratio, [[n]=Exception Child MC Name, [n+1]=Hittable?, [n+2]=Dmg Ratio],...
			_dispPlayerReferenceOn = fDef.dispPlayerReferenceOn;
			_bulletOrigin = fDef.bulletOrigin;
			_initialDisp = fDef.initialDisp;
			_weapSwitchDelay = fDef.weapSwitchDelay;
			_recoil = fDef.recoil;
			_inv = fDef.inv;
			_moveDef = fDef.moveDef;//"linear":[0]=Velocity,[1]=Acc. "pattern":[0]=xMvArray,[1]=yMvArray
			_mouseAimOn = fDef.mouseAimOn;
			_faceXForwardOn = fDef.faceForwardOn;
			_faceForwardOn = fDef.faceForwardOn;
			_faceMouseOn = fDef.faceMouseOn;
			_faceMouseAlwaysOn = fDef.faceMouseAlwaysOn;
			_faceMouseDirectionOn = fDef.faceMouseDirectionOn;
			_facePlayerDirectionAlwaysOn = fDef.facePlayerDirectionAlwaysOn;
			_aOPlayerStickOn = fDef.aOPlayerStickOn;
			_gravity = fDef.gravity;
			_skillEquipArray = fDef.skillEquipArray;//[n]=[[n]=PhysObjName, [n+1]=Counter=null(set in PhysObj]...
			_specialSkillName = fDef.specialSkillName;
			_duration = fDef.duration;//-1 = infinite duration
			_cooldown = fDef.cooldown;//Amount of time b4 can create physObj again
			_initalShotDelay = fDef.initalShotDelay;
			_multiple = fDef.multiple;//Number of PhysObj fired at once
			_multipleSpread = fDef.multipleSpread;//[n]=fixed angle 0, [n+1]=fixed angle 1...
			_shotsMax = fDef.shotsMax;
			_borders = fDef.borders;
			_deathBorders = fDef.deathBorders;
			_aniPattern = fDef.aniPattern;//
			_aniMvHash = fDef.aniMvHash;
			_control = fDef.control;
			_linearMv = fDef.linearMv;
			
			_vertCondSkill = fDef.vertCondSkill;
			_chainSkillArray = fDef.chainSkillArray;
			_transformArray = fDef.transformArray;
		}
	}
}