﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	import flash.geom.Point;
	import flash.media.Sound;
	import flash.media.SoundTransform;
	import flash.geom.ColorTransform;
	import flash.filters.*;
	import fl.motion.Color;

	public class PhysObj extends MovieClip{
		private var _physObjDef:PhysObjDef = new PhysObjDef();
		private var _physObjName:String;
		private var _physObjCreator:PhysObj;
		
		private var _crntGraphic:MovieClip;
		private var _crntGraphicStandWidth:Number;
		private var _crntGraphicStandHeight:Number;
		private var _crntAni:Animation = new Animation([]);
		
		private var gameTimeFunc:Function;
		
		private var moveOn:Boolean = true;
		private var _airOn:Boolean = false;
		private var _velX:Number = 0;
		private var _velMaxX:Number = 99999;
		private var _accX:Number = 0;
		
		private var _velY:Number = 0;
		private var _velMaxY:Number = 99999;
		private var _accY:Number = 0;
		
		private var crntVelX:Number = 0;
		private var maxVelX:Number = 0;
		
		private var crntVelY:Number = 0;
		private var maxVelY:Number = 0;
		
		private var velAddArrayX:Array = new Array(0);
		private var velAddArrayY:Array = new Array(0);
		
		private var borderCoord:Object = {hLeft:0,hTop:0,hRight:720,hBottom:405};
		
		private var _directionFacing:String = "right";
		
		private var edgeDistance:Number = 360;
		private var stageFocusOn:Boolean = false;
		
		private var _skillEquipArray:Array = new Array(0);;//[n]=[[n]=PhysObjName, [n+1]=Counter]...
		public function get skillEquipArray():Array{
			return _skillEquipArray;
		}
		private var _skillEquipCrnt:uint = 0;
		public function get skillEquipCrnt():uint{
			return _skillEquipCrnt;
		}
		//For causing dmg
		private var _team:String = null;
		private var _dmgType:String = "opponent";//"none" (Avatar shoud use this),"same","all"
		private var _dmgBase:Number = 1;
		private var _skill:Skill = new Skill();
		private var _bulletOrigin:Array = [0,0];
		private var _damage:Damage;
		
		//For taking dmg
		private var _hitRules:Array = new Array(0);//[n]=Hittable?, [n+1]=Dmg Ratio, [[n]=Exception Child MC Name, [n+1]=Hittable?, [n+2]=Dmg Ratio],...
		private var _hPCrnt:Number = 1;
		private var _hPMax:Number = 20;
		private var _deathOn:Boolean = false;
		
		private var lastTimeAutoMove:Number = 0;
		
		public function PhysObj(pPOName:String,pGameTimeFunc:Function,pSkillEquipArray:Array=null){
			_physObjDef.setPhysObjDef(pPOName);
			_hPCrnt = _physObjDef.hPMax;
			_hPMax = _physObjDef.hPMax;
			_physObjName = pPOName;
			_dmgBase = _physObjDef.dmgBase;
			_damage = new Damage(this,Main.getMain().ptBStorageArray);
			var FClass:Class = getDefinitionByName(_physObjDef.mCName) as Class;
			_crntGraphic = new FClass();
			addChild(_crntGraphic);
//			_crntGraphic.cacheAsBitmap = true;
			_crntGraphicStandWidth = _crntGraphic.width;
			_crntGraphicStandHeight = _crntGraphic.height;
			
			mvSpeed.addMvSpeed({hName:"gravity",hVelX:0,hAccX:0,hVelY:0,hAccY:_physObjDef.gravity,hTier:2},"add");

			_skillEquipArray = Clone.doClone(_physObjDef.skillEquipArray);
			_bulletOrigin = _physObjDef.bulletOrigin;
			for(var i:uint=0; i<_skillEquipArray.length; i++){
				var fPhysObjDef:PhysObjDef = new PhysObjDef();
				fPhysObjDef.setPhysObjDef(_skillEquipArray[i][0]);
				var fCounter = new Counter(-1,fPhysObjDef.cooldown,fPhysObjDef.multiple,pGameTimeFunc);
				_skillEquipArray[i][1] = fCounter;
			}
			_skill.setSkill(_physObjDef.skillName);
			gameTimeFunc = pGameTimeFunc;
			lastTimeAutoMove = pGameTimeFunc();
			lastTimeExist = pGameTimeFunc();
		}
		private var lastTimeExist:uint;
		public function physObjLoop(){
			for(var i:int=0; i<_skillEquipArray.length; i++){
				_skillEquipArray[i][1].counting();
			}
			autoMoveFunc();
			if(_physObjDef.duration > -1){
				if(gameTimeFunc()-lastTimeExist >= _physObjDef.duration){
					_deathOn = true;
				}
			}
		}
		private function startDeath(){
			_skillEquipArray = new Array(0);
		}
		/*********************************************************
							MOVEMENT
		**********************************************************/
//		private function setAreaEnds(event:Event){
//			if (this.x > stage.stageWidth-edgeDistance) {//If avatar is more than the right edge distance, 
//				rightEnd = true;//it is at the right end
//			}			
//			if (this.x < edgeDistance) {//If avatar is more than the right edge distance, 
//				leftEnd = true;//it is at the right end
//			}		
//			removeEventListener(Event.ENTER_FRAME, setAreaEnds);
//		}
		public function changeDirectionFacing() {
			_crntGraphic.scaleX = -_crntGraphic.scaleX;
			if (_directionFacing == "right") {
				_directionFacing = "left";
			}
			else if(_directionFacing == "left") {
				_directionFacing = "right";
			}
		}
		public function setDirectionFacing(pDirection:String) {
			if (pDirection!=_directionFacing) {
				changeDirectionFacing();
			}
		}
		public function addVelX(pVel:Number){
			velAddArrayX.push(pVel);
		}
		public function removeVelX(pVel:Number){
			ArrayHelper.findAndRemove(velAddArrayX,pVel);
		}
		public function addVelY(pVel:Number){
			velAddArrayY.push(pVel);
		}
		public function removeVelY(pVel:Number){
			ArrayHelper.findAndRemove(velAddArrayY,pVel);
		}
		private var mvSpeedArray:Array = new Array(0);
		private var _mvSpeed:MvSpeed = new MvSpeed();
		public function get mvSpeed():MvSpeed{
			return _mvSpeed;
		}
		private function autoMoveFunc(){
			var fTimePassed:int = gameTimeFunc()-lastTimeAutoMove;
			lastTimeAutoMove += fTimePassed;
			_mvSpeed.mvSpeedTimer(fTimePassed);
//			var fVelAddX:Number = ArrayHelper.getSum(velAddArrayX);
//			var fVelAddY:Number = ArrayHelper.getSum(velAddArrayY);
			var i:uint=0;
			var fVelAddX:Number = _mvSpeed.velX;
			var fVelAddY:Number = _mvSpeed.velY;
			var fAccAddX:Number = _mvSpeed.accX;
			var fAccAddY:Number = _mvSpeed.accY;
//			var fTier:uint = 0;
//			for(i=0;i<mvSpeedArray.length;i++){
//				if(mvSpeedArray.tier>fTier){
//					fTier = mvSpeedArray.tier;
//					fVelAddX = mvSpeedArray.velX;
//					fVelAddY = mvSpeedArray.velY;
//				}
//				else if(mvSpeedArray.tier==fTier){
//					fVelAddX += mvSpeedArray.velX;
//					fVelAddY += mvSpeedArray.velY;
//				}
//			}
			//trace(_mvSpeed.velY);
			_velX += (_accX+fAccAddX)*fTimePassed/1000;
			_velY += (_accY+fAccAddY)*fTimePassed/1000;
			if(_velX>_velMaxX){
				_velX = _velMaxX;
			}
			else if(_velX<-_velMaxX){
				_velX = -_velMaxX;
			}
			moveX(fTimePassed, _velX + fVelAddX, _accX+fAccAddX);
			
			if(_velY>_velMaxY){
				_velY = _velMaxY;
			}
			else if(_velY<-_velMaxY){
				_velY = -_velMaxY;
			}
			moveY(fTimePassed, _velY + fVelAddY, _accY+fAccAddY);
			if(_physObjDef.faceForwardOn){
				faceForward(_velX + fVelAddX,_velY + fVelAddY);
			}
			if(_physObjDef.borders["hBottom"]){
				if(this.y >= borderCoord["hBottom"]&&_physObjDef.mCAlignXY["hY"]=="bottom"){
					this.y = borderCoord["hBottom"];
					if(_velY > 0){
						_velY = 0;
					}
					airOn = false;
				}
				else if(this.y+_crntGraphicStandHeight/2 >= borderCoord["hBottom"]&&_physObjDef.mCAlignXY["hY"]=="mid"){
					this.y = borderCoord["hBottom"]-_crntGraphicStandHeight/2;
					if(_velY > 0){
						_velY = 0;
					}
					airOn = false;
				}
				else{
					airOn = true;
				}
			}
			if(_physObjDef.borders["hTop"]){
				if((this.y-_crntGraphicStandHeight/2<=borderCoord["hTop"]&&_physObjDef.mCAlignXY["hY"]=="mid")){
					this.y = borderCoord["hTop"]+_crntGraphicStandHeight/2;
					_velY = 0;
				}
				else if(this.y-_crntGraphicStandHeight<=borderCoord["hTop"]&&_physObjDef.mCAlignXY["hY"]=="bottom"){
					this.y = borderCoord["hTop"]+_crntGraphicStandHeight;
					_velY = 0;
				}
			}
			if(this.x <= borderCoord["hLeft"] && _physObjDef.borders["hLeft"]){
				this.x = borderCoord["hLeft"];
				_velX = 0;
			}
			if(this.x >= borderCoord["hRight"] && _physObjDef.borders["hRight"]){
				this.x = borderCoord["hRight"];
				_velX = 0;
			}
		}
		private function moveY(pTimePassed:uint, pSpeed:Number, pAcc:Number, pPositiveOn:Boolean=true,pNegativeOn:Boolean=true){
			if(moveOn){
				var fDistance:Number = pSpeed*pTimePassed/1000 + .5*pAcc*Math.pow(pTimePassed/1000,2);
				if(!pPositiveOn && fDistance>0){
					fDistance = 0;
				}
				if(!pNegativeOn && fDistance<0){
					fDistance = 0;
				}
				this.y+=fDistance;
			}
		}
		private function moveX(pTimePassed:uint, pSpeed:Number, pAcc:Number, pPositiveOn:Boolean=true,pNegativeOn:Boolean=true){
			if(moveOn){
				var fDistance:Number = pSpeed*pTimePassed/1000 + .5*pAcc*Math.pow(pTimePassed/1000,2);
				if(!pPositiveOn && fDistance>0){
					fDistance = 0;
				}
				if(!pNegativeOn && fDistance<0){
					fDistance = 0;
				}
				this.x+=fDistance;
/*
				var fCurrentBackground:Background = MovieClip(Main.getMain()).getCurrentBackground();
				if(stageFocusOn){
					//var fWallBounceOn:Boolean = false;
					if(fDistance<0){
						if(this.x - dO.width/2 < fCurrentBackground.getScrollX()){//Don't allow this to go over left end of BG
							this.x = fCurrentBackground.getScrollX() + _crntGraphicStandWidth/2;
						}
						if(MovieClip(Game.getGame()).getAvatarArray().length==0){//If single avatar
							if (this.x < edgeDistance) {//If not at left end and past edge
								fCurrentBackground.moveBackground(-fDistance);//Move background
							}
						}
						else{//If multi avatar
							if(this.x - dO.width/2 < 0){//If past the left side of stage screen
								this.x = dO.width/2;
								if(!fWallBounceOn){
									wallBounceFunc(pSpeed);
								}
							}
							else{
								fCurrentBackground.multiplePlayerFunc(Game.getGame().getPlayerCamArray());
							}
						}
					}
					else if(fDistance>0){
						if(this.x + dO.width/2 > fCurrentBackground.getScrollX() + fCurrentBackground.getBGWidth()){//Stick avatar to right end
							//WALL BOUNCE
							wallBounceFunc(pSpeed);
							fWallBounceOn = true;
							this.x = fCurrentBackground.getScrollX() + fCurrentBackground.getBGWidth() - dO.width/2;
						}
						if(MovieClip(Game.getGame()).getAvatarArray().length==0){
							if (this.x > stage.stageWidth-edgeDistance){//If not at right and past edge
								fCurrentBackground.moveBackground(-fDistance);//Move background
							}
						}
						else{
							if(this.x + dO.width/2 > stage.stageWidth){//Stick to end of screen
								this.x = stage.stageWidth - dO.width/2;
								if(!fWallBounceOn){
									wallBounceFunc(pSpeed);
								}
							}
							else{
								fCurrentBackground.multiplePlayerFunc(Game.getGame().getPlayerCamArray());
							}
						}
					}
				}
				else{
					if(fDistance<0){
						if(this.x - dO.width/2 < fCurrentBackground.getScrollX()){//Don't allow this to go over left end
							//WALL BOUNCE
							wallBounceFunc(pSpeed);
							this.x = fCurrentBackground.getScrollX() + dO.width/2;
						}
						if(ArrayHelper.contains(Game.getGame().getPlayerCamArray(),this)){//If multi avatar
							if(this.x - dO.width/2 < 0){//If past the left side of stage screen
								this.x = dO.width/2;
								if(!fWallBounceOn){
									wallBounceFunc(pSpeed);
								}
							}
							else{
								fCurrentBackground.multiplePlayerFunc(Game.getGame().getPlayerCamArray());
							}
						}
					}
					else if(fDistance>0){
						if(this.x + dO.width/2 > fCurrentBackground.getScrollX() + fCurrentBackground.getBGWidth()){//Stick avatar to right end
							//WALL BOUNCE
							wallBounceFunc(pSpeed);
							this.x = fCurrentBackground.getScrollX() + fCurrentBackground.getBGWidth() - dO.width/2;
						}
						if(ArrayHelper.contains(Game.getGame().getPlayerCamArray(),this)){//If multi avatar
							if(this.x + dO.width/2 > stage.stageWidth){//Stick to end of screen
								this.x = stage.stageWidth - dO.width/2;
								if(!fWallBounceOn){
									wallBounceFunc(pSpeed);
								}
							}
							else{
								fCurrentBackground.multiplePlayerFunc(Game.getGame().getPlayerCamArray());
							}
						}
					}
				}*/
			}
		}
		/*
		private function moveY(pTimePassed:uint, pSpeed:Number,pAcc:Number){
			if(!attackFreezeOn){
				var fCurrentBackground:Background = MovieClip(Game.getGame()).getCurrentBackground();			
				originalY = this.y;
				var fDist:Number = pSpeed*pTimePassed/1000 + .5*pAcc*Math.pow(pTimePassed/1000,2);
				this.y+=fDist;
				if(manualPlayerCollisionOn){
					var fDmgObjB:DmgObj = (MovieClip(Game.getGame()).testCollision(dO));
					if(fDmgObjB!=null){//If this is hitting another player or shield, 
						removeKB();
						this.y = originalY;
					}
				}
	//			var dmgObjPoint:Point = new Point(dO.x, dO.y);
	//			dmgObjPoint = dO.localToGlobal(dmgObjPoint);
				if(fDist<0){
					if (this.y - dO.height/2 <= stage.stageHeight - fCurrentBackground.getBGHeight()) {//if past top
						this.y = stage.stageHeight - fCurrentBackground.getBGHeight() + dO.height/2;
					}
				}
				else if(fDist>0){
					if (this.y + dO.height/2 >= stage.stageHeight) {//If past bottom
						this.y = stage.stageHeight - dO.height/2;
					}
				}
			}
		}
		private function playerActions() {
			var i:uint=0;
			var timePassed:int = gameTimeFunc()-lastTimeMove;
			lastTimeMove+=timePassed;
			if(getPlayerActionsOn()){
				if(MovieClip(Game.getGame()).getGameMode()=="battleArea"){
					//*******************SPEED ADJUSTMENT****************
					if(mvSpeedModArray.length!=0){
						var fMvSpeedMod:Number = 1;
						for(i=0; i<mvSpeedModArray.length; i++){
							fMvSpeedMod*=mvSpeedModArray[i];
						}
						currentMvSpeedMod = fMvSpeedMod;
						xMvSpeed = baseXMvSpeed * fMvSpeedMod;
						yMvSpeed = baseYMvSpeed * fMvSpeedMod;
						runSpeed = xMvSpeed * runMultiplier;
						airDashSpeed = xMvSpeed * airDashMultiplier;
						if(fMvSpeedMod<1){
							setConditionFX("SpeedDecrease");
						}
						else if(fMvSpeedMod>1){
							setConditionFX("SpeedIncrease");
						}
						else{
							setConditionFX("SpeedNormal");
						}
					}
					else{
						currentMvSpeedMod = 1;
						setConditionFX("SpeedNormal");
						xMvSpeed = baseXMvSpeed;
						yMvSpeed = baseYMvSpeed;
						runSpeed = xMvSpeed * runMultiplier;
						airDashSpeed = xMvSpeed * airDashMultiplier;
					}
					//++++++++++++++++++RESTING++++++++++++++++++++
					if(inputMode == "rest" && !getInactionOn()){
						currentAni.changeAni(_crntGraphic, "startRest", "endRest", aniRestDuration, gameTimeFunc, 0, null);
						enableRestRecoveryOn = true;
						//if(shieldCurrentActual == shieldMax){//If full shield, start focus regen
							if(focusRegenFirstOn){
								lastTimeFocusRegen = gameTimeFunc();
								focusRegenFirstOn = false;
							}
							regenerateFocus(); 
						//}
						//else{
							shieldRegenPerc = shieldRegenRestPerc;
						//}
					}
					else if(inputMode == "restRecovery"){
						startRestRecovery();
					}
					//++++++++++++++++++++SKILL QUEUE++++++++++++++++++++++++++++
					if(inputQueue.length>0){
						for(i=0; i<inputQueue.length; i++){
							if(gameTimeFunc()-lastTimeCastQueue >= castQueueDuration - inputTimerQueue[0]){
								inputQueue.splice(0,1);
								inputTypeQueue.splice(0,1);
								inputTimerQueue.splice(0,1);
								i--;
							}
						}
					}
					if(inputQueue.length>0){
						if((inputMode == "movement") && !getInactionOn()){
							if(inputQueue[0]=="jump"){
								startTrueJump();
							}
							else{
								var fFormerInputType:String = inputType;
								inputType = inputTypeQueue[0];
								checkAndStartSkill(inputQueue[0], false);
								inputType = fFormerInputType;
							}
							inputQueue.splice(0,1);
							inputTypeQueue.splice(0,1);
							inputTimerQueue.splice(0,1);
						}
					}
					//++++++++++++++++AVATAR ONLY++++++++++++++++++++++++++
					if (playerType=="avatar") {
						//******************Z KEY****************
						if (keyboardTester.getKeyOnHash().hJump) {
	//							lastTimeFocusRegen = gameTimeFunc();
							if(!shiftPressedOnce){
								shiftPressedOnce = true;
								if((inputMode == "movement") && !getInactionOn()) {
									startTrueJump();
								}
								else{
									checkAndStartSkill(["jump"]);
								}
							}
						}
						else{
							shiftPressedOnce = false;
						}
						if(!skillInputOn && inputMode != "meditate"){
							//****************LEFT AND RIGHT ARROW OR !LEFT AND !RIGHT ARROW***********************
							if ((keyboardTester.getKeyOnHash().hRight && keyboardTester.getKeyOnHash().hLeft)||
								(!keyboardTester.getKeyOnHash().hRight && !keyboardTester.getKeyOnHash().hLeft)) {//If both or neither left and right arrows are pressed at same time, dont do anything
								moveActionXDirection = null;
							}
							else {
								//****************LEFT ARROW***********************
								if (keyboardTester.getKeyOnHash().hLeft && !kBDirectionXLock) {//Move left
									if (keyboardTester.getDoubleTapHash().hLeft && (!manualBattleSlowOn || !battleSlowOn)) {//If double tapped and run not already activated
										moveAction = "run";
										moveActionXDirection = "left";
									}
									else{
										moveAction = "walk";
										moveActionXDirection = "left";
										//}
									}
									if(manualHAttackOn){
										if(!leftPressedOnce){
											if(_directionFacing=="right"){
												attackDirection = "left";
											}
											else{
												attackDirection = "right";
											}
										}
										
									}
									leftPressedOnce = true;//Only for attack direction
								}
								else{
									leftPressedOnce = false;
								}
								//****************RIGHT ARROW***********************
								if (keyboardTester.getKeyOnHash().hRight && !kBDirectionXLock) {//Move right
									if (keyboardTester.getDoubleTapHash().hRight && (!manualBattleSlowOn || !battleSlowOn)) {//If double tapped and run not already activated
										moveAction = "run";
										moveActionXDirection = "right";
									}
									else{
										moveAction = "walk";
										moveActionXDirection = "right";
									}
									if(manualHAttackOn){
										if(!rightPressedOnce){
											if(_directionFacing=="right"){
												attackDirection = "right";
											}
											else{
												attackDirection = "left";
											}
										}
									}
									rightPressedOnce = true;//Only for attack direction
								}
								else{
									rightPressedOnce = false;
								}
							}
							//*****************UP AND DOWN ARROW OR !UP AND !DOWN ARROW**************************
							if ((keyboardTester.getKeyOnHash().hUp && keyboardTester.getKeyOnHash().hDown) || 
								(!keyboardTester.getKeyOnHash().hUp && !keyboardTester.getKeyOnHash().hDown)) {
								moveActionYDirection = null;
							}
							else{
	
								//****************DOWN ARROW***********************
								if (keyboardTester.getKeyOnHash().hDown) {//Move down
									moveActionYDirection = "down";
									if(moveAction!="run" || moveActionXDirection == null){
										moveAction = "walk";
									}
									if(manualHAttackOn){
										if(!downPressedOnce){
											attackDirection = "down";
										}
									}
									downPressedOnce = true;//Only for attack direction
								}
								else{
									downPressedOnce = false;
								}
								//****************UP ARROW***********************
								if (keyboardTester.getKeyOnHash().hUp) {//Move up
									moveActionYDirection = "up";
									if(moveAction!="run" || moveActionXDirection == null){
										moveAction = "walk";
									}
									if(manualHAttackOn){
										if(!upPressedOnce){
											attackDirection = "up";
										}
									}
									upPressedOnce = true;//Only for attack direction
								}
								else{
									upPressedOnce = false;
								}
							}
							//*************************NOTHING IS PRESSED**********************
							if(moveActionXDirection==null&&moveActionYDirection==null){
								moveAction = "stand";
								moveActionXDirection = null;
								moveActionYDirection = null;
								if(manualHAttackOn){
									attackDirection = "hNormal";
								}
							}
						}
						else{//If skillInputOn
							moveAction = "stand";
							moveActionXDirection = null;
							moveActionYDirection = null;
						}
						//*************************NOT WALK/RUN*************************************
						if (inputMode != "movement" || getInactionOn() || skillInputOn) {//Continue slide if not in "movement" mode
							if(_crntGraphic.y==0 && !jumpOn && !kUOn){
								if(xMvSpeedNew<0){
									//xMvSpeedNew += xMvSpeed*timePassed/300;
									moveX(timePassed,xMvSpeedNew,xFriction,false);
									xMvSpeedNew += xFriction*timePassed/1000;
									if(xMvSpeedNew>0){
										xMvSpeedNew = 0;
									}
								}
								else if(xMvSpeedNew>0){
									moveX(timePassed,xMvSpeedNew,-xFriction,true,false);
									xMvSpeedNew -= xFriction*timePassed/1000;
									if(xMvSpeedNew<0){
										xMvSpeedNew = 0;
									}
								}
							}
						}
						//**************************H ATTACK************************************
						if(manualHAttackOn){
							if(!actualDefenseInputOn && hAttackPressedOnceOn){
								inputType = "a";
								currentSkillInput = [attackDirection];
								checkAndStartSkill(ArrayHelper.cloneArray(currentSkillInput), true);
							}
	//						if(manualAtkDefSkillsOn){
	//									inputType = null;
	//						}
	//						skillInputOn = false;
	//							leftPressedOnceInput = false;//Reset these to prevent keys from being inputted if they were already held down before pressing z
	//							rightPressedOnceInput = false;
	//							upPressedOnceInput = false;
	//							downPressedOnceInput = false;
	//							currentSkillInput.splice(0,currentSkillInput.length);//Delete everything in input array
	//						if (inputMode!="casting" && inputMode!="meditate" && !getInactionOn()) {
	//							inputMode = "movement";
	//						}
						}
						//*************************WALK/RUN*************************************
						if (inputMode == "movement" && !getInactionOn() && !skillInputOn) {
							if(_crntGraphic.y==0 && !jumpOn && !kUOn){
								var fTimePassedDustCloud:uint = gameTimeFunc()-lastTimeFrictionDustCloud;
								switch(moveAction){
									case "walk":
										switch(moveActionXDirection){
											case "left":
												if(manualAccOn){
													//If moving left slower than the walk speed (or not moving left at all)
													if(xMvSpeedNew>-xMvSpeed){
														//xMvSpeedNew += xMvSpeed*timePassed/300;
														var f
														if(xMvSpeedNew>frictionDustSpeedThresh && fTimePassedDustCloud>=frictionDustInterval ){
															createDustCloud();
															if(!tireScreechOn){
																playSound("SndTireScreech0",.3,false,gameTimeFunc);
																tireScreechOn = true;
															}
															lastTimeFrictionDustCloud += fTimePassedDustCloud;
														}
														xMvSpeedNew -= xAcc*timePassed/1000;//Increase the left speed
														if(xMvSpeedNew<-xMvSpeed){//If over the max left walk speed now,
															xMvSpeedNew = -xMvSpeed;//make it equal to the max left walk speed
														}
														if(xMvSpeedNew<=0){
															tireScreechOn = false;
														}
													}
													else{//If moving faster than the walk speed
														tireScreechOn = false;
														xMvSpeedNew += xAcc*timePassed/1000;//Decrease left speed
														if(xMvSpeedNew>-xMvSpeed){//If under the max left walk speed now,
															xMvSpeedNew = -xMvSpeed;//make it equal to the max left walk speed
														}
													}
													if(!tireScreechOn){
														currentAni.changeAni(_crntGraphic, aniSWRArray[3], aniSWRArray[4], aniSWRArray[5]/currentMvSpeedMod, gameTimeFunc, 0, aniWalkSound);
														//Make sure instead of dividing by zero, just make the duration huge (so basically paused animation)
														if(xMvSpeedNew!=0){
															currentAni.setDuration(aniSWRArray[5]/currentMvSpeedMod*Math.abs(xMvSpeed/xMvSpeedNew));
														}
														else{
															currentAni.setDuration(aniSWRArray[5]/currentMvSpeedMod*Math.abs(xMvSpeed/.000000001));
														}
													}
													else{
														currentAni.changeAni(_crntGraphic,"startFriction","endFriction", aniFrictionDuration,gameTimeFunc,0,null);
													}
													moveX(timePassed, xMvSpeedNew,0);//Can't use moveXWithDirectionChange because the direction change is based on the direction of the speed
													if(_directionFacing == "right"){
														changeDirectionFacing();
													}
												}
												else{
													currentAni.changeAni(_crntGraphic, aniSWRArray[3], aniSWRArray[4], aniSWRArray[5]/currentMvSpeedMod, gameTimeFunc, 0, aniWalkSound);
													xMvSpeedNew = -xMvSpeed;
													moveX(timePassed, xMvSpeedNew,0);//Can't use moveXWithDirectionChange because the direction change is based on the direction of the speed
													if(_directionFacing == "right"){
														changeDirectionFacing();
													}
												}
												break;
											case "right":
												if(manualAccOn){
													if(xMvSpeedNew<xMvSpeed){
														//xMvSpeedNew += xMvSpeed*timePassed/300;
														if(xMvSpeedNew<-frictionDustSpeedThresh && fTimePassedDustCloud>=frictionDustInterval){
															createDustCloud();
															if(!tireScreechOn){
																playSound("SndTireScreech0",.3,false,gameTimeFunc);
																tireScreechOn = true;
															}
															lastTimeFrictionDustCloud += fTimePassedDustCloud;
														}
														xMvSpeedNew += xAcc*timePassed/1000;
														if(xMvSpeedNew>xMvSpeed){
															xMvSpeedNew = xMvSpeed;
														}
														if(xMvSpeedNew>=0){
															tireScreechOn = false;
														}
													}
													else{
														tireScreechOn = false;
														xMvSpeedNew -= xAcc*timePassed/1000;
														if(xMvSpeedNew<xMvSpeed){
															xMvSpeedNew = xMvSpeed;
														}
													}
													if(!tireScreechOn){
														currentAni.changeAni(_crntGraphic, aniSWRArray[3], aniSWRArray[4], aniSWRArray[5]/currentMvSpeedMod, gameTimeFunc, 0, aniWalkSound);
														//Make sure instead of dividing by zero, just make the duration huge (so basically paused animation)
														if(xMvSpeedNew!=0){
															currentAni.setDuration(aniSWRArray[5]/currentMvSpeedMod*Math.abs(xMvSpeed/xMvSpeedNew));
														}
														else{
															currentAni.setDuration(aniSWRArray[5]/currentMvSpeedMod*Math.abs(xMvSpeed/.000000001));
														}
													}
													else{
														currentAni.changeAni(_crntGraphic,"startFriction","endFriction", aniFrictionDuration,gameTimeFunc,0,null);
													}
													moveX(timePassed, xMvSpeedNew,0);
													if(_directionFacing == "left"){
														changeDirectionFacing();
													}
												}
												else{
													currentAni.changeAni(_crntGraphic, aniSWRArray[3], aniSWRArray[4], aniSWRArray[5]/currentMvSpeedMod, gameTimeFunc, 0, aniWalkSound);
													xMvSpeedNew = xMvSpeed;
													moveX(timePassed, xMvSpeedNew,0);
													if(_directionFacing == "left"){
														changeDirectionFacing();
													}
												}
												break;
											default:
												currentAni.changeAni(_crntGraphic, aniSWRArray[3], aniSWRArray[4], aniSWRArray[5]/currentMvSpeedMod, gameTimeFunc, 0, aniWalkSound);
												if(manualAccOn){
													if(xMvSpeedNew<0){
														//xMvSpeedNew += xMvSpeed*timePassed/300;
														moveX(timePassed, xMvSpeedNew,xFriction,false);
														xMvSpeedNew += xFriction*timePassed/1000;
														if(xMvSpeedNew>0){
															xMvSpeedNew = 0;
														}
													}
													else if(xMvSpeedNew>0){
														moveX(timePassed, xMvSpeedNew,-xFriction,true,false);
														xMvSpeedNew -= xFriction*timePassed/1000;
														if(xMvSpeedNew<0){
															xMvSpeedNew = 0;
														}
													}													
												}
												else{
													xMvSpeedNew = 0;
												}
		//										xMvSpeedNew = 0;
												break;
										}
										switch(moveActionYDirection){
											case "up":
												this.moveY(timePassed, -yMvSpeed,0);
												break;
											case "down":
												this.moveY(timePassed, yMvSpeed,0);
												break;
											default:
												break;
										}
										break;
									case "run":
		//								if(xMvSpeedNew!=runSpeed){
		//									xMvSpeedNew += 250*timePassed/1000;
		//									if(xMvSpeedNew>runSpeed){
		//										xMvSpeedNew = runSpeed;
		//									}
		//								}
										switch(moveActionXDirection){
											case "left":
												if(jumpOn){
													
												}
												if(manualAccOn){
													if(xMvSpeedNew>-runSpeed){
														//xMvSpeedNew += xMvSpeed*timePassed/300;
														if(xMvSpeedNew>frictionDustSpeedThresh && fTimePassedDustCloud>=frictionDustInterval){
															createDustCloud();
															if(!tireScreechOn){
																playSound("SndTireScreech0",.3,false,gameTimeFunc);
																tireScreechOn = true;
															}
															lastTimeFrictionDustCloud += fTimePassedDustCloud;
														}
														xMvSpeedNew -= xAcc*timePassed/1000;
														if(xMvSpeedNew<-runSpeed){
															xMvSpeedNew = -runSpeed;
														}
														if(xMvSpeedNew<=0){
															tireScreechOn = false;
														}
													}
													else{
														tireScreechOn = false;
														xMvSpeedNew += xAcc*timePassed/1000;
														if(xMvSpeedNew>-runSpeed){
															xMvSpeedNew = -runSpeed;
														}
													}
													if(!tireScreechOn){
														currentAni.changeAni(_crntGraphic, aniSWRArray[6], aniSWRArray[7], aniSWRArray[8]/currentMvSpeedMod, gameTimeFunc, 0, aniRunSound);
														//Make sure instead of dividing by zero, just make the duration huge (so basically paused animation)
														if(xMvSpeedNew!=0){
															currentAni.setDuration(aniSWRArray[8]/currentMvSpeedMod*Math.abs(runSpeed/xMvSpeedNew));
														}
														else{
															currentAni.setDuration(aniSWRArray[8]/currentMvSpeedMod*Math.abs(runSpeed/.000000001));
														}
													}
													else{
														currentAni.changeAni(_crntGraphic,"startFriction","endFriction", aniFrictionDuration,gameTimeFunc,0,null);
													}
													moveX(timePassed, xMvSpeedNew,0);
													if(_directionFacing == "right"){
														changeDirectionFacing();
													}
												}
												else{
													currentAni.changeAni(_crntGraphic, aniSWRArray[6], aniSWRArray[7], aniSWRArray[8]/currentMvSpeedMod, gameTimeFunc, 0, aniRunSound);
													xMvSpeedNew = -runSpeed;
													moveX(timePassed, xMvSpeedNew,0);
													if(_directionFacing == "right"){
														changeDirectionFacing();
													}
												}
												break;
											case "right":
												if(manualAccOn){
													if(xMvSpeedNew<runSpeed){
														//xMvSpeedNew += xMvSpeed*timePassed/300;
														if(xMvSpeedNew<-frictionDustSpeedThresh && fTimePassedDustCloud>=frictionDustInterval){
															createDustCloud();
															if(!tireScreechOn){
																playSound("SndTireScreech0",.3,false,gameTimeFunc);
																tireScreechOn = true;
															}
															lastTimeFrictionDustCloud += fTimePassedDustCloud;
														}
														xMvSpeedNew += xAcc*timePassed/1000;
														if(xMvSpeedNew>runSpeed){
															xMvSpeedNew = runSpeed;
														}
														if(xMvSpeedNew>=0){
															tireScreechOn = false;
														}
													}
													else{
														tireScreechOn = false;
														xMvSpeedNew -= xAcc*timePassed/1000;
														if(xMvSpeedNew<runSpeed){
															xMvSpeedNew = runSpeed;
														}
													}
													if(!tireScreechOn){
														currentAni.changeAni(_crntGraphic, aniSWRArray[6], aniSWRArray[7], aniSWRArray[8]/currentMvSpeedMod, gameTimeFunc, 0, aniRunSound);
														//Make sure instead of dividing by zero, just make the duration huge (so basically paused animation)
														if(xMvSpeedNew!=0){
															currentAni.setDuration(aniSWRArray[8]/currentMvSpeedMod*Math.abs(runSpeed/xMvSpeedNew));
														}
														else{
															currentAni.setDuration(aniSWRArray[8]/currentMvSpeedMod*Math.abs(runSpeed/.000000001));
														}
													}
													else{
														currentAni.changeAni(_crntGraphic,"startFriction","endFriction", aniFrictionDuration,gameTimeFunc,0,null);
													}
													moveX(timePassed, xMvSpeedNew,0);
													if(_directionFacing == "left"){
														changeDirectionFacing();
													}
												}
												else{
													currentAni.changeAni(_crntGraphic, aniSWRArray[6], aniSWRArray[7], aniSWRArray[8]/currentMvSpeedMod, gameTimeFunc, 0, aniRunSound);
													xMvSpeedNew = runSpeed;
													moveX(timePassed, xMvSpeedNew,0);
													if(_directionFacing == "left"){
														changeDirectionFacing();
													}
												}
												break;
											default:
												currentAni.changeAni(_crntGraphic, aniSWRArray[6], aniSWRArray[7], aniSWRArray[8]/currentMvSpeedMod, gameTimeFunc, 0, aniRunSound);
												if(xMvSpeedNew<0){
													//xMvSpeedNew += xMvSpeed*timePassed/300;
													moveX(timePassed, xMvSpeedNew,xFriction,false);
													xMvSpeedNew += xFriction*timePassed/1000;
													if(xMvSpeedNew>0){
														xMvSpeedNew = 0;
													}
												}
												else if(xMvSpeedNew>0){
													moveX(timePassed, xMvSpeedNew,-xFriction,true,false);
													xMvSpeedNew -= xFriction*timePassed/1000;
													if(xMvSpeedNew<0){
														xMvSpeedNew = 0;
													}
												}												
		//										xMvSpeedNew = 0;
												break;
										}
										switch(moveActionYDirection){
											case "up":
												this.moveY(timePassed, -yMvSpeed,0);
												break;
											case "down":
												this.moveY(timePassed, yMvSpeed,0);
												break;
											default:
												break;
										}
										break;
									case "stand":
										currentAni.changeAni(_crntGraphic, aniSWRArray[0], aniSWRArray[1], aniSWRArray[2]/currentMvSpeedMod, gameTimeFunc, 0, aniStandSound);
										if(manualSlideOn){
											tireScreechOn = false;
											if(xMvSpeedNew<0){
												//xMvSpeedNew += xMvSpeed*timePassed/300;
												moveX(timePassed, xMvSpeedNew,xFriction,false);
												xMvSpeedNew += xFriction*timePassed/1000;
												if(xMvSpeedNew>0){
													xMvSpeedNew = 0;
												}
											}
											else if(xMvSpeedNew>0){
												moveX(timePassed, xMvSpeedNew,-xFriction,true,false);
												xMvSpeedNew -= xFriction*timePassed/1000;
												if(xMvSpeedNew<0){
													xMvSpeedNew = 0;
												}
											}
											
										}
										else{
											xMvSpeedNew = 0;
										}
										break;
									default:
										currentAni.changeAni(_crntGraphic, aniSWRArray[0], aniSWRArray[1], aniSWRArray[2]/currentMvSpeedMod, gameTimeFunc, 0, aniStandSound);
										if(manualSlideOn){
											tireScreechOn = false;
											
											if(xMvSpeedNew<0){
												moveX(timePassed,xMvSpeedNew,xFriction,false);
												//xMvSpeedNew += xMvSpeed*timePassed/300;
												xMvSpeedNew += xFriction*timePassed/1000;
												if(xMvSpeedNew>0){
													xMvSpeedNew = 0;
												}
											}
											else if(xMvSpeedNew>0){
												moveX(timePassed,xMvSpeedNew,-xFriction,true,false);
												xMvSpeedNew -= xFriction*timePassed/1000;
												if(xMvSpeedNew<0){
													xMvSpeedNew = 0;
												}
											}											
										}
										else{
											xMvSpeedNew = 0;
										}
										break;
								}
							}
							//*************************NOTHING IS PRESSED**********************
							if(!keyboardTester.getKeyOnHash().hSkill && (!keyboardTester.getKeyOnHash().hBlock || inputMode!="meditate") && !keyboardTester.getKeyPressOnHash().hNormal && !keyboardTester.getKeyOnHash().hJump && (!keyboardTester.getKeyOnHash().hDown || bothPressedVertical) && (!keyboardTester.getKeyOnHash().hUp  || bothPressedVertical) && !(keyboardTester.getKeyOnHash().hRight && !bothPressedHorizontal && !kBDirectionXLock) && !(keyboardTester.getKeyOnHash().hLeft && !bothPressedHorizontal && !kBDirectionXLock)){
								if(_crntGraphic.y==0 && !jumpOn && !kUOn && !airDashOn){
									currentAni.changeAni(_crntGraphic, aniSWRArray[0], aniSWRArray[1], aniSWRArray[2]/currentMvSpeedMod, gameTimeFunc, 0, aniStandSound);
								}
								else{
									//currentAni.changeAni(_crntGraphic, aniSWRArray[9], aniSWRArray[10], aniSWRArray[11], gameTimeFunc, 1, null);								
								}
								moveAction = "stand";
							}
						}
				}
			}
		}*/
		public static function compareTeams(pAttacker:PhysObj,pVictim:PhysObj):Boolean{
			if(pAttacker.dmgType=="all" || (pAttacker.dmgType=="opponent"&&pAttacker.team!=pVictim.team) || (pAttacker.dmgType=="same"&&pAttacker.team==pVictim.team)){
				return true;
			}
			return false;
		}
		public function faceForward(pVelX:Number,pVelY:Number){
//			if(aOUpsideDownOn){
//				if(xSpeedNew<0){//If moving left
//					_crntGraphic.rotation = Math.atan2(-ySpeedNew,xSpeedNew)*(360/(2*Math.PI));
//				}
//				else{
//					_crntGraphic.rotation = Math.atan(-ySpeedNew/xSpeedNew)*(360/(2*Math.PI));
//				}
//			}
//			else{
				if(pVelX<0){//If moving left
				   if(_crntGraphic.scaleX > 0){//If graphic is facing right
						_crntGraphic.scaleX = -_crntGraphic.scaleX;
				   }
				}
				else if(pVelX>0){//if moving right
				   if(_crntGraphic.scaleX < 0){//If graphic is facing left
						_crntGraphic.scaleX = -_crntGraphic.scaleX;
				   }
				}
				_crntGraphic.rotation = Math.atan(pVelY/pVelX)*(360/(2*Math.PI));
//			}			
		}
		public function get physObjDef():PhysObjDef{
			return _physObjDef;
		}
		public function get physObjName():String{
			return _physObjName;
		}
		public function get physObjCreator():PhysObj{
			return _physObjCreator;
		}
		public function set physObjCreator(p:PhysObj){
			_physObjCreator = p;
		}
		public function get airOn():Boolean{
			return _airOn;
		}
		public function set airOn(pB:Boolean){
			_airOn = pB;
		}
		public function get velX():Number{
			return _velX;
		}
		public function set velX(pVel:Number){
			_velX = pVel;
		}
		public function get accX():Number{
			return _accX;
		}
		public function set accX(pAcc:Number){
			_accX = pAcc;
		}
		public function get velY():Number{
			return _velY;
		}
		public function set velY(pVel:Number){
			_velY = pVel;
		}
		public function get accY():Number{
			return _accY;
		}
		public function set accY(pAcc:Number){
			_accY = pAcc;
		}
		public function get crntGraphic():MovieClip{
			return _crntGraphic;
		}
		public function get crntAni():MovieClip{
			return _crntAni;
		}
		public function get crntGraphicStandWidth():Number{
			return _crntGraphicStandWidth;
		}
		public function get crntGraphicStandHeight():Number{
			return _crntGraphicStandHeight;
		}
		public function get directionFacing():String{
			return _directionFacing;
		}
		public function get hitRules():Array{
			return _hitRules;
		}
		public function set hitRules(a:Array){
			_hitRules = a;
		}
		public function get dmgType():String{
			return _dmgType;
		}
		public function set dmgType(a:String){
			_dmgType = a;
		}
		public function get dmgBase():Number{
			return _dmgBase;
		}
		public function get team():String{
			return _team;
		}
		public function set team(a:String){
			_team = a;
		}
		public function get deathOn():Boolean{
			return _deathOn;
		}
		public function set deathOn(pB:Boolean){
			if(!_deathOn && pB){
				removeEventListener(Event.ENTER_FRAME, physObjLoop);
				//if(this.parent!=null){
					this.parent.removeChild(this);
				//}
				delete this;
			}
			_deathOn = pB;
		}
		public function get skill():Skill{
			return _skill;
		}
		public function set skill(pB:Skill){
			_skill = pB;
		}
		public function get damage():Damage{
			return _damage;
		}
		public function set damage(pB:Damage){
			_damage = pB;
		}
		public function get hPCrnt():Number{
			return _hPCrnt;
		}
		public function set hPCrnt(pB:Number){
			_hPCrnt = pB;
		}
		public function get bulletOrigin():Array{
			return _bulletOrigin;
		}
		public function set bulletOrigin(s:Array){
			_bulletOrigin = s;
		}
	}
}