﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import flash.utils.Timer;
    import flash.geom.ColorTransform;
	import fl.motion.Color;

	
	public class PointBurst extends Sprite {
		// text style
		static const fontFace:String = "Arial";
		private var fontSize:int = 20;
		static const fontBold:Boolean = true;
		static const fontColor:Number = 0x000FFF;
		
		// animation
		private var _duration:int = 1000;
		
		private var scaleChangeOn:Boolean = true;
		private var bounceOn:Boolean = true;
		private var colorChangeOn:Boolean = true;
//		static const animSteps:int = 10;
//		static const animDelay:int = 50;
		static const startScale:Number = .9;
		static const endScale:Number = 1.3;
		private var _gravity:Number = 150;
		static const landingDist:Number = 10;
//		static const origJumpSpeed = 2.5;
		private var _bounceSpeed:Number = -100;		
		private var _jumpSpeed:Number = _bounceSpeed;
		static const bounceReduction:Number = 2;//2 means half as much bounce next time
		static const colorDelay = 200;
		
		private var tField:TextField;
		private var tFieldBG0:TextField;
		private var tFieldBG1:TextField;
		private var tFieldBG2:TextField;
		private var tFieldBG3:TextField;
		private var burstSprite:Sprite;
		private var parentMC:MovieClip;
//		private var animTimer:Timer;
		private var pntBStorageArray:Array;//Array of the parent so garbage collection doesn't remove if local
		private var currentTimeFunc:Function;		
		private var origX:Number;
		private var origY:Number;		
		private var percentDone:Number = 0;
		
		private var redOffset:Number;
		private var greenOffset:Number;
		private var blueOffset:Number;
		
		private var followMC:MovieClip = null;//Follows this objects x,y changes without being a child of it
		private var followMCOriginCoord:Object = {hX:0,hY:0};
		
		private var lastTimeDuration:uint;
		private var lastTimeAnim:uint;
		private var lastTimeColor:uint;
		
		public function PointBurst(mc:MovieClip, pText:String, pX,pY:Number, pRedOffset:Number, pGreenOffset:Number, pBlueOffset:Number, pPntBStorageArray:Array, pCurrentTimeFunc:Function, pFollowMC:MovieClip=null) {
			parentMC = mc;
			origX = pX;
			origY = pY;
			redOffset = pRedOffset;
			greenOffset = pGreenOffset;
			blueOffset = pBlueOffset;
			pntBStorageArray = pPntBStorageArray;
			currentTimeFunc = pCurrentTimeFunc;
			
			if(pFollowMC!=null){
				followMC = pFollowMC;
				followMCOriginCoord["hX"] = followMC.x;
				followMCOriginCoord["hY"] = followMC.y;
			}

			var fColor:Color = new Color();
			fColor.redOffset = fColor.redOffset + redOffset;
			if(fColor.redOffset>255){
				fColor.redOffset = 255;
			}
			else if(fColor.redOffset<0){
				fColor.redOffset = 0;
			}
			fColor.greenOffset = fColor.greenOffset + greenOffset;
			if(fColor.greenOffset>255){
				fColor.greenOffset = 255;
			}
			else if(fColor.greenOffset<0){
				fColor.greenOffset = 0;
			}				
			fColor.blueOffset = fColor.blueOffset + blueOffset;
			if(fColor.blueOffset>255){
				fColor.blueOffset = 255;
			}
			else if(fColor.blueOffset<0){
				fColor.blueOffset = 0;
			}

			// create text format
			var tFormat:TextFormat = new TextFormat();
			tFormat.font = fontFace;
			tFormat.size = fontSize;
			tFormat.bold = fontBold;
			tFormat.align = "center";
			tFormat.italic = true;
			tFormat.color = fColor.color;
			// create text field
			tField = new TextField();
			//tField.embedFonts = true;			
			tField.selectable = false;
			tField.defaultTextFormat = tFormat;
			tField.autoSize = TextFieldAutoSize.CENTER;
			tField.text = String(pText);
			tField.x = -(tField.width/2);
			tField.y = -(tField.height/2);
			
			// create text field background
			tFormat.color = 0xFFFFFF;
			tFieldBG0 = new TextField();
			//tField.embedFonts = true;
			tFieldBG0.selectable = false;
			tFieldBG0.defaultTextFormat = tFormat;
			tFieldBG0.autoSize = TextFieldAutoSize.CENTER;
			tFieldBG0.text = String(pText);
			tFieldBG0.x = -(tFieldBG0.width/2)+1;
			tFieldBG0.y = -(tFieldBG0.height/2);
			tFieldBG0.setTextFormat(tFormat);
			
			tFieldBG1 = new TextField();
			//tField.embedFonts = true;
			tFieldBG1.selectable = false;
			tFieldBG1.defaultTextFormat = tFormat;
			tFieldBG1.autoSize = TextFieldAutoSize.CENTER;
			tFieldBG1.text = String(pText);
			tFieldBG1.x = -(tFieldBG1.width/2)-1;
			tFieldBG1.y = -(tFieldBG1.height/2);
			tFieldBG1.setTextFormat(tFormat);
			
			tFieldBG2 = new TextField();
			//tField.embedFonts = true;
			tFieldBG2.selectable = false;
			tFieldBG2.defaultTextFormat = tFormat;
			tFieldBG2.autoSize = TextFieldAutoSize.CENTER;
			tFieldBG2.text = String(pText);
			tFieldBG2.x = -(tFieldBG2.width/2);
			tFieldBG2.y = -(tFieldBG2.height/2)+1;
			tFieldBG2.setTextFormat(tFormat);
			
			tFieldBG3 = new TextField();
			//tField.embedFonts = true;
			tFieldBG3.selectable = false;
			tFieldBG3.defaultTextFormat = tFormat;
			tFieldBG3.autoSize = TextFieldAutoSize.CENTER;
			tFieldBG3.text = String(pText);
			tFieldBG3.x = -(tFieldBG3.width/2);
			tFieldBG3.y = -(tFieldBG3.height/2)-1;
			tFieldBG3.setTextFormat(tFormat);
			
			// create sprite
			burstSprite = new Sprite();
			burstSprite.x = origX;
			burstSprite.y = origY;
//			burstSprite.scaleX = startScale;
//			burstSprite.scaleY = startScale;
//			burstSprite.alpha = 0;
		}
		public function setFontSize(u:uint){
			fontSize = u;
//			tField.getTextFormat();
			var tFormat:TextFormat = tField.getTextFormat();
			tFormat.size = u;

			tField.setTextFormat(tFormat);
			tFormat.color = 0xFFFFFF;
			tFieldBG0.setTextFormat(tFormat);
			tFieldBG1.setTextFormat(tFormat);
			tFieldBG2.setTextFormat(tFormat);
			tFieldBG3.setTextFormat(tFormat);
			tField.defaultTextFormat = tFormat;
			tFieldBG0.defaultTextFormat = tFormat;
			tFieldBG1.defaultTextFormat = tFormat;
			tFieldBG2.defaultTextFormat = tFormat;
			tFieldBG3.defaultTextFormat = tFormat;
		}
		public function get gravity():Number{
			return _gravity;
		}		
		public function set gravity(n:Number){
			_gravity = n;
		}
		public function get bounceSpeed():Number{
			return _bounceSpeed;
		}		
		public function set bounceSpeed(n:Number){
			_bounceSpeed = n;
			_jumpSpeed = n;
		}
		public function get duration():uint{
			return _duration;
		}
		public function set duration(u:uint){
			_duration = u;
		}
		public function setTopDist(n:Number){//CAN'T USE because frame rate changes too much
		//If you want to actually work, base the actual equations on gameTime.  Too lazy now.
			//d=vt+.5at^2
			//d = .5*Math.pow(_bounceSpeed,2)/_gravity;
			_bounceSpeed = ((n+.5*(_gravity)*Math.pow(_duration/1000, 2))/(_duration/1000))/20;
//			_bounceSpeed = Math.sqrt(n*_gravity*2);
			_jumpSpeed = _bounceSpeed;
		}
		private var xMin:Number = 0;
		private var xMax:Number = 0;
		private var xSpeed:Number = 0;
		public function setXDisp(pXMin:Number, pXMax:Number){
			xMin = pXMin;
			xMax = pXMax;
			xSpeed = (xMin + Math.random()*(xMax-xMin))/(_duration/1000);
		}
		public function start(){
			pntBStorageArray.push(this);
			xSpeed = (xMin + Math.random()*(xMax-xMin))/(_duration/1000);
//			var tFormat:TextFormat = new TextFormat();
//			tFormat.font = fontFace;
//			tFormat.size = fontSize;
//			tFormat.bold = fontBold;
//			tFormat.align = "center";				
//			tField.setTextFormat(tFormat);
			burstSprite.addChild(tFieldBG0);
			burstSprite.addChild(tFieldBG1);
			burstSprite.addChild(tFieldBG2);
			burstSprite.addChild(tFieldBG3);
			burstSprite.addChild(tField);
			parentMC.addChild(burstSprite);
			lastTimeAnim = currentTimeFunc.call();
			lastTimeColor = currentTimeFunc.call();
			lastTimeDuration = currentTimeFunc.call();
//			animTimer = new Timer(_duration, 1);
			addEventListener(Event.ENTER_FRAME, rescaleBurst,false,0,true);
//			animTimer.addEventListener(TimerEvent.TIMER_COMPLETE, removeBurst);
//			animTimer.start();			
		}
		// animate
		private function rescaleBurst(e:Event) {
			// how far along are we
//			var percentDone:Number = event.target.currentCount/animSteps;
			// set scale and alpha
//			burstSprite.scaleX = (1.0-percentDone)*startScale + percentDone*endScale;
//			burstSprite.scaleY = (1.0-percentDone)*startScale + percentDone*endScale;
//			burstSprite.alpha = 1.0-percentDone;
//			burstSprite.scaleX = (1.0-percentDone)*startScale + percentDone*endScale;
//			burstSprite.scaleY = (1.0-percentDone)*startScale + percentDone*endScale;
//			burstSprite.alpha = 1.0-percentDone;
			//Change color
			if(currentTimeFunc.call()-lastTimeDuration >= _duration){
				removeBurst();
			}
			else{
				if(colorChangeOn){
					var fTimePassedColor:int = currentTimeFunc.call()-lastTimeColor;
					if(fTimePassedColor >= colorDelay){
						lastTimeColor += fTimePassedColor;
						var fRndNum:Number = Math.random()* 0xFFFFFF;
						var fColor:Color = new Color();
						fColor.setTint(fRndNum, .7);
						fColor.redOffset = fColor.redOffset + redOffset;
						if(fColor.redOffset>255){
							fColor.redOffset = 255;
						}
						else if(fColor.redOffset<0){
							fColor.redOffset = 0;
						}
						fColor.greenOffset = fColor.greenOffset + greenOffset;
						if(fColor.greenOffset>255){
							fColor.greenOffset = 255;
						}
						else if(fColor.greenOffset<0){
							fColor.greenOffset = 0;
						}				
						fColor.blueOffset = fColor.blueOffset + blueOffset;
						if(fColor.blueOffset>255){
							fColor.blueOffset = 255;
						}
						else if(fColor.blueOffset<0){
							fColor.blueOffset = 0;
						}				
		
		//			tField.getTextFormat();
						var tFormat:TextFormat = tField.getTextFormat();
						tFormat.color = fColor.color;
						tField.setTextFormat(tFormat);
					}
				}
				//Change scale and movement
//				if(currentTimeFunc.call()-lastTimeAnim >= animDelay){

				if(scaleChangeOn){
					percentDone = (currentTimeFunc.call()-lastTimeDuration)/_duration;
					//Scale
					if(percentDone <= 1){
						burstSprite.scaleX = (1.0-percentDone)*startScale + percentDone*endScale;
						burstSprite.scaleY = (1.0-percentDone)*startScale + percentDone*endScale;
					}
					else{
						burstSprite.scaleX = endScale;
						burstSprite.scaleY = endScale;
					}
				}
				//Jump, Fall, Bounce
				var fTimePassedAnim:uint = currentTimeFunc.call()-lastTimeAnim;
				lastTimeAnim += fTimePassedAnim;
				if(bounceOn){					
					burstSprite.y += _jumpSpeed*fTimePassedAnim/1000;
					_jumpSpeed += _gravity*fTimePassedAnim/1000;
					if(burstSprite.y >= origY + landingDist){//If its landing
						burstSprite.y = origY + landingDist;
						_bounceSpeed = _bounceSpeed/bounceReduction;
						_jumpSpeed = _bounceSpeed;
					}
				}
				if(xSpeed!=0){
					burstSprite.x += xSpeed*fTimePassedAnim/1000;
				}
				if(followMC!=null){
					burstSprite.x += followMC.x - followMCOriginCoord["hX"];
					burstSprite.y += followMC.y - followMCOriginCoord["hY"];
					followMCOriginCoord["hX"] = followMC.x;
					followMCOriginCoord["hY"] = followMC.y;
				}
//				}
			}
		}
		
		// all done, remove self
		private function removeBurst() {
			
			removeEventListener(Event.ENTER_FRAME, rescaleBurst);
			if(pntBStorageArray.indexOf(this)!=-1){
				pntBStorageArray.splice(pntBStorageArray.indexOf(this),1);
			}
//			burstSprite.removeChild(tField);
			parentMC.removeChild(burstSprite);
//			tField = null;
//			burstSprite = null;
			delete this;
		}
		public function setScaleChangeOn(b:Boolean){
			scaleChangeOn = b;
		}
		public function setColorChangeOn(b:Boolean){
			colorChangeOn = b;
		}
		public function setBounceOn(b:Boolean){
			bounceOn = b;
		}
	}
}