﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	import flash.text.*;

	
	public class PopUpBox extends MovieClip{
		private var mC:MovieClip;
		private var duration:int;//-1=infinity
		private var lastTimeOST:uint;
		private var startOn:Boolean = false;
		private var gameTimeFunc:Function;
		
		private var storeArray:Array = null;//To keep it from being removed by garbage collector
		
		private var dispArray:Array;
		private var xDispSpeed:Number = 0;
		private var xDispSpeedNew:Number = 0;
		private var xDispAcc:Number = 0;
		private var yDispSpeed:Number = 0;
		private var yDispSpeedNew:Number = 0;
		private var yDispAcc:Number = 0;
		private var dispArrayCounter:uint = 0;
		private var dispOn:Boolean = false;
		private var dispArrayDuration:uint;
		private var lastTimeDispChange:uint;
		private var lastTimeDisp:uint;

		public function PopUpBox(){
	
		}
		public function start(pMC:MovieClip,pDuration:int,pDispArray:Array,pGameTimeFunc:Function=null){
			//If already running, remove previous activity
			mC = pMC;
			duration = pDuration;
			dispArray = pDispArray;
			gameTimeFunc = pGameTimeFunc;
			if(startOn){
				removeEventListener(Event.ENTER_FRAME, runOST);
			}
			startOn = true;
			addChild(mC);
			if(!Boolean(pGameTimeFunc)){
				gameTimeFunc = getTimer;
			}
			else{
				gameTimeFunc = pGameTimeFunc;
			}
			if(Boolean(pDispArray)){
				startDisp(dispArray);
			}
			//start running
			addEventListener(Event.ENTER_FRAME, runOST);
			lastTimeOST = gameTimeFunc();
		}
		public function setStoreArray(pArray:Array){
			storeArray = pArray;
			storeArray.push(this);
		}
		public function startDisp(pArray:Array){
			removeDisp();
			dispOn = true;
			
			lastTimeDisp = gameTimeFunc();//For when the duration of disp is up
			lastTimeDispChange = 0;
			dispArrayCounter = 0;
			
			dispArray = pArray;
			
			xDispSpeed = pArray[0];
			xDispSpeedNew = pArray[0];
			xDispAcc = pArray[1];
			yDispSpeed = pArray[2];
			yDispSpeedNew = pArray[2];
			yDispAcc = pArray[3];
			dispArrayDuration = pArray[4];				
				
			addEventListener(Event.ENTER_FRAME, dispTimer);
		}
		private function dispTimer(event:Event){
			var fTimePassed:uint = gameTimeFunc()-lastTimeDisp;
			lastTimeDisp+=fTimePassed;
			if(dispArray!=null && dispArray.length>dispArrayCounter){//Custom AO Movement
				lastTimeDispChange+=fTimePassed;
				if(lastTimeDispChange>=dispArrayDuration){
					moveX(fTimePassed-(lastTimeDispChange-dispArrayDuration), xDispSpeedNew,xDispAcc);
					moveY(fTimePassed-(lastTimeDispChange-dispArrayDuration), yDispSpeedNew,yDispAcc);
					xDispSpeedNew += xDispAcc*(fTimePassed-(lastTimeDispChange-dispArrayDuration))/1000;
					yDispSpeedNew += yDispAcc*(fTimePassed-(lastTimeDispChange-dispArrayDuration))/1000;

					fTimePassed = lastTimeDispChange-dispArrayDuration;//Remove the overflow of time
					lastTimeDispChange = fTimePassed;

					dispArrayCounter+=5;//5 because xSpeed0, ySpeed0, xAcc0, yAcc0, duration0 -> next set
					if(dispArray.length>dispArrayCounter){
						xDispSpeed = dispArray[dispArrayCounter];
						xDispSpeedNew = xDispSpeed;
						xDispAcc = dispArray[dispArrayCounter+1];
						yDispSpeed = dispArray[dispArrayCounter+2];
						yDispSpeedNew = yDispSpeed;
						yDispAcc = dispArray[dispArrayCounter+3];
						dispArrayDuration = dispArray[dispArrayCounter+4];
						lastTimeDispChange = 0;
					}
					else{
						dispArrayDuration = 0;
						dispOn = false;
						removeEventListener(Event.ENTER_FRAME, dispTimer);
					}
				}
			}
			else{
				dispArrayDuration = 0;
				dispOn = false;
				removeEventListener(Event.ENTER_FRAME, dispTimer);
			}
			if(dispOn){
				moveX(fTimePassed,xDispSpeedNew,xDispAcc);
				moveY(fTimePassed,yDispSpeedNew,yDispAcc);
				xDispSpeedNew += xDispAcc*fTimePassed/1000;
				yDispSpeedNew += yDispAcc*fTimePassed/1000;
			}
		}
		private function moveX(pTimePassed:uint,pDispSpeedNew:Number,pDispAcc:Number){
			mC.x += pDispSpeedNew*pTimePassed/1000 + .5*pDispAcc*Math.pow(pTimePassed/1000,2);
		}
		private function moveY(pTimePassed:uint,pDispSpeedNew:Number,pDispAcc:Number){
			mC.y += pDispSpeedNew*pTimePassed/1000 + .5*pDispAcc*Math.pow(pTimePassed/1000,2);
		}
		private function removeDisp(){
			if(dispOn){
				xDispSpeed = 0;
				yDispSpeed = 0;
				xDispSpeedNew = 0;
				yDispSpeedNew = 0;
				xDispAcc = 0;
				yDispAcc = 0;
				dispArrayDuration = 0;
				dispOn = false;
	//				kBDirectionXLock = false;//to turn off prevention of x movement while kb'ed
				removeEventListener(Event.ENTER_FRAME, dispTimer);
			}
		}
		private function runOST(e:Event){
			if(gameTimeFunc()-lastTimeOST >= duration && duration!=-1){
				end();
			}
		}
		public function end(){
			if(dispOn){
				removeDisp();
			}
			if(storeArray!=null){
				ArrayHelper.findAndRemove(storeArray,this);
			}
			startOn = false;
			removeEventListener(Event.ENTER_FRAME, runOST);
			if(this.contains(mC)){
				removeChild(mC);
			}
			if(Boolean(parent)){
				parent.removeChild(this);
			}
			delete this;
		}
		public function removeObjEvent(){
			removeEventListener(Event.ENTER_FRAME, runOST);
		}
		public function getStartOn():Boolean{
			return startOn;
		}
	}
}