﻿package {
	import flash.utils.Timer;
	import flash.utils.getTimer;
	import flash.events.*;
	import flash.display.*;
	import flash.media.Sound;
	import flash.utils.getQualifiedClassName;
	import flash.geom.Point;
	public class Skill extends MovieClip {
		static const DMG_RANGE_BONUS_PER_TECH:Number = 0;//Amount of additional min dmg range per each point of technique attribute
		static const DMG_ENERGY_MIN:Number = 1;//% of dmg at 0 shield (if 1, shield does not affect dmg)

		private var thisSkill:Skill;
		//Class Var
		//Skill properties
		private var skillName:String = null;
		private var skillInput:Array = null;
		private var skillInputType:String = "attack";//"attack" or "defense"
		private var skillGroundAirType:String = "ground";//"ground", "air", anything else = both so just leave as null
		private var skillGroundAirHitType:String = null;//"ground"=only hits ground enemies, "air"=~, null = hits both
		private var skillAirLandingCancelOn:Boolean = true;//If "air" skillGroundAirType, then true=skill cancels if landed, false=skill continues if landed
		private var grabOn:Boolean = false;//true=Only hits if target is not stunned, block stunned, or casting
		private var hPCost:int = 0;
		private var shieldCost:int = 0;
		private var focusCost:int = 0;
		private var castConditionFunc:Function = null;//Parameter is (pPlayer:Player), returns Boolean
		private var castTime:uint;
		private var castTimeNew:Number = 0;//In case of castTime speed change (i.e. technique attri), store in new var
		private var activateTime:uint;
		private var rechargeTime:uint = 0;
		private var _cooldown:uint = 0;//*NO USE*Put in PhysObjDef instead
		private var shadowOn:Boolean = true;
		
		private var chainReq:uint = 0;
		private var stanceReq:Array = null;//[#]=null == can be used normally (only difference is it can also be used in specified exclusive stances)
		private var skillType:String;//"none", "projectile", "shield", "melee", "player"
		private var aOGraphic:Array;//null, graphicClassName
		private var skillSymbol:String;
		private var graphicJumpOn:Boolean = false;
		private var _mvSpeedArray:Array;
		private var playerDisplacementArray:Array = null;
		private var playerZDisplacementArray:Array = null;
		private var playerDisplacementFreezeOn:Boolean = false;//true=speed stacks, false=immediate speed change
		private var playerZDisplacementFreezeOn:Boolean = false;//true=speed stacks, false=immediate speed change
		private var aerialFreezeDuration:uint = 0;//How long player will be suspended in the air (if it's an air skill)
		private var cUninterruptableOn:Boolean = false;
		private var aUninterruptableOn:Boolean = false;
		private var autoBlockCOn:Boolean = false;
		private var autoBlockAOn:Boolean = false;
		
		private var fixedDirection:String = null;//"left"=always faces left, "right"=always faces right
		
		private var skillLvl:int = 0;
	
		//REMOVE LATER
		private var playerXDisplacementDuration:int = 0;
		private var playerXDisplacementSpeed:int = 0;
		private var playerXDisplacementAcc:int = 0;
		/////
		
		private var playerDisplacementInitialOn:Boolean = false;//True=Disp during cast, false=Disp after cast
		private var playerZDisplacementInitial:Boolean = false;//True=Disp during cast, false=Disp after cast
		private var skillDescription:String = null;
		
		private var cancelCastOn:Boolean = false;
		private var cancelActivateOn:Boolean = false;
		private var cancelCastStart:int = 0;
		private var cancelCastEnd:int = 0;
		private var cancelActivateStart:int = 0;//Time after activation starts when you can cancel (i.e. 0=right in the beginning)
		private var cancelActivateEnd:int = 0;//After this time, no longer cancellable
		private var cancelCCriticalStart:int = 0;
		private var cancelCCriticalEnd:int = 0;		
		private var cancelACriticalStart:int = 0;
		private var cancelACriticalEnd:int = 0;
		private var strictCancelAOn:Boolean = false;
		private var strictCancelAInputSkillNameArray:Array = null;
		private var strictCancelACastSkillNameArray:Array = null;
		private var strictCancelAInputSkillNameArrayOptional:Array = null;//strictCancel skills that are not immediately added and only work if their respective skills are added
		private var strictCancelACastSkillNameArrayOptional:Array = null;//strictCancel skills that are not immediately added and only work if their respective skills are added
		private var strictCancelAStart:uint = 0;
		private var strictCancelAEnd:uint = 0;
		private var strictCancelCOn:Boolean = false;
		private var strictCancelCInputSkillNameArray:Array = null;
		private var strictCancelCCastSkillNameArray:Array = null;
		private var strictCancelCInputSkillNameArrayOptional:Array = null;//strictCancel skills that are not immediately added and only work if their respective skills are added
		private var strictCancelCCastSkillNameArrayOptional:Array = null;//strictCancel skills that are not immediately added and only work if their respective skills are added
		private var strictCancelCStart:uint = 0;
		private var strictCancelCEnd:uint = 0;
		private var cancelPointTime:uint = 300;//Time after activation in which cancel skill executes
		private var cancelPointInstantStartTime:uint = 0;//Time after initiation in which cancel skill executes when inputted (includes castTime)
		private var cancelPointNewCastTime:int = -1;//-1=no new cast time, else this skill castTime=~ when it's cast as a cancelPointSkill 
		private var cancelPointSkillNameArray:Array = null;//[0]="include" or "exclude", [1]=inputArray, ([2]=SkillNameArray to execute in order of precedents for the given input)*only for "include"
		private var cancelPointInstantStartSkillNameArray:Array = null;//[0]="include" or "exclude", [1]=inputArray, ([2]=SkillNameArray to execute in order of precedents for the given input)*only for "include"
		private var instantCancelOn:Boolean = false;
//		private var cancelCriticalProp:Number = 0;//starting from center of cActivateStart and cActivateEnd, the time proportion between 0 and 1 
												 //of the total cancellable duration where a critical hit is registered
		private var endOnHit:Boolean = false;
		private var endOnHitSkillName:String = null;
		
		private var	counterAttackSkillName:String = null;
		private var	counterAttackMissC:Boolean = false;//One attack misses during cast
		private var	counterAttackMissA:Boolean = false;
		private var counterAttackCOn:Boolean = false;//Skill will end when hit (or miss) and CA skill will start (if not null)
		private var counterAttackAOn:Boolean = false;
		
		private var landingSkillName:String = null;
		
		private var chainSkillNameArray:Array = null;
		
		private var criticalSkillName:String = null;
		
		private var exclusiveStanceOn:Boolean = false;
		private var stanceEnd:Boolean = false;//Ends stance after cast
		//For Attack Obj
		private var aOHitOn:Boolean = true;//If the AO hits when in contact with anything (perhaps without damage i.e. grenade type effect)
		private var aODmgOn:Boolean = true;//If dmg is even displayed
		private var aOMeleeHitOn:Boolean = true;//true=Player takes dmg when melee hits melee with >= priority, false=no dmg(i.e. infinitely high priority)
		private var aOBackHitOn:Boolean = true;//Will register back hits
		private var _dmgRaw:Number = 0;
		private var _dmgRatio:Number = 0;
		private var _hitMultHash:Object;
		private var aODmg:int;//2 ratio is regular, 7 ratio is a little less than OHK against 5 hp opponent of same lvl, 8 is always OHK against 5 hp
		private var aODmgRatio:Number = 1;//Number to multiply by the base dmg, always + (Math.abs to make sure anyways)
		private var aODmgRangeMin:Number = .8;//minimum % randomized damage to max which is 1
		private var aODmgReduction:Number = 0;//The dmg for this attack is reduced by this much%/combo
		private var aOShieldDmg:Number = 0;
		private var aOFocusDmg:Number = 0;
		private var aOLifeStealOn:Boolean = false;//Steals amount of life based on damage dealt
		
		//REMOVE LATER
		private var aODmgGrowth:int;
		private var aODmgMod:int;//NOT in AttackObject object, used to calc dmg formula, reduces player dmg stat		
		////////////////
		
		private var dmgFormType:uint;//NOT in AttackObject object, used to calc dmg formula, formula type, 0=normal, 1=totalDmg==dmgRatio
		private var playerDmgStat:uint;//NOT in AttackObject object, used to calc dmg formula
		private var playerDmgStatType:String;//NOT in AttackObject object, used to calc dmg formula
		private var playerLvl:uint;

		private var aOHPCurrent:int;
		private var aOHPMax:int;
		private var aOHitMax:uint = 0;//for melee, so aO cannot hit a single player more than the max
		private var duration:int;// 0 for no duration (infinite existence)
		private var attackFreq:int;
		private var dmgType:String;//"physical", "magical", "psycho"
		private var aOPriority:uint = 5;//0-10, if two melee attacks clash, the one with higher priority will win.
		private var attackFreezeDuration:uint = 250;//Movement freezes for attackFreezeDuration when hit
		private var stun:int = 0;
		private var stunReduction:Number = .02;//The stun duration for this attack is reduced by this much%/combo
		private var disable:int = 0;
		private var blockStun:int = 100;//If hit while blocking, forced to block an additional ~ until movement again
		private var _kBHash:Object = null;
		private var _kBFreeFall:Object = null;//{hXVel:,hYVel:}Automatically adds a freefall control, gravity defined in physObjDef
		private var kBComboMod:Number = 1.04;
		private var kBMoveEqualOn:Boolean = false;//KB is = to xMvSpeed
		private var kUOn:Boolean = false;//true=hit will cause kU, false=kU will only occur if opponent is already in air
		private var kUVel:Number = -75;//pixel/sec upwards, - = up, + = down
		private var kUComboMod:Number = .985;//Cumulative reduction of KU vel and air rec time accumulated while player is hit during KU or KD (0-1, 0=complete reduction, 1=no reduction)
		private var kUAirRecDuration:Number = 10000;//Amount of time not able to air recover (e.g. 0=Instantly able to air recover), Make it the same as stun for now
		private var kUForceSpeedChangeOn:Boolean = false;//true = KU speed instantly changes to new kUVel AND is not affected by kUComboReduction, false = KU speed stacks
		private var kUForceBounceOn:Boolean = false;//Forces bounces regardless of the bounce thresh
//		private var kUXSpeedAngleOn:Boolean = false;//true = KB will depend on the angle of the hit
		private var kDOn:Boolean = false;//true = causes KD
		private var kDHitOn:Boolean = false;//true = Will hit KD'ed foes
		private var kDTime:uint = 450;//KD time on ground ONLY (not including fall and rise time)
		private var interruptOn:Boolean = false;
		private var aOPlayerStick:Boolean = false;//aO anchors to player position
		private var aOPlayerStickZ:Boolean = false;//aO Z anchors to player Z
		private var aOHomingArray:Array = null;
		private var aOAntiProjectileOn:Boolean = false;
		private var aOIndestructableOn:Boolean = false;
		private var aODirectionFacingPlayerOn:Boolean = false;//When transforming, new AO faces direction of the player instead of former AO
		
		//REMOVE LATER
		private var xSpeed:Number;
		private var xAcc:Number
		private var ySpeed:Number;
		private var yAcc:Number = 0;
		////////////////
		
		private var aOSpeedArray:Array = null;//xSpeed0, xSpeedMax0, xAcc0, ySpeed0, ySpeedMax0, yAcc0, duration0, xSpeed1... etc....null=loop prev speed commands
		private var aOSpeedFunc:Function = null;//Parameters(pAO:AttackObject):Array, used for dynamic speeds (homing, etc)
		private var accu:int;
		private var aODispOrigin:String = "center"; //AO displacement origin: center(default), front, back, top, bottom
		private var aOXDisplacement:Number;
		private var aOYDisplacement:Number;
		private var aOZDisplacement:Number = 0;//graphical y origin
		private var aOZDispPlayerReferenceOn:Boolean = true;//true=z is based on player reference, false=aO will be at the exact z-coord of aOZDisplacement
		private var aOZSpeedArray:Array = null;//zSpeed0, zSpeedMax0, zAcc0, duration0, etc...
		private var aOMovementFacingOn:Boolean = false;//AO moves facing the direction of it's x/z movement
		private var aOScaleX:Number = 1;
		private var aOScaleY:Number = 1;
		private var aORotation:Number = 0;
		private var aOWidth:Number = 0;
		private var aOHeight:Number = 30;
		private var aOZ:Array = null;//If null, then take the AO graphics height, if no AO, then take player's height.  If not null, then [0]=z y-start(<=0)(0=start from bottom,<0=start higher than bottom), [1]=z y-height (-#)
		private var aOLandingDeathOn:Boolean = false;//AO dies when it hits the ground
		private var collisionType:String;//*NEW: opponent team is "opponent", same team is "same", all team is "all", no team is "none".... *OLD:0 is player team, 1 is opponent team, 2 is both (hostile, triggers on both sides), 3 is neither (neutral, triggers on no side), 4 is trigger all
		private var collisionTypeDelayArray:Array = null;//[0]=newCollisionType for AO to become:String(i.e."opponent", etc.), [1]=delay until becomes that team (can use this instead of transform, not recommended tho)
		
		private var aOTransformTypeArray:Array = null;//"hit","death","channeling","duration"
		private var aOTransformSkillNameArray:Array = null;//The associated skill with aOTransformSkillArray
		
		private var playerCastAniArray:Array = null;//[n]="start___",[n+1]="cEnd___",[n+2]=#Loops, [n+3]=cDuration,etc
		private var playerActivateAniArray:Array = null;//[n]="start___",[n+1]="cEnd___",[n+2]=#Loops, [n+3]=cDuration,etc
		private var aOUpsideDownOn:Boolean = false;
		private var aOAniArray:Array = null;//[0]=startLabel,[1]=endLabel,[2]=Loop#,[3]=Duration,[4]=SoundArray[ClassName,Frame# or Label,Vol,false]
		private var aOAniDuration:uint = 0;//0 causes AO to just use the duration as aniDuration (this is for endless loops)
		private var dmgFXArray:Array = null;
		
		private var unblockableOn:Boolean = false;
		private var unblockableType:String = null;//"air" or "ground", DON'T USE FOR NOW, only use unblockableOn
//		private var focusSkillOn:Boolean = false;//Used in Player addAFT(aO);
		
		private var req:Array = [0];//Attrib req to learn skill (Str, Int, Fash, Bum, Obe, Mas)
		private var reqSkills:Array = null;//Req skill names that are needed to learn skill
		private var preSkillName:String;//Skill req. and to be replaced with this skill ("none" if none)
		//For Stances
		private var stanceAniArray:Array = null;//[0]=startStandAniName,[0]=endStandAniName,[1]=standAniDuration,...walk...run...jump...[11]
		private var transformOn:Boolean;//True:Become the graphic (alpha away player graphic), False: just stick behind player graphic
		private var bonus:Number;//Any numerical bonus from stance, to be used to take away the same amount at end of stance		
		//For Both
		private var startAOEffectFunc:Function = null;//Occurs when AOPlayer hit
		private var endAOEffectFunc:Function = null;
		private	var startAOConstEffectFunc:Function = null;//Occurs as long as AO and Player are in contact
		private	var endAOConstEffectFunc:Function = null;
		private var startSkillCastFunc:Function = null;//Occurs right from start of skill
		private var endSkillCastFunc:Function = null;
		private var startSkillActivateFunc:Function = null;//Occurs when skill is activated
		private var endSkillActivateFunc:Function = null;
		private var startStanceEffectFunc:Function = null;
		private var endStanceEffectFunc:Function = null;
		private var lastTimeEffect:uint;
		private var gameTimeFunc:Function;
		private var effectDuration:uint;
		private var soundArray:Array = null;//[castSoundName, castStartFrame, castVol, activateSoundName, activateStartFrame, activateVol]
		private var echoSoundArray:Array = null;//[soundName, castVol, echoInterval, # of echo, echoMultiplier]
		private var aOSoundArray:Array = null;//[soundName, frame#, volume];
		private var aOEchoSoundArray:Array = null;//[soundName, castVol, echoInterval, # of echo, echoMultiplier]
		//For Equipment
		private var channelOn:Boolean = false;
		private var channelDelay:uint=0;//Delay before channeled skill is cast
		private var channelNum:int=0;//Number of times channeled skill can be used in one channeling, -1=infinite
		//DYNAMIC class variables (THE FEW VARIABLES THAT !AFFECT! SKILL)
		private var castOn:Boolean = false;
		private var lastTimeCast:int = 0;
		private var lastTimeCastFinish:int = 0;
		private var activateOn:Boolean = false;
		private var rechargeOn:Boolean = false;
		private var hasHit:Boolean = false;//For when a skill hits in Player
		private var counterA:uint = 0;//For all your counting needs (ex. Shiny Rotating Box count)
		
		private var skillTempArray:Array = null;//Just add a temp skill for the chain skill, counter skill, etc.  If null, then try to grab from the skillArray.
		private var stanceSkillArray:Array = null;//Stance temp skill set: [[Ground c, ground left,...ground down],[air...][stance...]]
		
		private var doesNotExistOn:Boolean = false;
		
		private var _mouseAimOn:Boolean = false;
		private var _kB:Object = {};
		public function get mouseAimOn():Boolean{
			return _mouseAimOn;
		}
		public function set mouseAimOn(b:Boolean){
			_mouseAimOn = b;
		}
		
		public function Skill(){
			thisSkill = this;
		}
		public function getSkillLvl():int{
			return skillLvl;
		}
		public function setSkillLvl(pSkillLvl:int){//Start at 1, 0 = does not have this skill
			skillLvl = pSkillLvl;
			setSkill(skillName);
		}
		public function setSkill(pSkillName:String) {
			var fSkillBase:Skill;
			var i:uint=0;
			//Mr. Cat Skills
			switch(pSkillName){
				/*********************************************************************
										MAMA CAT
				**********************************************************************/
				case "Bark0":
					skillName = pSkillName;
					skillInput = ["Normal"];
					
					castTime = 150;
					activateTime = 250;
					//_cooldown = 250;
				
					//_mvSpeedArray = [{hName:skillName,hVelX:0,hAccX:0,hVelY:-40,hAccY:0,hTier:2,hDuration:500},"add"];
					//playerDisplacementArray = [30*(1000/activateTime),0,0,0,activateTime];
					//playerDisplacementInitialOn = true;
					
					duration = 1000;
					attackFreq = 200;
					aOHitMax = 3;
					
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[200,null,0,500],hYMvArray:[-200*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBHash = [30*(1000/activateTime),0,0,0,500];
					//_kBFreeFall = {hXVel:200,hYVel:-200};
					stun = activateTime;
					disable = 0;
					
					_dmgRaw = 0;
					_dmgRatio = -1;
					aODmgRatio = -1;
					
					break;
				case "Poke":
					skillName = pSkillName;
					
					duration = 5000;
					aOHitMax = 1;
					attackFreq = 5000;
					
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[200,null,0,500],hYMvArray:[-200*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[100,null,0,500],hYMvArray:[-400*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBFreeFall = {hXVel:20,hYVel:0};
					stun = activateTime;
					disable = 0;
					
					_dmgRaw = -0;
					_dmgRatio = -1;
					soundArray = [null,0,0, "SndSwosh0",0,1];
					dmgFXArray = ["Blunt0"];					
					break;
				case "KnockBack0":
					skillName = pSkillName;
					
					duration = 350;
					aOHitMax = 1;
					attackFreq = duration/aOHitMax;					
					
					_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[200,null,0,500],hYMvArray:[-200*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[100,null,0,500],hYMvArray:[-400*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBFreeFall = {hXVel:150,hYVel:-200};
					stun = activateTime;
					disable = 0;
					
					_dmgRaw = -1;
					_dmgRatio = -1;
					soundArray = [null,0,0, "SndSwosh0",0,1];
					dmgFXArray = ["Blunt0"];					
					break;
				case "Burn":
					skillName = pSkillName;
					
					//_mvSpeedArray = [{hName:skillName,hVelX:-40,hAccX:0,hVelY:-40,hAccY:0,hTier:2,hDuration:500},"add"];
					
					duration = 350;
					aOHitMax = 1;
					attackFreq = duration/aOHitMax;					
					
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[200,null,0,500],hYMvArray:[-200*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					_kBHash = {hName:pSkillName,hType:"linear",hDef:{hVel:300,hAcc:-300,hSpread:0},hTier:{hTierNum:2,hType:"replace"},hDuration:1000};
					stun = activateTime;
					disable = 0;
					
					_dmgRaw = -1;
					_dmgRatio = -1;
					soundArray = [null,0,0, "SndSwosh0",0,1];
					dmgFXArray = ["Blunt0"];
					
					break;
				case "BurnUp":
					skillName = pSkillName;
					
					duration = 350;
					aOHitMax = 1;
					attackFreq = duration/aOHitMax;					
					
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[200,null,0,500],hYMvArray:[-200*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[100,null,0,500],hYMvArray:[-400*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					_kBFreeFall = {hXVel:300,hYVel:-300};
					stun = activateTime;
					disable = 0;
					
					_dmgRaw = -1;
					_dmgRatio = -1;
					soundArray = [null,0,0, "SndSwosh0",0,1];
					dmgFXArray = ["Blunt0"];					
					break;
				case "BurnDown":
					skillName = pSkillName;
					
					duration = 350;
					aOHitMax = 1;
					attackFreq = duration/aOHitMax;					
					
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[200,null,0,500],hYMvArray:[-200*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[100,null,0,500],hYMvArray:[400*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					_kBFreeFall = {hXVel:300,hYVel:-300};
					stun = activateTime;
					disable = 0;
					
					_dmgRaw = -1;
					_dmgRatio = -1;
					soundArray = [null,0,0, "SndSwosh0",0,1];
					dmgFXArray = ["Blunt0"];					
					break;
				case "KnockUp":
					skillName = pSkillName;
					
					duration = 2000;
					aOHitMax = 99999;
					attackFreq = 5000;					
					
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[200,null,0,500],hYMvArray:[-200*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[100,null,0,500],hYMvArray:[400*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					_kBFreeFall = {hXVel:0,hYVel:-200};
					stun = activateTime;
					disable = 0;
					
					_dmgRaw = 0;
					_dmgRatio = -1;
					soundArray = [null,0,0, "SndSwosh0",0,1];
					dmgFXArray = ["Blunt0"];					
					break;
				case "Curse":
					skillName = pSkillName;
					
					duration = 100;
					aOHitMax = 1;
					attackFreq = duration/aOHitMax;					
					
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[0,null,0,500],hYMvArray:[0,null,0,500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[100,null,0,500],hYMvArray:[400*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBFreeFall = {hXVel:0,hYVel:0};
					stun = activateTime;
					disable = 0;
					
					_dmgRaw = -1;
					_dmgRatio = -1;
					_hitMultHash = {hRatio:1.1,hDuration:4000};
					
					soundArray = [null,0,0, "SndSwosh0",0,1];
					dmgFXArray = ["Blunt0"];					
					break;
				case "CurseRing":
					skillName = pSkillName;
					
					duration = 2000;
					aOHitMax = 4;
					attackFreq = duration/aOHitMax;					
					
					_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[0,null,0,500],hYMvArray:[0,null,0,500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					//_kBHash = {hName:pSkillName,hType:"pattern",hDef:{hXMvArray:[100,null,0,500],hYMvArray:[400*(1000/500),null,400*Math.pow(1000/500,2),500]},hTier:{hTierNum:2,hType:"replace"},hDuration:500};
					_kBFreeFall = {hXVel:0,hYVel:0};
					stun = activateTime;
					disable = 0;
					
					_dmgRaw = -1;
					_dmgRatio = -1;
					soundArray = [null,0,0, "SndSwosh0",0,1];
					dmgFXArray = ["Blunt0"];					
					break;
			}

		}
		//GET SET FUNCS
		public function getSkillName():String {
			return skillName;
		}
		public function getPreSkillName():String{
			return preSkillName;
		}
		public function getSkillInput():Array {
			return skillInput;
		}
		public function getSkillInputType():String {
			return skillInputType;
		}
		public function getSkillGroundAirType():String{
			return skillGroundAirType;
		}
		public function getSkillGroundAirHitType():String{
			return skillGroundAirHitType;
		}
		public function getSkillAirLandingCancelOn():Boolean{
			return skillAirLandingCancelOn;
		}
		public function getGrabOn():Boolean{
			return grabOn;
		}
		public function getCastTime():int{
			return castTime;
		}
		public function getActivateTime():int{
			return activateTime;
		}
		public function getRechargeTime():int{
			return rechargeTime;
		}
		public function get cooldown():uint{
			return _cooldown;
		}
		public function getShadowOn():Boolean{
			return shadowOn;
		}
		public function getHPCost():int {
			return hPCost;
		}
		public function getFocusCost():int {
			return focusCost;
		}
		public function getShieldCost():int {
			return shieldCost;
		}
		public function getCastConditionFunc():Function{
			return castConditionFunc;
		}
		public function getCastOn():Boolean {
			return castOn;
		}
		public function getActivateOn():Boolean {
			return activateOn;
		}
		public function setActivateOn(b:Boolean) {
			activateOn = b;
		}
		public function getRechargeOn():Boolean {
			return rechargeOn;
		}
		public function getCancelPointTime():uint{
			return cancelPointTime;
		}
		public function getCancelPointInstantStartTime():uint{
			return cancelPointInstantStartTime;
		}
		public function getChainReq():uint{
			return chainReq;
		}
		public function getStanceReq():Array{
			return stanceReq;
		}
		public function getSkillType():String {
			return skillType;
		}
		public function getAOGraphic():Array {
			return aOGraphic;
		}
		public function getSkillSymbol():String {
			return skillSymbol;
		}
		public function getGraphicJumpOn():Boolean{
			return graphicJumpOn;
		}
		public function get mvSpeedArray():Array{
			return _mvSpeedArray;
		}
		public function getPlayerDisplacementArray():Array {
			return playerDisplacementArray;
		}
		public function getPlayerZDisplacementArray():Array {
			return playerZDisplacementArray;
		}
		public function getPlayerDisplacementFreezeOn():Boolean{
			return playerDisplacementFreezeOn;
		}
		public function getPlayerZDisplacementFreezeOn():Boolean{
			return playerZDisplacementFreezeOn;
		}
		public function getAerialFreezeDuration():uint{
			return aerialFreezeDuration;
		}
		public function getPlayerXDisplacementSpeed():int {
			return playerXDisplacementSpeed;
		}
		public function getPlayerXDisplacementAcc():int {
			return playerXDisplacementAcc;
		}		
		public function getPlayerDisplacementInitialOn():Boolean {
			return playerDisplacementInitialOn;
		}
		public function getPlayerZDisplacementInitial():Boolean {
			return playerZDisplacementInitial;
		}
		public function getCancelCastOn():Boolean{
			return cancelCastOn;
		}
		public function getCancelActivateOn():Boolean{
			return cancelActivateOn;
		}
		public function getCancelCastStart():int{
			return cancelCastStart;
		}
		public function getCancelCastEnd():int{
			return cancelCastEnd;
		}
		public function getCancelActivateStart():int{
			return cancelActivateStart;
		}
		public function getCancelActivateEnd():int{
			return cancelActivateEnd;
		}
		public function getCancelCCriticalStart():int{
			return cancelCCriticalStart;
		}
		public function getCancelCCriticalEnd():int{
			return cancelCCriticalEnd;
		}
		public function getCancelACriticalStart():int{
			return cancelACriticalStart;
		}
		public function getCancelACriticalEnd():int{
			return cancelACriticalEnd;
		}
		public function getStrictCancelAOn():Boolean{
			return strictCancelAOn;
		}
		public function getStrictCancelAInputSkillNameArray():Array{
			return strictCancelAInputSkillNameArray;
		}
		public function getStrictCancelACastSkillNameArray():Array{
			return strictCancelACastSkillNameArray;
		}
		public function getStrictCancelAInputSkillNameArrayOptional():Array{
			return strictCancelAInputSkillNameArrayOptional;
		}
		public function getStrictCancelACastSkillNameArrayOptional():Array{
			return strictCancelACastSkillNameArrayOptional;
		}
		public function getStrictCancelACastSkillArray():Array{
			if(strictCancelACastSkillNameArray!=null){
				var fArray:Array = new Array(0);
				for(var i:uint=0; i<strictCancelACastSkillNameArray.length; i++){
					var fSkill:Skill = new Skill();
					fSkill.setSkill(strictCancelACastSkillNameArray[i]);
					if(!fSkill.getDoesNotExistOn()){
						fArray.push(fSkill);
					}
				}
				if(fArray.length==0){
					return null;
				}
				else{
					return fArray;
				}				
			}
			return null;
		}
		public function getStrictCancelAStart():uint{
			return strictCancelAStart;
		}
		public function getStrictCancelAEnd():uint{
			return strictCancelAEnd;
		}
		public function getStrictCancelCOn():Boolean{
			return strictCancelCOn;
		}
		public function getStrictCancelCInputSkillNameArray():Array{
			return strictCancelCInputSkillNameArray;
		}
		public function getStrictCancelCCastSkillNameArray():Array{
			return strictCancelCCastSkillNameArray;
		}
		public function getStrictCancelCInputSkillNameArrayOptional():Array{
			return strictCancelCInputSkillNameArrayOptional;
		}
		public function getStrictCancelCCastSkillNameArrayOptional():Array{
			return strictCancelCCastSkillNameArrayOptional;
		}
		public function getStrictCancelCCastSkillArray():Array{
			if(strictCancelCCastSkillNameArray!=null){
				var fArray:Array = new Array(0);
				for(var i:uint=0; i<strictCancelCCastSkillNameArray.length; i++){
					var fSkill:Skill = new Skill();
					fSkill.setSkill(strictCancelCCastSkillNameArray[i]);
					if(!fSkill.getDoesNotExistOn()){
						fArray.push(fSkill);
					}					
				}
				if(fArray.length==0){
					return null;
				}
				else{
					return fArray;
				}				
			}
			return null;
		}
		public function getStrictCancelCStart():uint{
			return strictCancelCStart;
		}
		public function getStrictCancelCEnd():uint{
			return strictCancelCEnd;
		}
		public function getCancelPointSkillNameArray():Array{
			return cancelPointSkillNameArray;
		}
		public function getCancelPointInstantStartSkillNameArray():Array{
			return cancelPointInstantStartSkillNameArray;
		}
		public function getInstantCancelOn():Boolean{
			return instantCancelOn;
		}
		public function getExclusiveStanceOn():Boolean{
			return exclusiveStanceOn;
		}
		public function getStanceAniArray():Array{
			return stanceAniArray;
		}
		public function getStanceEnd():Boolean{
			return stanceEnd;
		}
		public function getSoundArray():Array{
			return soundArray;
		}
		public function getEchoSoundArray():Array{
			return echoSoundArray;
		}
		public function getAOSoundArray():Array{
			return aOSoundArray;
		}
		public function getAOEchoSoundArray():Array{
			return aOEchoSoundArray;
		}
		public function getSkillDescription():String{
			return skillDescription;
		}
		
		//For dmgObj
		public function getChannelOn():Boolean{
			return channelOn;
		}
		public function getChannelDelay():uint{
			return channelDelay;
		}
		public function getChannelNum():int{
			return channelNum;
		}
		public function getUnblockableOn():Boolean{
			return unblockableOn;
		}
		public function getUnblockableType():String{
			return unblockableType;
		}
		public function getAOHitOn():Boolean{
			return aOHitOn;
		}
		public function getAODmgOn():Boolean{
			return aODmgOn;
		}
		public function getAOMeleeHitOn():Boolean{
			return aOMeleeHitOn;
		}
		public function getAOBackHitOn():Boolean{
			return aOBackHitOn;
		}
		public function get dmgRaw():Number{
			return _dmgRaw;
		}
		public function get dmgRatio():Number{
			return _dmgRatio;
		}
		public function get hitMultHash():Object{
			return _hitMultHash;
		}
		public function setAODmg(n:Number) {
			aODmg = n;
		}
		public function getAODmg():Number {
			return aODmg;
		}
		public function getAODmgRatio():Number{
			return aODmgRatio;
		}
		public function getAODmgRangeMin():Number{
			return aODmgRangeMin;
		}
		public function getAODmgReduction():Number{
			return aODmgReduction;
		}
		public function getAOShieldDmg():Number{
			return aOShieldDmg;
		}
		public function getAOFocusDmg():Number{
			return aOFocusDmg;
		}
		public function getAOLifeStealOn():Boolean{
			return aOLifeStealOn;
		}
		public function getDmgFormType():uint{
			return dmgFormType;
		}
		public function setPlayerDmgStat(i:uint){
			playerDmgStat = i;
		}
		public function getPlayerDmgStatType():String{
			return playerDmgStatType;
		}
		public function setPlayerLvl(i:uint){//Used in Game Class's createAttackObjectNow Func and AttackObject's constructor
			playerLvl = i;
		}
		public function getAOHPCurrent():int {
			return aOHPCurrent;
		}
		public function getAOHPMax():int {
			return aOHPMax;
		}
		public function getAOHitMax():uint{
			return aOHitMax;
		}
		public function getDuration():int {
			return duration;
		}
		public function getAttackFreq():int{
			return attackFreq;
		}
		public function get kBHash():Object {
			return _kBHash;
		}
		public function get kBFreeFall():Object{
			return _kBFreeFall;
		}
		public function getInterruptOn():Boolean{
			return interruptOn;
		}
		public function getCUninterruptableOn():Boolean{
			return cUninterruptableOn;
		}
		public function getAUninterruptableOn():Boolean{
			return aUninterruptableOn;
		}
		public function getAutoBlockCOn():Boolean{
			return autoBlockCOn;
		}
		public function getAutoBlockAOn():Boolean{
			return autoBlockAOn;
		}
		public function getFixedDirection():String{
			return fixedDirection;
		}
		public function getDmgType():String {
			return dmgType;
		}
		public function getAOPriority():int{
			return aOPriority;
		}
		public function getAttackFreezeDuration():uint{
			return attackFreezeDuration;
		}
		public function getStun():int{
			return stun;
		}
		public function getStunReduction():Number{
			return stunReduction;
		}
		public function getDisable():int{
			return disable;
		}
		public function getBlockStun():int{
			return blockStun;
		}
		public function getKDOn():Boolean{
			return kDOn;
		}
		public function getKDHitOn():Boolean{
			return kDHitOn;
		}
		public function getKDTime():uint{
			return kDTime;
		}
		public function getKUOn():Boolean{
			return kUOn;
		}
		public function getKUVel():Number{
			return kUVel;
		}
		public function getKUComboMod():Number{
			return kUComboMod;
		}
		public function getKBComboMod():Number{
			return kBComboMod;
		}
		public function getKBMoveEqualOn():Boolean{
			return kBMoveEqualOn;
		}
		public function getKUAirRecDuration():uint{
			return kUAirRecDuration;
		}
		public function getKUForceSpeedChangeOn():Boolean{
			return kUForceSpeedChangeOn;
		}
		public function getKUForceBounceOn():Boolean{
			return kUForceBounceOn;
		}
//		public function getKUXSpeedAngleOn():Boolean{
//			return kUXSpeedAngleOn;
//		}
		public function getXSpeed():Number {
			return xSpeed;
		}
		public function getXAcc():Number{
			return xAcc;
		}
		public function getYSpeed():Number {
			return ySpeed;
		}
		public function getYAcc():Number{
			return yAcc;
		}
		public function getAOSpeedArray():Array{
			return aOSpeedArray;
		}
		public function getAOSpeedFunc():Function{
			return aOSpeedFunc;
		}
		public function getAOHomingArray():Array{
			return aOHomingArray;
		}
		public function getAOPlayerStick():Boolean{
			return aOPlayerStick;
		}
		public function getAOPlayerStickZ():Boolean{
			return aOPlayerStickZ;
		}
		public function getAOAntiProjectileOn():Boolean{
			return aOAntiProjectileOn;
		}
		public function getAOIndestructableOn():Boolean{
			return aOIndestructableOn;
		}
		public function getAODirectionFacingPlayerOn():Boolean{
			return aODirectionFacingPlayerOn;
		}
		public function getAccu():int {
			return accu;
		}
		public function getAOXDisplacement():Number {
			return aOXDisplacement;
		}
		public function setAOXDisplacement(i:Number) {
			aOXDisplacement = i;
		}
		public function getAOYDisplacement():int {
			return aOYDisplacement;
		}
		public function getAODispOrigin():String{
			return aODispOrigin;
		}
		public function getCollisionType():String {
			return collisionType;
		}
		public function getCollisionTypeDelayArray():Array{
			return collisionTypeDelayArray;
		}
		public function getAOHeight():Number{
			return aOHeight;
		}
		public function getAOWidth():Number{
			return aOWidth;
		}
		public function getAOZ():Array{
			return aOZ;
		}
		public function getAOLandingDeathOn():Boolean{
			return aOLandingDeathOn;
		}
		public function getAOZDisplacement():Number{
			return aOZDisplacement;
		}
		public function getAOZDispPlayerReferenceOn():Boolean{
			return aOZDispPlayerReferenceOn;
		}
		public function getAOZSpeedArray():Array{
			return aOZSpeedArray;
		}
		public function getAOMovementFacingOn():Boolean{
			return aOMovementFacingOn;
		}
		public function getAOScaleX():Number{
			return aOScaleX;
		}
		public function getAOScaleY():Number{
			return aOScaleY;
		}
		public function getAORotation():Number{
			return aORotation;
		}
		public function getReq():Array{
			return req;
		}
		public function getReqSkills():Array{
			return reqSkills;
		}
		public function getPlayerCastAniArray():Array{
			return playerCastAniArray;
		}
		public function getPlayerActivateAniArray():Array{
			return playerActivateAniArray;
		}
		public function getAOAniArray():Array{
			return aOAniArray;
		}		
		public function getDmgFXArray():Array{
			return dmgFXArray;
		}
		public function getTransformOn():Boolean{
			return transformOn;
		}
		public function getStartSkillCastFunc():Function{
			return startSkillCastFunc;
		}
		public function getEndSkillCastFunc():Function{
			return endSkillCastFunc;
		}
		public function getStartSkillActivateFunc():Function{
			return startSkillActivateFunc;
		}
		public function getEndSkillActivateFunc():Function{
			return endSkillActivateFunc;
		}
		public function getStartStanceEffectFunc():Function{
			return startStanceEffectFunc;
		}
		public function getEndStanceEffectFunc():Function{
			return endStanceEffectFunc;
		}
		public function getStartAOEffectFunc():Function{
			return startAOEffectFunc;
		}
		public function getEndAOEffectFunc():Function{
			return endAOEffectFunc;
		}
		public function getStartAOConstEffectFunc():Function{
			return startAOConstEffectFunc;
		}
		public function getEndAOConstEffectFunc():Function{
			return endAOConstEffectFunc;
		}
		public function getAOTransformTypeArray():Array{
			return aOTransformTypeArray;
		}
		public function getAOTransformSkillNameArray():Array{
			return aOTransformSkillNameArray;
		}
		public function getAOTransformSkillArray():Array{
			if(aOTransformSkillNameArray!=null){
				var fArray:Array = new Array(0);
				for(var i:uint=0; i<aOTransformSkillNameArray.length; i++){
					var fSkill:Skill = new Skill();
					fSkill.setSkill(aOTransformSkillNameArray[i]);
					if(fSkill.getDoesNotExistOn()){
						fArray.push(null);
					}
					else{
						fArray.push(fSkill);
					}
				}
				return fArray;
			}
			return null;
		}
		public function setHasHit(b:Boolean){
			hasHit = b;
		}
		public function getHasHit():Boolean{
			return hasHit;
		}
		public function getEndOnHit():Boolean{
			return endOnHit;
		}
		public function getEndOnHitSkillName():String{
			return endOnHitSkillName;
		}
		public function getEndOnHitSkill():Skill{
			if(endOnHitSkillName!=null){
				var fSkill:Skill = new Skill();
				fSkill.setSkill(endOnHitSkillName);
				if(fSkill.getDoesNotExistOn()){
					return null;
				}
				return fSkill;		
			}
			return null;
		}
		public function getCounterAttackCOn():Boolean{

			return counterAttackCOn;
		}
		public function getCounterAttackAOn():Boolean{
			return counterAttackAOn;
		}
		public function getCounterAttackSkill():Skill{
			if(counterAttackSkillName!=null){
				var fSkill:Skill = new Skill();
				fSkill.setSkill(counterAttackSkillName);
				if(fSkill.getDoesNotExistOn()){
					return null;
				}
				return fSkill;				
			}
			return null;
		}
		public function getCounterAttackSkillName():String{
			return counterAttackSkillName;
		}
		public function getLandingSkill():Skill{
			if(landingSkillName!=null){
				var fSkill:Skill = new Skill();
				fSkill.setSkill(landingSkillName);
				if(fSkill.getDoesNotExistOn()){
					return null;
				}
				return fSkill;				
			}
			return null;
		}
		public function getLandingSkillName():String{
			return landingSkillName;
		}
		public function getChainSkillNameArray():Array{
			return chainSkillNameArray;
		}
		public function getChainSkillArray():Array{
			if(chainSkillNameArray!=null){
				var fArray:Array = new Array(0);
				for(var i:uint=0; i<chainSkillNameArray.length; i++){
					var fSkill:Skill = new Skill();
					fSkill.setSkill(chainSkillNameArray[i]);
					if(!fSkill.getDoesNotExistOn()){
						fArray.push(fSkill);
					}					
				}
				if(fArray.length==0){
					return null;
				}
				else{
					return fArray;
				}
			}
			return null;
		}
		public function getCriticalSkillName():String{
			return criticalSkillName;
		}
		public function getCriticalSkill():Skill{
			if(criticalSkillName!=null){
				var fSkill:Skill = new Skill();
				fSkill.setSkill(criticalSkillName);
				if(fSkill.getDoesNotExistOn()){
					return null;
				}
				return fSkill;
			}
			return null;
		}
		public function getCounterAttackMissC():Boolean{
			return counterAttackMissC;
		}
		public function getCounterAttackMissA():Boolean{
			return counterAttackMissA;
		}
		public function getAOUpsideDownOn():Boolean{
			return aOUpsideDownOn;
		}
		public function getSkillTempArray():Array{
			return skillTempArray;
		}
		public function getStanceSkillArray():Array{
			return stanceSkillArray;
		}
		public function getDoesNotExistOn():Boolean{
			return doesNotExistOn;
		}
		//COPY SKILL
		private function copySkill(pSkillCName:String){
			var fSkillC:Skill = new Skill();
			fSkillC.setSkill(pSkillCName);
			
			skillName = fSkillC.getSkillName();
			preSkillName = fSkillC.getPreSkillName();
			skillInput = fSkillC.getSkillInput();
			skillInputType = fSkillC.getSkillInputType();
			skillGroundAirType = fSkillC.getSkillGroundAirType();
			skillGroundAirHitType = fSkillC.getSkillGroundAirHitType();
			skillAirLandingCancelOn = fSkillC.getSkillAirLandingCancelOn();
			grabOn = fSkillC.getGrabOn();
			hPCost = fSkillC.getHPCost();
			shieldCost = fSkillC.getShieldCost();
			focusCost = fSkillC.getFocusCost();
			castConditionFunc = fSkillC.getCastConditionFunc();
			chainReq = fSkillC.getChainReq();
			stanceReq = fSkillC.getStanceReq();
			castTime = fSkillC.getCastTime();
			activateTime = fSkillC.getActivateTime();
			rechargeTime = fSkillC.getRechargeTime();
			_cooldown = fSkillC.cooldown;
			_mouseAimOn = fSkillC.mouseAimOn;
			shadowOn = fSkillC.getShadowOn();
			cancelPointTime = fSkillC.getCancelPointTime();
			cancelPointInstantStartTime = fSkillC.getCancelPointInstantStartTime();
			
			cUninterruptableOn = fSkillC.getCUninterruptableOn();
			aUninterruptableOn = fSkillC.getAUninterruptableOn();
			autoBlockCOn = fSkillC.getAutoBlockCOn();
			autoBlockAOn = fSkillC.getAutoBlockAOn();
			
			fixedDirection = fSkillC.getFixedDirection();
			
			cancelCastOn = fSkillC.getCancelCastOn();
			cancelCastStart = fSkillC.getCancelCastStart();
			cancelCastEnd = fSkillC.getCancelCastEnd();
			cancelCCriticalStart = fSkillC.getCancelCCriticalStart();
			cancelCCriticalEnd = fSkillC.getCancelCCriticalEnd();
			criticalSkillName = fSkillC.getCriticalSkillName();
			
			cancelActivateOn = fSkillC.getCancelActivateOn();
			cancelActivateStart = fSkillC.getCancelActivateStart();
			cancelActivateEnd = fSkillC.getCancelActivateEnd();
			strictCancelAOn = fSkillC.getStrictCancelAOn();
			strictCancelAInputSkillNameArray = fSkillC.getStrictCancelAInputSkillNameArray();
			strictCancelACastSkillNameArray = fSkillC.getStrictCancelACastSkillNameArray();
			strictCancelAStart = fSkillC.getStrictCancelAStart();
			strictCancelAEnd = fSkillC.getStrictCancelAEnd();
			strictCancelCOn = fSkillC.getStrictCancelCOn();
			strictCancelCInputSkillNameArray = fSkillC.getStrictCancelCInputSkillNameArray();
			strictCancelCCastSkillNameArray = fSkillC.getStrictCancelCCastSkillNameArray();
			strictCancelCInputSkillNameArrayOptional = fSkillC.getStrictCancelCInputSkillNameArrayOptional();
			strictCancelCCastSkillNameArrayOptional = fSkillC.getStrictCancelCCastSkillNameArrayOptional();
			strictCancelCStart = fSkillC.getStrictCancelCStart();
			strictCancelCEnd = fSkillC.getStrictCancelCEnd();
			cancelPointSkillNameArray = fSkillC.getCancelPointSkillNameArray();
			cancelPointInstantStartSkillNameArray = fSkillC.getCancelPointInstantStartSkillNameArray();
			
			instantCancelOn = fSkillC.getInstantCancelOn();
			
			graphicJumpOn = fSkillC.getGraphicJumpOn();
			_mvSpeedArray = fSkillC.mvSpeedArray;
			playerDisplacementArray = fSkillC.getPlayerDisplacementArray();
			playerDisplacementInitialOn = fSkillC.getPlayerDisplacementInitialOn();
			playerDisplacementFreezeOn = fSkillC.getPlayerDisplacementFreezeOn();
			playerZDisplacementArray = fSkillC.getPlayerZDisplacementArray();
			playerZDisplacementInitial = fSkillC.getPlayerZDisplacementInitial();
			playerZDisplacementFreezeOn = fSkillC.getPlayerZDisplacementFreezeOn();
			aerialFreezeDuration = fSkillC.getAerialFreezeDuration();
			
			exclusiveStanceOn = fSkillC.getExclusiveStanceOn();
			stanceAniArray = fSkillC.getStanceAniArray();
			stanceEnd = fSkillC.getStanceEnd();
			transformOn = fSkillC.getTransformOn();
			
			collisionType = fSkillC.getCollisionType();
			collisionTypeDelayArray = fSkillC.getCollisionTypeDelayArray();
			skillType = fSkillC.getSkillType();
			aOGraphic = fSkillC.getAOGraphic();
			skillSymbol = fSkillC.getSkillSymbol();
			aOAntiProjectileOn = fSkillC.getAOAntiProjectileOn();
			aOIndestructableOn = fSkillC.getAOIndestructableOn();
			aODirectionFacingPlayerOn = fSkillC.getAODirectionFacingPlayerOn();

			aOHitOn = fSkillC.getAOHitOn();
			aODmgOn = fSkillC.getAODmgOn();
			aOMeleeHitOn = fSkillC.getAOMeleeHitOn();
			aOBackHitOn = fSkillC.getAOBackHitOn();
			_dmgRaw = fSkillC.dmgRaw;
			_dmgRatio = fSkillC.dmgRatio;
			_hitMultHash = fSkillC.hitMultHash;
			aODmg = fSkillC.getAODmg();
			aODmgRatio = fSkillC.getAODmgRatio();
			aODmgRangeMin = fSkillC.getAODmgRangeMin();
			aODmgReduction = fSkillC.getAODmgReduction();
			aOShieldDmg = fSkillC.getAOShieldDmg();
			aOFocusDmg = fSkillC.getAOFocusDmg();
			aOLifeStealOn = fSkillC.getAOLifeStealOn();
			
			dmgFormType = fSkillC.getDmgFormType();
			aOHPCurrent = fSkillC.getAOHPCurrent();
			aOHPMax = fSkillC.getAOHPMax();
			aOHitMax = fSkillC.getAOHitMax();
			duration = fSkillC.getDuration();
			attackFreq = fSkillC.getAttackFreq();
			accu = fSkillC.getAccu();
			dmgType = fSkillC.getDmgType();//"happy", "sad", "psycho"
			aOPriority = fSkillC.getAOPriority();
			attackFreezeDuration = fSkillC.getAttackFreezeDuration();
			stun = fSkillC.getStun();
			stunReduction = fSkillC.getStunReduction();
			disable = fSkillC.getDisable();
			blockStun = fSkillC.getBlockStun();
			_kBHash = fSkillC.kBHash();
			_kBFreeFall = fSkillC.kBFreeFall();
			kBComboMod = fSkillC.getKBComboMod();
			kBMoveEqualOn = fSkillC.getKBMoveEqualOn();
			kDOn = fSkillC.getKDOn();
			kDHitOn = fSkillC.getKDHitOn();
			kDTime = fSkillC.getKDTime();
			kUOn = fSkillC.getKUOn();
			kUVel = fSkillC.getKUVel();
			kUForceSpeedChangeOn = fSkillC.getKUForceSpeedChangeOn();
			kUForceBounceOn = fSkillC.getKUForceBounceOn();
//			kUXSpeedAngleOn = fSkillC.getKUXSpeedAngleOn();
			kUComboMod = fSkillC.getKUComboMod();
			kUAirRecDuration = fSkillC.getKUAirRecDuration();
			
			aOPlayerStick = fSkillC.getAOPlayerStick();
			aOPlayerStickZ = fSkillC.getAOPlayerStickZ();
			aOSpeedArray = fSkillC.getAOSpeedArray();
			aOZSpeedArray = fSkillC.getAOZSpeedArray();
			aOSpeedFunc = fSkillC.getAOSpeedFunc();
			aOMovementFacingOn = fSkillC.getAOMovementFacingOn();
			aOHomingArray = fSkillC.getAOHomingArray();
			aODispOrigin = fSkillC.getAODispOrigin();
			aOXDisplacement = fSkillC.getAOXDisplacement();
			aOYDisplacement = fSkillC.getAOYDisplacement();
			aOZDisplacement = fSkillC.getAOZDisplacement();
			aOScaleX = fSkillC.getAOScaleX();
			aOScaleY = fSkillC.getAOScaleY();
			aOWidth = fSkillC.getAOWidth();
			aOHeight = fSkillC.getAOHeight();
			aOZ = fSkillC.getAOZ();
			aOZDispPlayerReferenceOn = fSkillC.getAOZDispPlayerReferenceOn();
			aOLandingDeathOn = fSkillC.getAOLandingDeathOn();
			
			interruptOn = fSkillC.getInterruptOn();
			unblockableOn = fSkillC.getUnblockableOn();
			unblockableType = fSkillC.getUnblockableType();

			startSkillCastFunc = fSkillC.getStartSkillCastFunc();
			endSkillCastFunc = fSkillC.getEndSkillCastFunc();
			startSkillActivateFunc = fSkillC.getStartSkillActivateFunc();
			endSkillActivateFunc = fSkillC.getEndSkillActivateFunc();
			startStanceEffectFunc = fSkillC.getStartStanceEffectFunc();
			endStanceEffectFunc = fSkillC.getEndStanceEffectFunc();
			startAOEffectFunc = fSkillC.getStartAOEffectFunc();
			endAOEffectFunc = fSkillC.getEndAOEffectFunc();
			startAOConstEffectFunc = fSkillC.getStartAOConstEffectFunc();
			endAOConstEffectFunc = fSkillC.getEndAOConstEffectFunc();
			
			req = fSkillC.getReq();
			reqSkills = fSkillC.getReqSkills();
			
			playerCastAniArray = fSkillC.getPlayerCastAniArray();
			playerActivateAniArray = fSkillC.getPlayerActivateAniArray();
			aOUpsideDownOn = fSkillC.getAOUpsideDownOn();
			aOAniArray = fSkillC.getAOAniArray();
			dmgFXArray = fSkillC.getDmgFXArray();
			soundArray = fSkillC.getSoundArray();
			echoSoundArray = fSkillC.getEchoSoundArray();
			aOSoundArray = fSkillC.getAOSoundArray();
			aOEchoSoundArray = fSkillC.getAOEchoSoundArray();
			
			endOnHit = fSkillC.getEndOnHit();
			endOnHitSkillName = fSkillC.getEndOnHitSkillName();
			
			counterAttackCOn = fSkillC.getCounterAttackCOn();
			counterAttackAOn = fSkillC.getCounterAttackAOn();
			counterAttackSkillName = fSkillC.getCounterAttackSkillName();
			counterAttackMissC = fSkillC.getCounterAttackMissC();
			counterAttackMissA = fSkillC.getCounterAttackMissA();
			
			landingSkillName = fSkillC.getLandingSkillName();
			
			chainSkillNameArray = fSkillC.getChainSkillNameArray();
			
			aOTransformTypeArray = fSkillC.getAOTransformTypeArray();
			aOTransformSkillNameArray = fSkillC.getAOTransformSkillNameArray();
			
			skillTempArray = fSkillC.getSkillTempArray();
			stanceSkillArray = fSkillC.getStanceSkillArray();
			
			skillDescription = fSkillC.getSkillDescription();

		}
	}
}