﻿package {
	import flash.utils.Timer;
	import flash.utils.getTimer;
	import flash.events.*;
	import flash.display.*;
	
	public class TimedEffect extends MovieClip{
		private var effectDuration:int;
		private var lastTimeEffect:uint;
		private var startFunc:Function;
		private var endFunc:Function;
		private var gameTimeFunc:Function;
		private var _effectOn = false;
		private var storeArray:Array = null;
		public function TimedEffect(pStartFunc:Function, pEndFunc:Function, pEffectDuration:int, pGameTimeFunc:Function=null, pStoreArray:Array=null){
			effectDuration = pEffectDuration;
			startFunc = pStartFunc;
			endFunc = pEndFunc;
			gameTimeFunc = pGameTimeFunc;
			if(!Boolean(gameTimeFunc)){
				gameTimeFunc = getTimer;
			}
			storeArray = pStoreArray;
			if(storeArray is Array){
				storeArray.push(this);
			}
		}
		public function start(){
			startFunc();
			if(effectDuration!=0){
				_effectOn = true;
				lastTimeEffect = gameTimeFunc();
				addEventListener(Event.ENTER_FRAME, effectTimer);
			}
			else{
				end();
			}
		}
		private function effectTimer(e:Event){
			var fTimePassed:uint = gameTimeFunc()-lastTimeEffect;
			if(fTimePassed >= effectDuration){
				end();
			}
		}
		public function get effectOn():Boolean{
			return _effectOn;
		}
		public function end(){
			_effectOn = false;
			endFunc();
			if(effectDuration!=0){
				removeEventListener(Event.ENTER_FRAME, effectTimer);
			}
			if(Boolean(this.parent)){
				this.parent.removeChild(this);
			}
			if(storeArray!=null){
				storeArray.splice(storeArray.indexOf(this),1);
			}
			delete this;
		}
		public function forceEnd(){//End without calling endFunc()
			_effectOn = false;
			if(effectDuration!=0){
				removeEventListener(Event.ENTER_FRAME, effectTimer);
			}
			if(Boolean(this.parent)){
				this.parent.removeChild(this);
			}
			if(storeArray!=null){
				storeArray.splice(storeArray.indexOf(this),1);
			}
			delete this;
		}
		public function setEffectDuration(u:uint){
			effectDuration = u;
		}
	}
}